2008-12-11  Dan Williams  <dcbw@redhat.com>

	* Move NetworkManager to git.freedesktop.org
		- git clone git://git.freedesktop.org/git/NetworkManager/NetworkManager.git

2008-12-09  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Add 'never-default' property, which when true indicates that a
			connection should never be the default connection

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- (nm_ip4_config_get_never_default, nm_ip4_config_set_never_default):
			Add never-default helpers

	* src/NetworkManagerUtils.c
		- (nm_utils_merge_ip4_config): update never-default when merging the
			IP4 setting to the IP4 config

	* src/NetworkManagerSystem.c
		- (nm_system_apply_ip4_config): if the connection is never-default,
			don't add routes without a gateway

	* src/NetworkManagerPolicy.c
		- (get_best_device): don't let never-default connections be the best
		- (update_routing_and_dns): handle never-default for VPN connections

	* system-settings/plugins/ifcfg-rh/reader.c
		- (make_ip4_setting): handle never-default by checking GATEWAYDEV

2008-12-08  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-connection.c
		- (plugin_state_changed): clear secrets before setting the connection
			state to FAILED, since doing so may destroy the connection itself,
			since the NMVPNService owning this NMVPNConnection will unref it
			when the NMVPNConnection is failed or stopped

2008-12-05  Dan Williams  <dcbw@redhat.com>

	Patch from Michael Biebl  <mbiebl@gmail.com>

	* libnm-glib/Makefile.am
		- Bump libnm-glib revision to indicate new API
		- Give libnm-util version info

	* libnm-util/Makefile.am
		- Bump libnm-util soname to indicate API/ABI break with 0.6

2008-11-26  Dan Williams  <dcbw@redhat.com>

	* Release NetworkManager 0.7

2008-11-26  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
		- (nm_exported_connection_delete): rename 'delete' to 'do_delete' to
			avoid using C++ reserved keywords in headers

	* libnm-glib/nm-dbus-connection.c
	  system-settings/plugins/ifcfg-rh/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-suse/nm-suse-connection.c
	  system-settings/plugins/ifupdown/nm-ifupdown-connection.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/src/nm-sysconfig-connection.c
		- Change 'delete' to 'do_delete'

2008-11-25  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-rh
		- Rename 'ifcfg-fedora' to 'ifcfg-rh'; it's not just used on Fedora

	* system-settings/src/main.c
		- (load_plugins): transparently handle ifcfg-fedora as ifcfg-rh

2008-11-25  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	Fix mishandling of netlink error floods (rh #459205, novell #443429, lp #284507)

	* src/nm-netlink-monitor.c
		- Remove bits for using a non-default GMainContext, which weren't used
		- (nm_netlink_monitor_error_handler): don't leak the GError, and report
			the actual error code

	* src/NetworkManager.c
		- (nm_error_monitoring_device_link_state): disconnect error handler when
			an error flood occurs to avoid pegging the CPU

2008-11-23  Dan Williams  <dcbw@redhat.com>

	* callouts/nm-dispatcher-action.c
		- (construct_envp, nm_dispatcher_action): pass connection UUID to
			scripts in the environment

2008-11-21  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo  <tambet@gmail.com>

	* configure.in
	  libnm-util/libnm-util.ver
	  libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-8021x.h
		- Add configure-time option for the system CA path
		- Add 'system-ca-certs' option to 802.1x setting, which directs
			NetworkManager to use system CA certificates instead of any
			connection-defined CA certificates

	* src/supplicant-manager/nm-supplicant-config.c
	  src/supplicant-manager/nm-supplicant-settings-verify.c
		- Use system CA certificates if the connection says to do so

2008-11-21  Dan Williams  <dcbw@redhat.com>

	* src/nm-dbus-manager.c
	  src/nm-dbus-manager.h
		- (nm_dbus_manager_get_name_owner): return error

	* src/nm-manager.c
		- (impl_manager_activate_connection): perform additional validation on
			ActivateConnection calls of user connections
		- (is_user_request_authorized): ensure that the requestor is the same
			UID as the UID that owns the user settings service; users shouldn't
			be able to control another user's connections

2008-11-21  Dan Williams  <dcbw@redhat.com>

	* gfilemonitor/inotify-sub.c
		- (dup_dirname): actually remove trailing '/' (bgo #561807)

2008-11-21  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/parser.c (read_wpa_eap_settings): Make suse
	plugin compile again.

2008-11-20  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
		- (NMSettingValueIterFn): instead of just a gboolean for secrets, take
			all the GParamSpec flags of the property

	* system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/plugins/keyfile/reader.c
	  system-settings/plugins/keyfile/writer.c
		- Update for NMSettingValueIterFn change

2008-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- More documentation updates

2008-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
	  libnm-util/nm-utils-private.h
	  libnm-util/nm-connection.c
		- (nm_utils_register_value_transformations): make private, called
			from NMConnection registration anyway

2008-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/Makefile.am
	  libnm-util/nm-utils-private.h
		- New header for internal utils private functions

	* libnm-util/libnm-util.ver
	  libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- Document some functions
		- (nm_utils_string_in_list, nm_utils_string_list_contains,
		   nm_utils_string_slist_validate): un-export, only used within
			libnm-util or of limited use in general, and very easy to
			re-implement by apps if needed

	* libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-wired.c
	  libnm-util/nm-setting-wireless-security.c
	  libnm-util/nm-setting-wireless.c
		- Update for private nm_utils_string_* functions

2008-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
		- Add NMSetting errors
		- (nm_setting_update_secrets): return errors

	* libnm-util/nm-connection.c
	  libnm-util/nm-connection.h
		- (nm_connection_update_secrets): return errors

	* libnm-util/nm-setting-vpn.c
	  src/nm-activation-request.c
	  src/vpn-manager/nm-vpn-connection.c
		- Handle update secrets errors

2008-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
	  libnm-util/libnm-util.ver
		- (nm_setting_new_from_hash): rename from nm_setting_from_hash() to be
			consistent with nm_connection_new_from_hash()

	* src/nm-activation-request.c
	  libnm-util/nm-connection.c
		- Handle rename

2008-11-19  Dan Williams  <dcbw@redhat.com>

	* configure.in
	  Makefile.am
	  docs/libnm-util/Makefile.am
	  docs/libnm-util/libnm-util.types
		- Start to document libnm-util

2008-11-19  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.h
	  libnm-util/nm-connection.c
		- Document public functions

2008-11-19  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.h
	  libnm-util/nm-setting.c
	  src/nm-device.c
	  src/nm-manager.c
	  system-settings/plugins/ifcfg-fedora/plugin.c
		- Prefix compare flag defines with NM_SETTING_

2008-11-19  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.c
	  libnm-util/nm-connection.h
		- (nm_connection_replace_settings): take a GError

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-dbus-connection.c
	  src/nm-manager.c
	  system-settings/plugins/ifcfg-suse/nm-suse-connection.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/plugins/keyfile/plugin.c
		- Handle, or don't handle, errors from nm_connection_replace_settings()

2008-11-19  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-connection.c
		- (nm_setting_register, nm_setting_unregister): unexport; they are
			private and don't have a use outside libnm-util

2008-11-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-hso-gsm-device.c
		- (real_connection_secrets_updated): handle PIN/PUK correctly for HSO
			devices

2008-11-17  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (read_mac_address): clean up
		- (make_wireless_setting): pass NULL array to read_mac_address() like it
			expects

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (read_one_connection): don't segfault on NULL errors

2008-11-14  Dan Williams  <dcbw@redhat.com>

	* Tag 0.7.0-rc2

2008-11-14  Dan Williams  <dcbw@redhat.com>

	Handle gateways on different subnets

	* src/NetworkManagerSystem.c
		- (add_ip4_route_to_gateway): gateway route should be link scope and
			a host route
		- (replace_default_ip4_route): use a destination address too; gateway
			address should be /0; don't leak the gateway route object

2008-11-14  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/libnm_glib.ver
	  libnm-glib/nm-dbus-settings-system.c
	  libnm-glib/nm-dbus-settings-system.h
		- Add libnm-glib bits for CanModify

2008-11-14  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-settings-system.xml
	  system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- Add a "CanModify" property to indicate if any plugins support
			connection modification

2008-11-14  Dan Williams  <dcbw@redhat.com>

	Relicense libnm-glib to LGPLv2+ with agreement from contributors

2008-11-14  Dan Williams  <dcbw@redhat.com>

	* vpn-manager/nm-vpn-connection.c
		- (plugin_state_changed): clear VPN secrets on error to ensure they
			are always requested from the settings service (rh #429287)

2008-11-13  Dan Williams  <dcbw@redhat.com>

	* libnm-util/crypto.c
		- (crypto_get_private_key_data): fix bad initial arg type checking
			from pkcs#12 patch

2008-11-13  Dan Williams  <dcbw@redhat.com>

	Add support for PKCS#12 private keys (bgo #558982)

	* libnm-util/crypto.c
	  libnm-util/crypto.h
		- (parse_old_openssl_key_file): rename from parse_key_file(); adapt to
			take a GByteArray instead of a filename
		- (file_to_g_byte_array): handle private key files too
		- (decrypt_key): take a GByteArray rather than data + len
		- (crypto_get_private_key_data): refactor crypto_get_private_key() into
			one function that takes a filename, and one that takes raw data;
			detect pkcs#12 files as well
		- (crypto_load_and_verify_certificate): detect file type
		- (crypto_is_pkcs12_data, crypto_is_pkcs12_file): add pkcs#12 detection
			functions

	* libnm-util/crypto_gnutls.c
		- (crypto_decrypt): take GByteArray rather than data + len; fix a bug
			whereby tail padding was incorrectly handled, leading to erroneous
			successes when trying to decrypt the data
		- (crypto_verify_cert): rework somewhat
		- (crypto_verify_pkcs12): validate pkcs#12 keys

	* libnm-util/crypto_nss.c
		- (crypto_init): enable various pkcs#12 ciphers
		- (crypto_decrypt): take a GByteArray rather than data + len
		- (crypto_verify_cert): clean up
		- (crypto_verify_pkcs12): validate pkcs#12 keys

	* libnm-util/test-crypto.c
		- Handle pkcs#12 keys

	* libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-8021x.h
	  libnm-util/libnm-util.ver
		- Add two new properties, 'private-key-password' and
			'phase2-private-key-password', to be used in conjunction with
			pkcs#12 keys
		- (nm_setting_802_1x_set_ca_cert_from_file,
		   nm_setting_802_1x_set_client_cert_from_file,
		   nm_setting_802_1x_set_phase2_ca_cert_from_file,
		   nm_setting_802_1x_set_phase2_client_from_file): return certificate
			type
		- (nm_setting_802_1x_get_private_key_password,
		   nm_setting_802_1x_get_phase2_private_key_password): return private
			key passwords
		- (nm_setting_802_1x_set_private_key_from_file,
		   nm_setting_802_1x_set_phase2_private_key_from_file): set the private
			key from a file, and update the private key password at the same time
		- (nm_setting_802_1x_get_private_key_type,
		   nm_setting_802_1x_get_phase2_private_key_type): return the private
			key type

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Whitelist private key passwords

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_8021x): for pkcs#12 private keys,
			add the private key password to the supplicant config, but do not
			add the client certificate (as required by wpa_supplicant)

2008-11-12  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/keyfile/nm-keyfile-connection.c (copy_one_secret)
	(add_secrets): Don't add empty secrets to the secrets hash table.

2008-11-07  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless.c
		- (nm_setting_wireless_get_seen_bssid): fix bug from accessor conversion
			that cased this function to return garbage, breaking hidden AP
			detection

2008-11-07  Dan Williams  <dcbw@redhat.com>

	Fix deletion of VPN gateway route on DHCP renew (bgo #558133)

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_set_ip4_route): return the route that was added
		- (nm_system_add_ip4_vpn_gateway_route): make add_vpn_gateway_route()
			public, clean up, and return the route that was added
		- (nm_system_apply_ip4_config): remove VPN related stuff to simplify,
			since nm_system_add_ip4_vpn_gateway_route() is now available; add
			flags to allow only certain attributes of the NMIP4Config to be
			applied

	* src/nm-device.c
		- (handle_dhcp_lease_change): don't touch the DHCP4 config on failure
		- (nm_device_set_ip4_config): use nm_ip4_config_diff() to only apply
			what's really changed between the old and new configs; don't export
			the new IP4 config on failure; always send the DNS info to the
			named manager

	* src/vpn-manager/nm-vpn-connection.c
		- (device_ip4_config_changed, nm_vpn_connection_new, dispose): track the
			parent device's IP4Config and re-add the VPN gateway route when it
			changes
		- (nm_vpn_connection_ip4_config_get): add the VPN gateway route (since
			nm_system_apply_ip4_config() no longer does) and cache it for later
		- (connection_state_changed): move cleanup code to its own function
		- (vpn_cleanup): delete any previously added VPN gateway route; and
			re-apply the parent device's addresses and routes using
			nm_system_apply_ip4_config(), not nm_device_set_ip4_config()

2008-11-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- (nm_ip4_config_diff): new function; return the difference between two
			IP4 configs
		- (nm_ip4_config_compare): change into nm_ip4_config_diff

2008-11-05  Dan Williams  <dcbw@redhat.com>

	* nm-ip4-config.c
	  nm-ip4-config.h
		- (nm_ip4_config_compare): compare two IP4 configs

2008-11-05  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_etc_hosts): only add newline if not the last line of the file
			(Jonathan Miner)

2008-11-05  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-dhclient.c
		- (get_leasefile_for_iface): move lease files back to where dhclient
			puts them

2008-11-05  Michael Biebl  <mbiebl@gmail.com>

	* initscripts/Debian/NetworkManager
		- Update to what Debian is actually using

2008-11-05  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-setting-8021x.c: Verify PEAP settings as well.

2008-11-03  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/main.c
		- (add_default_dhcp_connection): make the fallback connection read-only

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
		- Add detailed errors
		- (impl_exported_connection_update, impl_exported_connection_delete):
			return an error if the connection is read-only

	* system-settings/plugins/ifupdown/nm-ifupdown-connection.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/src/main.c
		- Use more detailed errors

	* system-settings/src/nm-system-config-error.c
	  system-settings/src/nm-system-config-error.h
	  system-settings/src/dbus-settings.c
		- Remove NM_SYSCONFIG_SETTINGS_ERROR_INVALID_CONNECTION, replaced by
			NM_SETTINGS_ERROR_INVALID_CONNECTION

2008-11-02  Dan Williams  <dcbw@redhat.com>

	* Add license headers to everything in src/

2008-11-02  Dan Williams  <dcbw@redhat.com>

	* Tag 0.7.0-rc1

2008-11-02  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
		- (nm_ap_new_fake_from_connection): treat only lack of a wireless security
			setting as unencrypted; fixes a bug where NM wouldn't ask for new
			secrets when connecting to an encrypted network failed

2008-10-30  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-ip6-config.c
	  libnm-util/nm-setting-ip6-config.h
	  libnm-util/Makefile.am
		- Make properties private and add accessor functions
		- Hide IPv6 stuff from public API, it's incomplete and completely unused

	* libnm-util/nm-connection.c
	  libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- Ignore IPv6 stuff for now

2008-10-30  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-8021x.h
		- Make properties private and add accessor functions

	* src/supplicant-manager/nm-supplicant-config.c
	  system-settings/plugins/ifcfg-suse/parser.c
		- Use 802.1x setting accessors

2008-10-30  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-wireless-security.c
	  libnm-util/nm-setting-wireless-security.h
		- Make properties private and add accessor functions

	* libnm-util/nm-setting-wireless.c
	  src/NetworkManagerAP.c
	  src/nm-device-wifi.c
	  src/supplicant-manager/nm-supplicant-config.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
		- Use wireless security accessors

2008-10-30  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-ethernet.c
	  src/nm-device-wifi.c
	  src/nm-device.c
	  src/ppp-manager/nm-ppp-manager.c
		- Harmonize return checking of ioctl

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (is_wireless_device): fall back to SIOCGIWNAME (rh #466340)

2008-10-30  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (nm_ppp_manager_start): if /dev/ppp doesn't exist, load the
			ppp_generic module to create it (bgo #533064)

2008-10-30  Dan Williams  <dcbw@redhat.com>

	Patch from Alexander Sack <asac@canonical.com>

	Fix "ppp connections don't honour ip4 connection settings"

	* src/nm-device-ethernet.c
		- (real_act_stage4_get_ip4_config): merge ip4config settings
			with results from ppp manager

	* src/nm-serial-device.c
		- (real_act_stage4_get_ip4_config): merge ip4config settings
			with results from ppp manager

2008-10-29  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Make properties private and add accessor functions

	* callouts/nm-dispatcher-action.c
	  libnm-glib/libnm-glib-test.c
	  libnm-util/nm-utils.c
	  src/NetworkManagerPolicy.c
	  src/NetworkManagerSystem.c
	  src/NetworkManagerUtils.c
	  src/dhcp-manager/nm-dhcp-dhclient.c
	  src/dhcp-manager/nm-dhcp-manager.c
	  src/dnsmasq-manager/nm-dnsmasq-manager.c
	  src/nm-device-wifi.c
	  src/nm-device.c
	  src/nm-hso-gsm-device.c
	  src/nm-ip4-config.c
	  src/nm-ip4-config.h
	  src/ppp-manager/nm-ppp-manager.c
	  src/vpn-manager/nm-vpn-connection.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/plugins/ifcfg-suse/plugin.c
	  system-settings/plugins/ifupdown/parser.c
	  test/nm-tool.c
	  vpn-daemons/vpnc/properties/nm-vpnc.c
		- Use IP4 accessor functions

2008-10-29  Tambet Ingo  <tambet@gmail.com>

	Half of it by Dan Williams <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	libnm-util/nm-setting-vpn.c
	libnm-util/nm-setting-vpn.h
		- Make properties private and add accessor functions.

	* src/vpn-manager/nm-vpn-connection.c
	src/vpn-manager/nm-vpn-manager.c
	system-settings/plugins/keyfile/reader.c
	vpn-daemons/openvpn/properties/auth-helpers.c
	vpn-daemons/openvpn/properties/import-export.c
	vpn-daemons/openvpn/properties/nm-openvpn.c
	vpn-daemons/openvpn/src/nm-openvpn-service.c
	vpn-daemons/pptp/auth-dialog/main.c
	vpn-daemons/pptp/properties/advanced-dialog.c
	vpn-daemons/pptp/properties/nm-pptp.c
	vpn-daemons/pptp/src/nm-pptp-service.c
	vpn-daemons/vpnc/properties/nm-vpnc.c
	vpn-daemons/vpnc/src/nm-vpnc-service.c
		- Use VPN setting accessors.

2008-10-28  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-wireless.c
	  libnm-util/nm-setting-wireless.h
		- Make properties private and add accessor functions

	* src/NetworkManagerAP.c
	  src/nm-device-wifi.c
	  src/nm-manager.c
	  src/supplicant-manager/nm-supplicant-config.c
	  system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/plugins/ifupdown/parser.c
		- Use wireless setting accessors

2008-10-27  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-ppp.h
		- Make properties private and add accessor functions

	* src/ppp-manager/nm-ppp-manager.c
		- Use ppp setting accessors

2008-10-27  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/nm-setting.h
	  libnm-util/nm-setting.c
		- Make properties private and add accessor functions

	* libnm-util/nm-connection.c
	  libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-cdma.c
	  libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-gsm.c
	  libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip6-config.c
	  libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-pppoe.c
	  libnm-util/nm-setting-serial.c
	  libnm-util/nm-setting-template.c
	  libnm-util/nm-setting-vpn.c
	  libnm-util/nm-setting-wired.c
	  libnm-util/nm-setting-wireless-security.c
	  libnm-util/nm-setting-wireless.c
	  system-settings/plugins/keyfile/reader.c
	  system-settings/plugins/keyfile/writer.c
		- Use setting accessors

2008-10-27  Dan Williams  <dcbw@redhat.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-connection.h
		- Add a 'read-only' property that indicates the connection cannot be
			modified

	* system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/plugins/ifupdown/parser.c
		- These plugins are read-only at the moment

	* system-settings/plugins/keyfile/reader.c
	  system-settings/plugins/keyfile/writer.c
		- Read-only shouldn't get saved out to files or read in from them

2008-10-27  Tambet Ingo  <tambet@gmail.com>

	* src/nm-device-ethernet.c (nm_device_ethernet_get_speed): Implement
	correct speed reporting for fast devices (kernel >= 2.6.27).

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Attempt to compensate for modems that don't enable full AT parsing before
	the PIN has been entered.

	* src/nm-gsm-device.c
		- (init_modem): accept different init strings
		- (init_done): try different init strings on failure
		- (check_pin_done): on PIN success, do full modem init

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-connection.h
		- Make properties private and add accessor functions

	* src/NetworkManagerPolicy.c
	  src/nm-cdma-device.c
	  src/nm-device-ethernet.c
	  src/nm-device-interface.c
	  src/nm-device-wifi.c
	  src/nm-gsm-device.c
	  src/nm-manager.c
	  src/ppp-manager/nm-ppp-manager.c
	  src/vpn-manager/nm-vpn-connection.c
	  system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-fedora/plugin.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/plugins/ifupdown/parser.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/plugins/keyfile/plugin.c
	  system-settings/plugins/keyfile/writer.c
	  system-settings/src/main.c
		- Use those accessors

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-gsm.c
	  libnm-util/nm-setting-gsm.h
		- Make properties private and add accessor functions

	* src/nm-gsm-device.c
	  src/nm-hso-gsm-device.c
	  src/ppp-manager/nm-ppp-manager.c
		- Use those accessors

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-cdma.c
	  libnm-util/nm-setting-cdma.h
		- Make properties private and add accessor functions

	* src/nm-cdma-device.c
	  src/ppp-manager/nm-ppp-manager.c
		- Use those accessors

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-pppoe.c
	  libnm-util/nm-setting-pppoe.h
		- Make properties private and add accessor functions

	* src/nm-device-ethernet.c
	  src/ppp-manager/nm-ppp-manager.c
		- Use those accessors

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-wired.c
	  libnm-util/nm-setting-wired.h
		- Make properties private and add accessor functions

	* src/nm-device-ethernet.c
	  system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/src/main.c
		- Use those accessors

2008-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/libnm-util.ver
	  libnm-util/nm-setting-serial.c
	  libnm-util/nm-setting-serial.h
	  src/nm-serial-device.c
		- Make properties private and use accessors instead

2008-10-26  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-interface.c
	  src/supplicant-manager/nm-supplicant-interface.h
	  src/supplicant-manager/nm-supplicant-manager.c
	  src/supplicant-manager/nm-supplicant-manager.h
		- Add state-to-string conversion functions

	* src/nm-device-wifi.c
	  src/nm-device-ethernet.c
		- Normalize state info logging and use strings instead of numbers

2008-10-26  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): ignore host routes when determining whether
			a VPN connection should own the default route (bgo #552594)

2008-10-24  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (set_apn): remove erroneous spaces in AT+CGDCONT command (Jerone Young)

2008-10-23  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (create_pppd_cmd_line): pppd always parses /etc/ppp/options, so always
			add really important stuff to the command line to ensure that NM
			overrides /etc/ppp/options (bgo #556781)

2008-10-22  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
	  src/nm-device.c
		- Use the device's IP interface where appropriate (Per Hallsmark)

2008-10-22  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (schedule_automatic_registration_again): use a short timeout here
			instead of an idle handler to avoid using too much CPU polling for
			something we should be waiting a bit for anyway

2008-10-22  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
	  introspection/nm-device.xml
		- Add device state change reason for carrier changes

	* src/nm-device-ethernet.c
		- (set_carrier): use the carrier change reason when changing device
			state in response to carrier changes

2008-10-21  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_etc_hosts): don't leak errors, and ensure that
			g_file_set_contents() gets a valid error placeholder (rh #461933)

2008-10-21  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (free_get_settings_info): don't use the DBusGProxy which could be
			disposed of by the time the function is called
		- (internal_new_connection_cb): save connection scope
		- (connection_get_settings_cb): don't replace a connection unless it's
			actually different from the existing one; fixes an issue where
			killing the settings service wouldn't deactivate an active connection
			provided by that settings service, because it was using a connection
			that had already been replaced in the system or user hash

2008-10-21  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManager.c
		- (main): keep the DHCP manager around since it's a singleton; fixes
			a use-after-free exposed by r4196 since the DHCP manager singleton
			variable isn't cleared when the DHCP manager object is finalized

2008-10-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless-security.c
		- (verify): accept 'none' as a pairwise cipher with Ad-Hoc WPA connections

2008-10-20  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (ADD_STRING_LIST_VAL): don't add empty values to the supplicant config

2008-10-20  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get): fix mismatched refcount; creating the dhcp
			manager object already refs it once
		- (nm_dhcp_manager_cancel_transaction_real): clear freed variables that
			also get cleaned up by nm_dhcp_device_destroy() to prevent
			double-frees

2008-10-20  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (initial_get_connections): use private dbus manager, don't keep
			ref-ing the singleton.  Fixes mismatched refcounts of the dbus
			manager object.

2008-10-18  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
		- Rename the "get_secrets" virtual function "service_get_secrets" to
			clarify when it's used; NMExportedConnetion is a base-class for both
			the client and service side, which is sort of confusing, and
			get_secrets only makes sense on the service side.

	* libnm-glib/nm-dbus-connection.c
		- (get_secrets): remove, unused, and clients need to do extra work to
			get secrets anyway since the call can block on the remote side

	* system-settings/plugins/ifupdown/nm-ifupdown-connection.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
		- Fix up for get_secrets -> service_get_secrets

2008-10-16  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- (constructor): correctly determine encryption capabilities

2008-10-15  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- (wireless_qual_to_percent): fix quality calculation in a fallback case
			(Johannes Berg)

2008-10-15  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
		- (ip4_dest_in_same_subnet): tighter checks on subnet matching,
			if the ip4_dest is in a smaller subnet contained within a subnet
			the machine is currently on, the destination is in the same subnet
		- (nm_system_device_set_ip4_route): move subnet checks to callers
		- (add_vpn_gateway_route): check if the VPN gateway is in the same
			subnet as the parent device, and if so, don't add the direct
			host route via the parent device's gateway (bgo #481620)
		- (nm_system_apply_ip4_config): check whether the route to be added
			is contained within a subnet the device is already on

2008-10-11  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
	  introspection/nm-device.xml
	  include/NetworkManagerVPN.h
		- Add a few more state reasons for the device deactivated state

	* src/nm-device-interface.c
	  src/nm-device-interface.h
		- (nm_device_interface_deactivate): add a 'reason' argument

	* src/nm-device.c
	  src/nm-device.h
		- (nm_device_deactivate, nm_device_take_down): add a 'reason' argument
		- (nm_device_state_changed): pass the state change reason to
			nm_device_take_down()
		- (nm_device_set_managed): take a 'reason' argument, and pass it along
			to the state change function

	* src/nm-manager.c
	  src/nm-manager.h
		- (remove_one_device, handle_unmanaged_devices, sync_devices,
		   impl_manager_sleep): pass a reason code to nm_device_set_managed()
		- (nm_manager_deactivate_connection): add a 'reason' argument and pass
			something reasonable along to VPN deactivation

	* src/vpn-manager/nm-vpn-manager.c
	  src/vpn-manager/nm-vpn-manager.h
		- (nm_vpn_manager_deactivate_connection): add a 'reason' argument and
			pass that along to nm_vpn_connection_disconnect()

2008-10-11  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- (can_scan): remove old madwifi hack for not scanning while connected

2008-10-11  Dan Williams  <dcbw@redhat.com>

	Add support for VPN subnet gateways (bgo #549196)

	* include/NetworkManager.h
		- Add key for internal VPN subnet gateway

	* src/vpn-manager/nm-vpn-connection.c
		- (ip_address_to_string): return a const from a static buffer so we
			don't leak a lot of strings
		- (print_vpn_config): print internal VPN gateway as well
		- (nm_vpn_connection_ip4_config_get): grab internal VPN gateway from
			VPN service too
		- (nm_vpn_connection_get_ip4_internal_gateway): new function

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_replace_default_ip4_route): split into two, one for
			VPN connections and one for normal devices
		- (replace_default_ip4_route): break out route stuff into its own function
		- (nm_system_replace_default_ip4_route_vpn,
		   nm_system_replace_default_ip4_route): simplify by having two cases,
			one for VPNs and one for normal devices

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): simplify, use split default route replacement
			functions

2008-10-10  Dan Williams  <dcbw@redhat.com>

	Rework default route handling to consolidate decisions in the policy,
	and to take active VPN connections into account when changing the default
	route (bgo #545912)

	* src/NetworkManager.c
		- (main): pass the vpn_manager to the policy so it knows about active
			VPN connections; clean up the named manager which wasn't done before

	* src/NetworkManagerPolicy.c
	  src/NetworkManagerPolicy.h
		- (nm_policy_new): get a clue about the vpn_manager
		- (update_default_route): remove, fold into update_routing_and_dns()
		- (update_routing_and_dns): handle active VPN connections too; an
			active VPN connection becomes the default route if it does not have
			server-specified or user-specified custom routes.  Otherwise, the
			best active device gets the default route
		- (vpn_connection_activated, vpn_connection_deactivated, nm_policy_new,
		   nm_policy_destroy): track VPN connection activation and deactivation
			and update the default route when appropriate

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_vpn_device_unset_from_ip4_config): remove, put functionality
			in the VPN connection itself
		- (nm_system_vpn_device_set_from_ip4_config,
		   nm_system_device_set_from_ip4_config): merge together to make
			nm_system_apply_ip4_config()
		- (add_vpn_gateway_route): add a route to the VPN's external gateway
			via the parent device
		- (nm_system_apply_ip4_config): simplify
		- (add_ip4_route_to_gateway): new function; add a direct route to the
			gateway if needed
		- (nm_system_device_replace_default_ip4_route): simplify, break gateway
			route stuff out into add_ip4_route_to_gateway() for clarity

	* src/nm-device.c
		- (nm_device_set_ip4_config): update for nm_system_apply_ip4_config()

	* src/vpn-manager/nm-vpn-connection.c
	  src/vpn-manager/nm-vpn-connection.h
		- (nm_vpn_connection_get_ip4_config, nm_vpn_connection_get_ip_iface,
		   nm_vpn_connection_get_parent_device): add
		- (nm_vpn_connection_ip4_config_get): make the requirement of a tunnel
			device explicit
		- (connection_state_changed): update the named manager now that
			nm_system_vpn_device_unset_from_ip4_config() is gone; do something
			useful on errors

	* src/vpn-manager/nm-vpn-manager.c
	  src/vpn-manager/nm-vpn-manager.h
		- Add a 'connection-activated' signal
		- (nm_vpn_manager_get_active_connections): new function; mainly for the
			policy to find out about active VPN connections

2008-10-10  Tambet Ingo  <tambet@gmail.com>

	* src/nm-logging.c (nm_logging_setup): Don't use LOG_CONS when running as
	a daemon to prevent NM logging spew on console on startup and shutdown (due
	to dependency loop between NM and syslog).

2008-10-10  Alexander Sack  <asac@ubuntu.com>

	Implement managed mode. We bind devices configured in /etc/network/interfaces
	to their connections by updating wired/wireless setting with the
	mac address of the device.

	* system-settings/plugins/ifupdown/plugin.c
		- (get_net_address_for_udi): implement function to retrieve MAC
			address of udi from hal in GByteArray format
		- (bind_device_to_connection): bind mac address of device to
			wired/wireless system connection
		- (hal_device_added_cb): call bind_device_to_connection for
			system connections with a matching interface.name
		- (hal_device_added_cb): ensure that all code paths
			properly free the "iface" string.

2008-10-10  Alexander Sack  <asac@ubuntu.com>

	Parse nm-system-settings.conf and allow admins to either use managed and unmanaged
	mode of the ifupdown system config plugin.

	* system-settings/plugins/ifupdown/plugin.c
		- (SCPluginIfupdown_init): parse nm-system-settings.conf keyfile and set
			private unmanage_well_known state field accordingly

2008-10-10  Alexander Sack  <asac@ubuntu.com>

	Implement unmanaged mode that will prevent all devices in the
	well_known_udis set from being touched by NetworkManager

	* system-settings/plugins/ifupdown/plugin.c
		- (typedef struct SCPluginIfupdownPrivate): add gboolean
			unmanage_well_known field used to turn on/off unmanaged
			mode
		- (hal_device_added_cb,hal_device_remove_cb): emit |unmanaged-devices-changed|
			signal when well_known_udis get added/removed
		- (SCPluginIfupdown_get_unmanaged_devices): return all well_known_udis
			if we are in unmanaged mode

2008-10-10  Alexander Sack  <asac@ubuntu.com>

	Add support to track network devices that have a configuration
	with a matching interface.name in /etc/network/interfaces

	* system-settings/plugins/ifupdown/plugin.c
		- (typedef struct SCPluginIfupdownPrivate): add hash table
			to track |well_known_udis|
		- (get_iface_for_udi): helper function to get interface.name
			for a udi
		- (hal_device_added_cb, hal_device_removed_cb): callbacks
			that add and remove devices to and from the well_known_udis
			set depending on whether their |interface.name| matches
			any interface definition in /etc/network/interfaces
		- (SCPluginIfupdown_init): connect callbacks from above with
			hal_mgr and setup well_known_udis hashtable
		- (GObject__dispose): destroy well_known_udis hashtable
		- (hal_device_added_cb2): implement wrapper callback with GFunc
			signature. user_data is supposed to be a triple (hal_mgr,
			config and devtype)
		- (SCPluginIfupdown_init): bootstrap wired and wifi devices for
			startup and call hal_device_added_cb2

2008-10-10  Alexander Sack  <asac@ubuntu.com>

	Remove implementation for not used NMSystemConfigInterface callback functions
	in ifupdown plugin

	* system-settings/plugins/ifupdown/plugin.c
		- (SCPluginIfupdown_unmanaged_devices_changed): removed
		- (SCPluginIfupdown_connection_added): removed

2008-10-08  Dan Williams  <dcbw@redhat.com>

	Add a 'hostname' dispatcher action triggered on hostname changes (bgo #552983)

	* src/NetworkManagerUtils.c
		- (nm_utils_call_dispatcher): add a 'hostname' action

	* src/NetworkManagerPolicy.c
		- (set_system_hostname): dispatch hostname changes

	* callouts/nm-dispatcher-action.c
		- (nm_dispatcher_action): handle 'hostname' actions

2008-10-08  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
		- (find_route): ref the route so it doesn't get destroyed when the cache
			is cleared
		- (nm_system_device_set_priority): unref the route here after it's done
			being used

2008-10-08  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- Turn on serial debugging when NM_SERIAL_DEBUG is set in the environment

2008-10-08  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/keyfile/nm-keyfile-connection.c (update): Update the
	connection with new settings before saving it.

2008-10-06  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- nm_ip4_config_is_exported -> nm_ip4_config_get_dbus_path

	* src/nm-device-interface.c
		- (nm_device_interface_init): make 'ip4-config' a boxed property of type
			DBUS_TYPE_G_OBJECT_PATH so that we can make it NULL when we need to
			by using '/' for the object path

	* src/nm-device.c
		- (src/nm-device.c): marshal missing/unexported ip4-config through
			dbus as '/' since dbus-glib can't handle NULL objects nor can
			dbus handle NULL object paths

2008-10-03  Alexander Sack  <asac@ubuntu.com>

	Implement system hostname support for debian/ubuntu

	* system-settings/plugins/ifupdown/plugin.c
		- (GObject__get_property): extend announced capabilities; add
			NM_SYSTEM_CONFIG_INTERFACE_CAP_MODIFY_HOSTNAME support
		- (GObject__set_property,write_system_hostname): implement
			NM_SYSTEM_CONFIG_INTERFACE_CAP_MODIFY_HOSTNAME capability.
		- (GObject__set_property, GObject__get_property, SCPluginIfupdown_init,
		   update_system_hostname, get_hostname):
			implement hostname property that watches and
			parses /etc/hostname

2008-10-03  Alexander Sack  <asac@ubuntu.com>

	* system-settings/plugins/ifcfg-fedora/nm-inotify-helper.c
	  system-settings/plugins/ifcfg-fedora/nm-inotify-helper.h
	  system-settings/plugins/ifcfg-fedora/Makefile.am
	  system-settings/src/nm-inotify-helper.c
	  system-settings/src/nm-inotify-helper.h
	  src/Makefile.am
		- Move ifcfg-fedora inotify helpers to the system settings service so
			they are available to all plugins

2008-10-03  Alexander Sack  <asac@ubuntu.com>

	Implement support for wep-tx-keyidx in ifupdown system
	config plugin.

	* system-settings/plugins/ifupdown/parser.c
		- (update_wireless_security_setting_from_if_block): introduce
			free_type_mapping func table; rename a few local
			variables to improve readability; add wpa security mapping
			for wep-tx-keyidx property
		- (string_to_gpointerint): new function used for the auto_type_mapping
			of new wep-tx-keyidx property
		- (slist_free_all): free func used for mapped slist types

2008-10-03  Alexander Sack  <asac@ubuntu.com>

	* system-settings/src/main.c:
		- (add_default_dhcp_connection, device_removed_cb): ensure the UDI is
			always used as the hash key; fixes a crash when removing wired
			devices

2008-10-02  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (enter_pin_done, enter_pin, check_pin_done, real_act_stage1_prepare):
			pass the required GSM secret along via user_data rather than keeping
			it around in the private data where it sometimes didn't get cleared
		- (real_get_ppp_name): implement using the GSM username

2008-10-02  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
	  src/ppp-manager/nm-ppp-manager.h
		- (impl_ppp_manager_need_secrets): tries secrets twice before asking
			the settings daemon for completely new ones
		- (create_pppd_cmd_line): new parameter 'ppp_name' used to set the
			local PPP peer name; allow PPP debuging by launching NM with
			the environment variable NM_PPP_DEBUG defined
		- (nm_ppp_manager_start): new parameter 'ppp_name' passed to
			create_pppd_cmd_line()

	* src/nm-serial-device.c
	  src/nm-serial-device.h
		- New 'get_ppp_name' function for subclasses to implement to return the
			local PPP peer name
		- (real_act_stage2_config): call 'get_ppp_name' function of subclasses
			and pass that name to the PPP manager

	* src/nm-device-ethernet.c
		- (pppoe_stage2_config): pass the PPPoE username to the PPP manager as
			the local peer name

	* src/nm-cdma-device.c
		- (real_get_ppp_name): implement using the CDMA username

2008-10-02  Dan Williams  <dcbw@redhat.com>

	Patch from Alexander Sack <asac ubuntu com>

	* system-settings/plugins/ifupdown/parser.c
		- Implement more graceful ip4 config parsing for cases where
		  /etc/network/interfaces omits basic ip4 settings, such as gateway etc
		  by using default values

2008-10-02  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (device_state_changed): when marking a connection invalid, clear its
			secrets too so that fresh secrets get requested the next time

2008-10-01  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/dbus-settings.c
		- (nm_sysconfig_settings_init): cache system hostname on startup as
			a fallback if no plugin provides a hostname
		- (get_property): fall back to cached hostname if no plugin provides
			a hostname

2008-10-01  Dan Williams  <dcbw@redhat.com>

	Fix setting value comparison issue that caused some settings to look the
	same when they were really different (rh #464417)

	* libnm-util/nm-param-spec-specialized.c
		- (type_is_fixed_size): return fundamental size of the fixed type too
		- (nm_gvalues_compare_collection): use the fundamental fixed type size
			in the comparison so that the _entire_ fixed type collection gets
			compared rather than just the first 'len1' bytes

2008-09-30  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (lookup_thread_worker): don't store the idle handler ID becuase the
			idle handler could have already run and freed the LookupThread
			structure

2008-09-30  Tambet Ingo  <tambet@gmail.com>

	* src/nm-device.c (nm_device_get_priority): Implement.
	(nm_device_set_ip4_config): Send the device priority to system ip4 
	config setter.

	* src/NetworkManagerSystem.c (nm_system_device_set_from_ip4_config):
	Add priority argument and if it's >= 0, set the priority of the network
	route added automatically by netlink (or kernel?).
	(nm_system_device_set_priority): Implement.

	* src/NetworkManagerPolicy.c (get_best_device): Use 
	nm_device_get_priority() instead of home-grown version. Revert the
	meaning, best priority is the lowest one.

2008-09-29  Dan Williams  <dcbw@redhat.com>

	Handle ipw3945 suspend/resume by retrying the GIWRANGE request a few times
	when it returns EAGAIN (rh #362421)

	* src/nm-device-wifi.c
		- (wireless_get_range): try GIWRANGE a few times until the card responds
		- (real_get_generic_capabilities, constructor): use wireless_get_range()

2008-09-28  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
	  src/nm-serial-device.h
		- (nm_serial_device_close): stop PPP manager here so that PPP gets
			cleaned at the right times when subclasses close the serial port too
		- (nm_serial_device_send_command): use a default send delay; don't
			spin forever on EAGAIN
		- (get_reply_done, get_reply_got_data, nm_serial_device_get_reply):
			remove, no longer used
		- (find_response): return the matched response if any
		- (nm_serial_device_wait_reply_blocking): wait for a reply but block
			while doing so
		- (wait_for_reply_done): pass the matched response to the callback
		- (wait_for_reply_got_data): save the matched response; simplify timeout
			handling
		- (nm_serial_device_wait_for_reply): make 'responses' and 'terminators'
			const since they never get modified
		- (cleanup_device): split out common cleanup stuff to a new function
		- (real_deactivate_quickly, finalize): use cleanup_device()

	* src/nm-gsm-device.c
		- (modem_get_reply): remove, unused
		- (set_apn): give the card a bit more time to respond
		- (manual_registration_again, schedule_manual_registration_again,
		   manual_registration_response, manual_registration): handle manual
			registration timeouts better by retrying registration a few times
			because cards are a bit slow after CFUN=1
		- (automatic_registration_get_network, get_network_response): use
			modem_wait_for_reply() because it interacts better with the serial
			buffer and does more intelligent matching; need to wait for 'OK'
			rather than just matching terminators
		- (schedule_automatic_registration_again,
		   automatic_registration_response, automatic_registration): retry
			registration a few times on timeout or "searching" because cards
			take a bit to find a network after being powered up with CFUN=1
		- (power_up_response, power_up, init_full_done, enter_pin,
		   check_pin_done): power up the card with CFUN=1 before trying to
			register with the network
		- (init_modem_full, init_modem): use more standard 3G init strings

	* src/nm-hso-gsm-device.c
		- (modem_get_reply): remove, unused
		- (hso_ip4_config_response, real_act_stage3_ip_config_start): use
			modem_wait_for_reply() to match actual responses instead of single
			termination characters; it doesn't leave stuff in the serial buffer
			that might confuse later calls
		- (real_deactivate_quickly): use nm_serial_device_wait_reply_blocking()
			to ensure that the call is really disconnected and not leave extra
			stuff in the serial buffer

	* src/nm-cdma-device.c
		- (power_up_response, power_up, init_done): try Sierra-style modem
			power up before attempting to connect

2008-09-27  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-gsm.c
		- (verify): verify GSM network ID

2008-09-25  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-gsm.c
	  libnm-util/nm-setting-gsm.h
		- Fix up NM_GSM_NETWORK_* constants to accurately reflect the network
			technology terms (bgo #551361)

2008-09-25  Dan Williams  <dcbw@redhat.com>

	Fix bgo #549401 (inspired by patch from Alexander Sack)

	* src/nm-device-ethernet.c
		- (finish_supplicant_task): clean up scheduled tasks and free memory
		- (remove_supplicant_interface_error_handler): remove the supplicant
			error idle callback too
		- (supplicant_interface_release): rename from supplicant_interface_clean
			to match nm-device-wifi.c; clean up supplicant interface-related
			state tasks when the supplicant interface is disposed of
		- (schedule_state_handler): add scheduled tasks to a list so they can
			be cleaned up later
		- (supplicant_mgr_state_cb_handler, supplicant_iface_state_cb_handler,
		   supplicant_iface_connection_state_cb_handler): use
			finish_supplicant_task() to clean up each completed task
		- (supplicant_iface_connection_error_cb_handler,
		   supplicant_connection_timeout_cb): clear source id when the task is
			complete
		- (supplicant_iface_connection_error_cb): save scheduled task id for
			later cleanup
		- (nm_device_ethernet_dispose): clean up any pending supplicant state
			tasks

	* src/nm-device-wifi.c
		- (finish_supplicant_task): clean up scheduled tasks and free memory
		- (remove_supplicant_interface_error_handler): remove the supplicant
			error idle callback too
		- (supplicant_interface_release): clean up supplicant interface-related
			state tasks when the supplicant interface is disposed of
		- (schedule_state_handler): add scheduled tasks to a list so they can
			be cleaned up later
		- (supplicant_mgr_state_cb_handler, supplicant_iface_state_cb_handler,
		   supplicant_iface_connection_state_cb_handler): use
			finish_supplicant_task() to clean up each completed task
		- (supplicant_iface_connection_error_cb_handler): clear source id when
			the task is complete
		- (supplicant_iface_connection_error_cb): save scheduled task id for
			later cleanup
		- (nm_device_wifi_dispose): clean up any pending supplicant state tasks

2008-09-24  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/keyfile/plugin.c: Implement unmanaged_devices
	method and get/set hostname property.

2008-09-24  Tambet Ingo  <tambet@gmail.com>

	* src/supplicant-manager/nm-supplicant-interface.c
	(nm_supplicant_interface_disconnect): Don't increment the reference 
	count when disconnecting. The problem is on shutdown, when the replies
	to these commands do not arrive before NM exits, resulting on never
	calling supplicant interface's dispose(), which removes the interface
	from supplicant.

2008-09-24  Tambet Ingo  <tambet@gmail.com>

	* libnm-glib/nm-vpn-plugin-ui-interface.c: Add type checking to
	all the public function arguments.

2008-09-22  Tambet Ingo  <tambet@gmail.com>

	* src/vpn-manager/nm-vpn-connection.c: Add a signal handler for the
	"Failure" signal from VPN plugins, store the failure reason, and
	use it when the state is changed to failure.

	* introspection/nm-vpn-plugin.xml: Fix the "Failure" signal's type
	description.

	* include/NetworkManagerVPN.h (NMVPNConnectionStateReason): Add a new
	reason to the end of the list to not break the API.
	(NMVPNPluginFailure): Move it here (from libnm-glib/nm-vpn-plugin.h)
	so it can be shared by plugins and daemon.

2008-09-18  Dan Williams  <dcbw@redhat.com>

	Patch from Alexander Sack <asac@ubuntu.com>

	* configure.in
	  system-settings/plugins/Makefile.am
	  system-settings/plugins/ifupdown/Makefile.am
	  system-settings/plugins/ifupdown/interface_parser.c
	  system-settings/plugins/ifupdown/interface_parser.h
	  system-settings/plugins/ifupdown/nm-ifupdown-connection.c
	  system-settings/plugins/ifupdown/nm-ifupdown-connection.h
	  system-settings/plugins/ifupdown/parser.c
	  system-settings/plugins/ifupdown/parser.h
	  system-settings/plugins/ifupdown/plugin.c
	  system-settings/plugins/ifupdown/plugin.h
		- Implement a Debian/Ubuntu legacy network configuration plugin
			(gnome.org #551941)

2008-09-18  Dan Williams  <dcbw@redhat.com>

	Implement support for honoring configured and automatic hostnames, and for
	setting the configured hostname.

	* introspection/nm-ip4-config.xml
	  src/nm-ip4-config.c
	  src/nm-ip4-config.h
	  src/dhcp-manager/nm-dhcp-manager.c
		- Remove useless hostname property; it's not really part of the IPv4
			config

	* introspection/nm-settings-system.xml
	  libnm-glib/nm-dbus-settings-system.c
	  libnm-glib/nm-dbus-settings-system.h
		- Add SetHostname() call to system settings D-Bus interface
		- Add Hostname property to system settings D-Bus interface
		- (nm_dbus_settings_system_save_hostname,
		   nm_dbus_settings_system_get_hostname): implement

	* src/nm-device.c
	  src/nm-device.h
		- (nm_device_get_dhcp4_config): implement

	* src/nm-manager.c
	  src/nm-manager.h
		- Fetch and track system settings service hostname changes, and proxy
			the changes via a GObject property of the manager

	* system-settings/src/nm-system-config-interface.c
	  system-settings/src/nm-system-config-interface.h
		- Replace nm_system_config_interface_supports_add() with a capabilities
			bitfield

	* system-settings/src/nm-system-config-error.c
	  system-settings/src/nm-system-config-error.h
		- Add additional errors

	* system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- (get_property, nm_sysconfig_settings_class_init): add hostname
			property; first plugin returning a hostname wins
		- (impl_settings_add_connection): use plugin capabilities instead of
			nm_system_config_interface_supports_add()
		- (impl_settings_save_hostname): implement hostname saving

	* src/NetworkManagerPolicy.c
		- (lookup_thread_run_cb, lookup_thread_worker, lookup_thread_new,
		   lookup_thread_die): implement an asynchronous hostname lookup thread
			which given an IPv4 address tries to look up the hostname for that
			address with reverse DNS
		- (get_best_device): split out best device code from
			update_routing_and_dns()
		- (update_etc_hosts): update /etc/hosts with the machine's new hostname
			to preserve the 127.0.0.1 reverse mapping that so many things require
		- (set_system_hostname): set a given hostname
		- (update_system_hostname): implement hostname policy; a configured
			hostname (from the system settings service) is used if available,
			otherwise an automatically determined hostname from DHCP, VPN, etc.
			If there was no automatically determined hostname, reverse DNS of
			the best device's IP address will be used, and as a last resort the
			hostname 'localhost.localdomain' is set.
		- (update_routing_and_dns): use get_best_device(); update the system
			hostname when the network config changes
		- (hostname_changed): update system hostname if the system settings
			service signals a hostname change
		- (nm_policy_new): list for system settings service hostname changes
		- (nm_policy_destroy): ensure that an in-progress hostname lookup thread
			gets told to die

	* system-settings/plugins/keyfile/plugin.c
	  system-settings/plugins/ifcfg-suse/plugin.c
		- (get_property, sc_plugin_ifcfg_class_init): implement hostname and
			capabilities properties

	* system-settings/plugins/ifcfg-fedora/shvar.c
		- (svOpenFile): re-enable R/W access of ifcfg files since the plugin
			writes out /etc/sysconfig/network now

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (plugin_get_hostname): get hostname from /etc/sysconfig/network
		- (plugin_set_hostname): save hostname to /etc/sysconfig/network
		- (sc_network_changed_cb): handle changes to /etc/sysconfig/network
		- (sc_plugin_ifcfg_init): monitor /etc/sysconfig/network for changes
		- (get_property, set_property, sc_plugin_ifcfg_class_init): implement
			hostname get/set and capabilities get

2008-09-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless.c
		- (nm_setting_wireless_ap_security_compatible): only verify pairwise and
			group ciphers if the wireless-security setting explicitly specified
			them, effectively making the default be "all ciphers"  (idea from
			Alexander Sack)

2008-09-15  Dan Williams  <dcbw@redhat.com>

	Patch from Alexander Sack <asac@ubuntu.com>

	* src/named-manager/nm-named-manager.c
		- (dispatch_resolvconf): respect resolvconf exit code

2008-09-12  Tambet Ingo  <tambet@gmail.com>

	* src/named-manager/nm-named-manager.c (dispatch_netconfig): Make it compile
	again. Add some debugging.

2008-09-11  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/keyfile/plugin.c
		- (update_connection_settings): update connection manually, since
			nm_exported_connection_update() does authentication
		- (dir_changed): update_connection_settings() doesn't need to return
			an error

2008-09-09  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-vpn-plugin-ui-interface.c
	  libnm-glib/nm-vpn-plugin-ui-interface.h
	  libnm-glib/libnm_glib_vpn.ver
		- (nm_vpn_plugin_ui_interface_delete_connection): called when the plugin
			should clean up resources related to the connection (like keyring
			secrets)
		- (nm_vpn_plugin_ui_widget_interface_save_secrets): called when the plugin
			should save user-scope secrets (like to the keyring)

2008-09-08  Dan Williams  <dcbw@redhat.com>

	Patch from Alexander Sack <asac@ubuntu.com>

	* libnm-util/crypto_gnutls.c
	  libnm-util/crypto_nss.c
		- (crypto_init, crypto_deinit): just use a boolean instead of a refcount

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
	  libnm-util/libnm-util.ver
		- (nm_utils_init): initialize libnm-util
		- (nm_utils_deinit): de-initialize libnm-util and clean up resources

	* libnm-util/nm-setting-8021x.c
		- (nm_setting_802_1x_class_init): init libnm-util when needed

2008-09-05  Dan Williams  <dcbw@redhat.com>

	Patch from Roy Marples <roy@marples.name> and others

	* configure.in
	  src/named-manager/nm-named-manager.c
		- Add support for resolvconf; use --with-resolvconf at configure time
			to enable it

2008-09-05  Dan Williams  <dcbw@redhat.com>

	* libnm-util/crypto_nss.c
	  libnm-util/crypto_gnutls.c
	  libnm-util/crypto.h
		- (crypto_init): return error when init fails

2008-09-05  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-wifi.c
		- (access_point_removed_proxy): clean up the active access point too
			just in case the active ap changed signal didn't come through yet
		- (clean_up_aps): be sure to set priv->active_ap to NULL when cleaning up

2008-09-05  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
		- (constructor): get initial state after we know whether NM is running
			or not

2008-09-05  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-ip4-config.c
	  libnm-glib/nm-dhcp4-config.c
		- (finalize): clean up the DBusGProxy

2008-09-04  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- (nm_ip4_config_new): don't export over D-Bus here
		- (nm_ip4_config_export): new function; export the config over D-Bus
		- (nm_ip4_config_is_exported): new function

	* src/nm-device.c
		- (nm_device_activate_stage5_ip_config_commit): fix leak of IP4Config
			objects by balancing the IP4Config constructor; the device holds
			a reference to the IP4Config already
		- (nm_device_set_ip4_config): export the IP4Config when needed

2008-09-04  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Allow WPA-NONE key management for Ad-Hoc WPA connections

2008-09-04  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-vpn.c
	  libnm-util/nm-setting-vpn.h
		- Split VPN secrets from VPN data so that settings services can actually
			figure out that they are secrets and store them accordingly

	* system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/plugins/keyfile/reader.c
	  system-settings/plugins/keyfile/reader.h
	  system-settings/plugins/keyfile/writer.c
		- Store VPN secrets separately from VPN data so that they can be fetched
			on demand
		- Implement the get_secrets() call so that (a) secrets don't leak out
			to unprivileged callers, and (b) secrets can be sent to privileged
			callers when needed

	* vpn-daemons/vpnc/src/nm-vpnc-service.c
		- Handle split VPN secrets

2008-08-27  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (make_ip4_setting): use DOMAIN not SEARCH (rh #459370)

2008-08-27  Dan Williams  <dcbw@redhat.com>

	Ensure zombie children get cleaned up.  To get notifications when children
	die abnormally, g_spawn_async() requires G_SPAWN_DO_NOT_REAP_CHILD, but
	that requires calling waitpid() yourself if you've removed the child watch
	handler before the process has actually died, which NM needs to do in a few
	places.  So ensure that everything uses G_SPAWN_DO_NOT_REAP_CHILD and also
	cleans up after the child when required.  Should fix problems trying to
	activate mobile broadband connections after a previous failure.

	* src/dhcp-manager/nm-dhcp-dhclient.c
	  src/dhcp-manager/nm-dhcp-dhcpcd.c
		- Use G_SPAWN_DO_NOT_REAP_CHILD

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_device_destroy): ensure child is cleaned up
		- (nm_dhcp_client_stop, nm_dhcp_manager_cancel_transaction_real): always
			block on child quitting, since the non-blocking functionality was
			never actually used

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
		- (dm_watch_cb): child is already reaped here
		- (ensure_killed, nm_dnsmasq_manager_stop): block until child is dead

	* src/nm-device.c
		- (aipd_cleanup): block until child is dead

	* src/named-manager/nm-named-manager.c
		- (run_netconfig): don't use G_SPAWN_DO_NOT_REAP_CHILD if we aren't
			event bothering to watch the child

	* src/ppp-manager/nm-ppp-manager.c
		- (ppp_watch_cb): child is already reaped here
		- (ensure_killed, nm_ppp_manager_stop): block until child is dead

	* src/vpn-manager/nm-vpn-service.c
		- (vpn_service_watch_cb): child is already reaped here
		- (nm_vpn_service_daemon_exec): use G_SPAWN_DO_NOT_REAP_CHILD so that
			status of the child is actually tracked
		- (ensure_killed, finalize): block until child is dead

2008-08-26  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/keyfile/nm-keyfile-connection.c
		- (update): Update filename of the connection if the connection id
			was changed

	* system-settings/plugins/keyfile/plugin.c
		- (dir_changed): first pass at handling connection renames correctly

	* system-settings/plugins/keyfile/writer.c
	  system-settings/plugins/keyfile/writer.h
		- (write_connection): replace '/' with '*' when writing out the filename
			from the connection id

2008-08-26  Dan Williams  <dcbw@redhat.com>

	Add connection UUIDs, since connection names can be changed, and since
	old-style connection IDs could change over the life of the connection.  The
	UUID should be assigned at connection creation time, be stable for a given
	connection, and should be unique among all connections for a given settings
	service.

	* configure.in
	  libnm-util/Makefile.am
		- Require libuuid

	* introspection/nm-exported-connection.xml
		- Remove "GetID" method

	* libnm-glib/nm-dbus-connection.c
	  libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
		- Remove id-related stuff

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
	  libnm-util/libnm-util.ver
		- (nm_utils_uuid_generate, nm_utils_uuid_generate_from_string): Add
			utility functions to generate UUIDs

	* libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-connection.h
		- Add 'uuid' member to the connection setting
		- (verify): require valid 'uuid' for a valid connection

	* system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/nm-suse-connection.c
	  system-settings/plugins/ifcfg-suse/parser.c
	  system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/src/main.c
		- Remove id-related stuff
		- Give connections UUIDs where needed

2008-08-25  Dan Williams  <dcbw@redhat.com>

	* libnm-util/crypto_gnutls.c
	  libnm-util/crypto_nss.c
		- (crypto_init, crypto_deinit): refcount init/deinit
		- (crypto_md5_hash): allow NULL salt

2008-08-22  Michael Biebl  <mbiebl@gmail.com>

	* libnm-glib/Makefile.am
	  libnm-util/Makefile.am
	  libnm-glib/libnm_glib.ver
	  libnm-glib/libnm_glib_vpn.ver
	  libnm-util/libnm-util.ver
		- Use linker version scripts to control the list of exported 
		symbols. List each exported symbol explicitely.
	* libnm-util/Makefile.am
		- Fix compilation of the test-crypto binary. The crypto
		functions are no longer part of the libnm-util API. Add 
		crypto_*.c to test_crypto_SOURCES and link against the correct
		crypto libraries.

2008-08-19  Dan Williams  <dcbw@redhat.com>

	* configure.in
	  test/Makefile.am
		- Don't build test/test-common
		- Remove unused stuff

	* test/nm-set-fallback
	  test/nmtestdevices.c
	  test/test-common/.cvsignore
	  test/test-common/Makefile.am
	  test/test-common/test-common.c
	  test/test-common/test-common.h
		- delete

2008-08-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- (nm_utils_garray_to_string): remove; NM was the only user and doesn't
			export anything that needs to be converted with this function

	* src/dhcp-manager/nm-dhcp-manager.c
		- (garray_to_string): convert a byte array to a UTF-8 string with
			minimal validation; the DHCP client sends it in ASCII anyway
		- (get_option, copy_option): use garray_to_string()

2008-08-18  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
	  introspection/nm-device.xml
		- Add a "missing firmware" device state reason

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_set_up_down): add a no_firmware argument
		- (nm_system_device_set_up_down_with_iface): if the result of setting
			IFF_UP is ENOENT, that almost always means missing firmware

	* src/backends/NetworkManagerGeneric.c
	  src/nm-device-ethernet.c
	  src/nm-device-private.h
	  src/nm-device-wifi.c
	  src/nm-device.c
	  src/nm-device.h
	  src/nm-hso-gsm-device.c
	  src/vpn-manager/nm-vpn-connection.c
		- Pass no_firmware along; check it where appropriate

2008-08-18  Dan Williams  <dcbw@redhat.com>

	Patch from Robert Buchholz <rbu@gentoo.org>

	* autogen.sh
	  configure.in
		- Change to automake 1.9 and 'ustar' tar format defined by POSIX
			1003.1-1988, allowing for file names longer than 99 characters

2008-08-17  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
	  introspection/nm-device.xml
	  src/nm-gsm-device.c
		- Finer-grained GSM registration failure error codes

2008-08-17  Dan Williams  <dcbw@redhat.com>

	* callouts/Makefile.am
	  src/Makefile.am
		- Move dispatcher directory creation to callouts/Makefile.am

	* system-settings/plugins/keyfile/Makefile.am
		- Create keyfile connections directory in DESTDIR (bgo #546833)

2008-08-15  Dan Williams  <dcbw@redhat.com>

	Do connection sharing in a cleaner manner; all required iptables rules
	are now stored in the activation request and pertain only to the device
	which is being shared to other computers. (rh #458625)

	* src/nm-activation-request.c
	  src/nm-activation-request.h
		- (nm_act_request_add_share_rule): new function; add a sharing rule to
			the activation request which will get torn down automatically when
			the activation request dies
		- (nm_act_request_set_shared): push sharing rules to iptables when sharing
			is started, and tear them down when sharing is stopped

	* src/nm-device.c
		- (start_sharing): start up sharing by doing the required iptables magic
		- (share_init): poke the right bits of the kernel and load the right
			modules for NAT
		- (nm_device_activate_stage5_ip_config_commit): start NAT-ing this
			connection if it's a 'shared' connection

	* src/NetworkManagerPolicy.c
		- Remove all sharing stuff; done in the device code itself

2008-08-15  Dan Williams  <dcbw@redhat.com>

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
		- (create_dm_cmd_line): send the right router address

2008-08-15  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (pppd_timed_out): ensure timeouts fail the connection

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/nm-properties-changed-signal.c
	  src/nm-properties-changed-signal.h
		- Add a property spec flag for "don't export this property" in
			property changed signals

	* src/nm-hso-gsm-device.c
	  src/nm-gsm-device.c
	  src/nm-cdma-device.c
		- Don't export monitor interface or netdev interface properties

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): 'hso' devices can be default even if they
			don't have a gateway

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_deactivate_quickly): tear down activation request after
			calling device-specific deactivation

	* src/nm-hso-gsm-device.c
		- (real_deactivate_quickly): terminate connection when deactivating

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.h
		- Add HSO secrets caller

	* src/nm-gsm-device.c
	  src/nm-gsm-device.h
		- (modem_wait_for_reply): add a 'user_data' argument so callers can pass
			something to the callback function
		- (set_apn, set_apn_done): call class dial function, not a static one
		- (nm_gsm_device_class_init): add a class 'dial' function

	* src/nm-hal-manager.c
		- (get_hso_netdev): find the hso-driven hardware's net device
		- (modem_device_creator): recognize hso-driven hardware and create the
			right type of device object for it

	* src/Makefile.am
	  src/nm-hso-gsm-device.c
	  src/nm-hso-gsm-device.h
		- Implement support for devices driven by the 'hso' driver as a subclass
			of NMGsmDevice

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_is_up_with_iface): ensure ifreq is cleared before using
		- (nm_system_device_set_up_down_with_iface): cleanups; only return
			success if the operation really was successful

2008-08-14  Dan Williams  <dcbw@redhat.com>

	* src/nm-netlink-monitor.c
	  src/nm-netlink-monitor.h
	  src/nm-device-ethernet.c
		- (nm_netlink_monitor_request_status): return an error on failure
		- (constructor): don't segfault on missing error

2008-08-13  Dan Williams  <dcbw@redhat.com>

	* callouts/nm-dispatcher-action.c
		- Add IP4 config info to script environment

2008-08-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_set_ip4_config): don't touch hostnames here; distros
			that want to use DHCP hostnames should use dispatcher scripts
			for that

	* src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- Remove nm_system_set_hostname(), no longer used
	  
	* src/backends/Makefile.am
	  src/backends/shvar.c
	  src/backends/shvar.h
		- Remove shvar.*; no longer used

2008-08-12  Dan Williams  <dcbw@redhat.com>

	Revert most of the 'hostname' patch.  Too much stuff still breaks when
	hostname is updated at runtime.  Distros or users who want hostname updates
	can use dispatcher scripts to update the hostname if they need it.

2008-08-12  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-settings-system.xml
	  system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- Add a 'Hostname' property (rw) which represents the configured
			hostname and domain of the system, if any

	* system-settings/src/nm-system-config-error.c
	  system-settings/src/nm-system-config-error.h
	  system-settings/src/nm-system-config-interface.c
	  system-settings/src/nm-system-config-interface.h
		- Add a 'hostname' property to the plugin interface
		- Add a method to send updated hostname to plugins to save in their
			backing configuration store

	* system-settings/plugins/keyfile/nm-keyfile-connection.c
	  system-settings/plugins/keyfile/plugin.c
	  system-settings/plugins/keyfile/writer.c
	  system-settings/plugins/keyfile/writer.h
	  system-settings/plugins/ifcfg-suse/plugin.c
		- Add minimal hostname support

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- Add support for updating system hostname in /etc/sysconfig/network

2008-08-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/shvar.c
	  system-settings/plugins/ifcfg-fedora/shvar.c
		- Fix double-free caused by svSetValue() followed by svCloseFile()

2008-08-12  Tambet Ingo  <tambet@gmail.com>

	* Makefile.am: Fix distcheck.

2008-08-12  Tambet Ingo  <tambet@gmail.com>

	* libnm-glib/*.c. Document some more.

2008-08-12  Tambet Ingo  <tambet@gmail.com>

	Start documenting libnm-glib public API using gtk-doc.

	* libnm-glib/nm-serial-device.c: 
	* libnm-glib/nm-object.c: 
	* libnm-glib/nm-gsm-device.c: 
	* libnm-glib/nm-device.c: 
	* libnm-glib/nm-device-wifi.c: 
	* libnm-glib/nm-device-ethernet.c: 
	* libnm-glib/nm-client.c: 
	* libnm-glib/nm-cdma-device.c: Document the public API.

	* docs/libnm-glib/libnm-glib.types: Implement.

	* docs/libnm-glib/Makefile.am: Implement.

	* autogen.sh: 
	* configure.in: 
	* Makefile.am: Add gtk-doc support.

2008-08-12  Tambet Ingo  <tambet@gmail.com>

	* src/backends/*: Get rid of nm_system_should_modify_resolv_conf().

	* src/named-manager/nm-named-manager.c (rewrite_resolv_conf): Calculate
	the composite result of all the IP4 configurations and call a distro
	specific update_resolv_conf().
	(update_resolv_conf): Implement one for directly writing to 
	/etc/resolv.conf and one for opensuse to call netconfig.

2008-08-11  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (impl_ppp_manager_need_secrets): pass interface as required

2008-08-11  Dan Williams  <dcbw@redhat.com>

	Merge the vpn-properties setting with the vpn setting since it was pointless
	to keep both of them around.  Convert the vpn 'data' hash table to a hash
	of string:string (instead of string:variant) so that system settings plugins
	can have an easier time dealing with the arbitrary key/value pairs.

2008-08-11  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
		- (nm_utils_register_value_transformations): add value transform for
			a hash table of string:string

2008-08-10  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-vpn-plugin.c
		- (nm_vpn_plugin_connect): stop plugin after connection failure from
			an idle handler so the Connect reply gets delivered before the
			stop StateChanged signal

2008-08-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
		- (get_property): use common ip4 address/route conversion functions
		- (nm_ip4_config_replace_address, nm_ip4_config_replace_route): should
			copy the new route here, not take ownership

2008-08-08  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/parser.c (make_ip4_setting):
	Update the IP4 setting's method name.

2008-08-07  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-ip4-config.xml
	  libnm-glib/libnm-glib-test.c
	  libnm-glib/nm-ip4-config.c
	  libnm-glib/nm-ip4-config.h
	  src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
	  src/dhcp-manager/nm-dhcp-manager.c
	  src/nm-device.c
	  src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- Remove NIS logic; should be done from dispatcher scripts instead

2008-08-07  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): fix regression which caused
			mis-handling of DHCP responses that returned more than one router
			(found by Grant Williamson)

2008-08-07  Dan Williams  <dcbw@redhat.com>

	* callouts/nm-dispatcher-action.c
		- (nm_dispatcher_action): grab device path and create the device; pass
			the device's DHCP4 config to script caller
		- (dispatch_scripts): dump the DHCP4 config to the environment of called
			scripts

	* libnm-glib/nm-dhcp4-config.c
	  libnm-glib/nm-dhcp4-config.h
		- (nm_dhcp4_config_get_options): expose
		- (nm_dhcp4_config_get_one_option): renamed from nm_dhcp4_config_get_option

2008-08-07  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
		- Add the DHCP4Config D-Bus interface

	* libnm-glib/Makefile.am
	  libnm-glib/nm-dhcp4-config.c
	  libnm-glib/nm-dhcp4-config.h
		- Handle DHCP4 config objects exported by NM over D-Bus

	* libnm-glib/nm-device.c
	  libnm-glib/nm-device.h
		- Add a 'dhcp4-config' property

	* libnm-glib/libnm-glib-test.c
		- Print out DHCP4 config for devices
		- Fix some crashes when no connections are active

	* src/nm-device-interface.c
	  src/nm-device.c
	  src/nm-dhcp4-config.c
	  src/nm-dhcp4-config.h
		- Treat dhcp4-config object as an object path at the D-Bus interface so
			that when it doesn't exist we can proxy it as "/" which dbus-glib
			doesn't let us do when the property type is G_TYPE_OBJECT

2008-08-07  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManager.c
	  src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_init, nm_system_kill_all_dhcp_daemons): remove, unused

2008-08-06  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-ip4-config.c
	  libnm-glib/nm-ip4-config.h
		- Add 'routes' property

	* libnm-util/nm-setting-vpn.c
	  libnm-util/nm-setting-vpn.h
		- Remove 'routes' property

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- 'ignore-dhcp-dns' renamed to 'ignore-auto-dns'
		- Add 'ignore-auto-routes' property
		- 'routes' exposed over D-Bus is now an array of array of uint (4) to 
			accomodate route metrics
		- 'routes' exposed in C is now a list of NMSettingIP4Route structures

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- Add helpers for marshalling IP4 routes

	* src/NetworkManagerUtils.c
		- (nm_utils_merge_ip4_config): handle property renames and new route
			structure

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_ip4_route, nm_system_device_set_from_ip4_config,
		   nm_system_vpn_device_set_from_ip4_config): respect route metrics

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): handle new route structure

	* system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-fedora/writer.c
		- Handle routes separately from addresses now that routes have a different
			format

	* introspection/nm-ip4-config.xml
	  src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- Rename internal routing functions
		- 'static-routes' renamed to 'routes'

2008-08-04  Dan Williams  <dcbw@redhat.com>

	Patch from Sjoerd Simons <sjoerd.simons@collabora.co.uk>

	* src/NetworkManager.c
	  src/nm-manager.c
	  src/nm-manager.h
		- More explicitly make the NMManager a singleton

2008-08-04  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.c
	  libnm-util/nm-connection.h
		- (nm_connection_verify): return error on missing 'connection' setting
			(found by Sjoerd Simons)

2008-08-04  Dan Williams  <dcbw@redhat.com>

	Handle multiple concurrent PPP connections.

	* src/ppp-manager/nm-ppp-manager.c
	  src/ppp-manager/nm-ppp-manager.h
		- (constructor): only PPP Manager request bus name once; each
			NMPPPManager object gets a unique object path
		- (nm_ppp_manager_class_init, get_property, set_property,
		   nm_ppp_manager_new, nm_ppp_manager_start): pass parent interface in
			at construct time
		- (impl_ppp_manager_need_secrets, impl_ppp_manager_set_state): don't
			remove timeout until PPP manager gets an IP4 config
		- (create_pppd_cmd_line): pass dbus object path as 'ipparam' so that
			the plugin can call back to this specific PPP manager instance

	* src/nm-device-ethernet.c
	  src/nm-serial-device.c
		- Pass parent device in nm_ppp_manager_new()

	* src/nm-gsm-device.c
	  src/nm-cdma-device.c
	  	- (device_state_changed): don't close serial device on NEED_AUTH
	  		state changed, that's not a failure case like the rest are

	* src/ppp-manager/nm-pppd-plugin.c
		- (nm_ip_up): always use index 0 into the ipcp options, because NM always
			binds one interface to any pppd process, thus the correct index
			is always 0; send PHASE_DEAD on error to alert NM immediately of
			problems; try harder to get a peer address in spite of pppd
		- (plugin_init): use 'ipparam' as the object path back to our specific
			PPP manager instance

2008-08-04  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (impl_ppp_manager_need_secrets): rework to handle secrets better;
			since the GSM and CDMA settings now implement need_secrets, we can
			rely on them to do the right thing.  Where secrets are not required,
			just pass empty strings back to the pppd plugin.
		- (nm_ppp_manager_update_secrets): leak fix; don't need to dup the strings
		- (impl_ppp_manager_set_ip4_config): clear the secrets tries counter
			on successful IP4 config receipt

2008-08-04  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-cdma.c
	  libnm-util/nm-setting-gsm.c
		- (verify): validate username & password if they exist
		- (need_secrets): if username given, require a password too

2008-08-04  Dan Williams  <dcbw@redhat.com>

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
		- (create_dm_cmd_line): really don't listen on lo, despite what the
			manpage says about --listen-address without --interface
			(bgo #546033)

2008-08-01  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.c
		- (proxy_get_string): util function for querying a HAL property
		- (get_ancestor_device): split out from get_product_and_vendor()
		- (get_product_and_vendor): simplify; get more accurate pid & vid info
			from PCI devices by querying subsys properties
		- (nm_device_update_description): simplify

2008-08-01  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Make IPv4 methods reflect their usage; 'dhcp' -> 'auto' and
			'autoip' -> 'link-local'.  VPN & PPP connections can also have IPv4
			settings, and they don't necessarily use DHCP.

	* src/NetworkManagerPolicy.c
	  src/nm-device.c
	  system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-suse/parser.c
		- Fixup for method changes

2008-07-31  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.c
	  src/vpn-manager/nm-vpn-connection.c
		- Correct GetSecrets D-Bus pending call usage; the GetSecrets call
			itself should be attached to the activation request or the VPN
			connection, not the NMConnection object, since the call is not
			expected to live as long as the NMConnection itself

2008-07-31  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- (real_act_stage2_config): fix issue where association would continue
			even though secrets were needed; 'goto out' was in wrong scope and
			result of handle_auth_or_fail() should have been dumped directly to
			'ret' to ensure that the association was postponed until secrets
			are available

2008-07-31  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/plugin.c
	  system-settings/plugins/ifcfg-fedora/reader.c
		- Don't ignore unmanaged devices if their ifcfg file doesn't make a
			valid NM connection

2008-07-29  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (automatic_registration_response, automatic_registration): recognize
			denied registration and reorder responses

2008-07-29  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (nm_serial_device_wait_for_reply): fix timeout calculation.  Since
			time(2) is used for current time, which returns seconds, we shouldn't
			be multiplying by 1000.

2008-07-28  Dan Williams  <dcbw@redhat.com>

	Patch from Fabrice Bellet <fabrice@bellet.info>

	* src/NetworkManagerSystem.c
		- (route_in_same_subnet): mask addresses and compare them so that the
			function actually does what it says it's going to do (rh #456685)

2008-07-27  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip6-config.c
		- (set_property): add missing break that caused routes to be overwritten
			with addresses

	* libnm-util/nm-setting-ip6-config.c
		- (verify): validate routes and return GError everywhere on invalid setting
		- (finalize): don't leak routes
		- (set_property): add missing break that caused routes to be overwritten
			with addresses

2008-07-27  Dan Williams  <dcbw@redhat.com>

	* libnm-util/*
		- Relicense to LGPLv2+

2008-07-27  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (make_ip4_setting): fix parsing automatic configs

2008-07-27  Dan Williams  <dcbw@redhat.com>

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
	  src/nm-device.c
	  src/ppp-manager/nm-ppp-manager.c
		- Ensure child process gets reaped.  The child watch function may be
			removed from the mainloop before the child gets killed, so we have
			to make sure the child is reaped when it's told to die intentionally

2008-07-27  Dan Williams  <dcbw@redhat.com>

	Patch from Roy Marples <roy@marples.name>

	* src/dhcp-manager/nm-dhcp-dhcpcd.c
		- (nm_dhcp_client_start): fixup for latest dhcpcd 4.0 RC

2008-07-27  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (init_modem_full): send "ATZ E0" after CPIN, because apparently some
			Huawei devices turn echo back on after CPIN (rh #456770)

2008-07-24  Tambet Ingo  <tambet@gmail.com>

	* src/ppp-manager/nm-ppp-manager.c (nm_ppp_manager_update_secrets): Add
	format argument to g_set_error() call.

	* src/backends/interface_parser.[ch]: Remove.

	* src/backends/Makefile.am: Remove unused files interface_parser.[ch].

2008-07-21  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (create_pppd_cmd_line): send 'noipdefault' on non-PPPoE connections
			to prevent pppd from picking up some random local address from an
			interface that doesn't have anything to do with the one we're
			interested in (rh #455348)

2008-07-17  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
		- (string_to_utf8): general function for conversion to UTF-8 assisted
			by locale
		- (nm_utils_ssid_to_utf8): use string_to_utf8()
		- (nm_utils_garray_to_string): ensure returned string is UTF-8 safe

2008-07-17  Dan Williams  <dcbw@redhat.com>

	* introspection/Makefile.am
	  introspection/nm-device.xml
	  introspection/nm-dhcp4-config.xml
		- Add bits for the DHCP4Config property of the device, and the DHCP4Config
			itself
	* src/nm-device-interface.c
	  src/nm-device-interface.h
		- Add the DHCP4Config property

	* src/nm-device.c
		- Keep track of DHCP4 options via a new DHCP4Config property and notify
			D-Bus clients when it changes

	* src/nm-dhcp4-config.c
	  src/nm-dhcp4-config.h
		- Simple object to store DHCP4 options, export them over D-Bus, and
			notify when they change

	* src/dhcp-manager/nm-dhcp-manager.c
	  src/dhcp-manager/nm-dhcp-manager.h
		- (nm_dhcp_manager_set_dhcp4_config, copy_dhcp4_config_option): copy and
			filter server-returned DHCP options into an NMDHCP4Config object

2008-07-16  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-device.xml
		- Add device state reasons

2008-07-16  Dan Williams  <dcbw@redhat.com>

	Patch from Roy Marples <roy@marples.name>

	* configure.in
		- Add --with-dhcp-client option

	* src/dhcp-manager/Makefile.am
		- pass DHCP_CLIENT_PATH on compile line

	* src/dhcp-manager/nm-dhcp-manager.c
	  src/dhcp-manager/nm-dhcp-manager.h
		- Genericize for both dhcpcd and dhclient

	* src/dhcp-manager/nm-dhcp-dhclient.c
		- Move dhclient stuff out to it's own file from nm-dhcp-manager.c

	* src/dhcp-manager/nm-dhcp-dhcpcd.c
		- Implement support for dhcpcd too

2008-07-16  Tambet Ingo  <tambet@gmail.com>

	* system-settings/src/nm-system-config-interface.c 
	(nm_system_config_interface_supports_add): Implement.
	(nm_system_config_interface_add_connection): Return a boolean to notify
	of errors.

	* system-settings/src/nm-polkit-helpers.c: 
	* system-settings/src/nm-polkit-helpers.h: Move error declarations to
	a separate file.

	* system-settings/src/dbus-settings.c (impl_settings_add_connection):
	Return an error when none of the plugins support add or if addition
	failed for some reason.

	* system-settings/src/nm-system-config-error.h: 
	* system-settings/src/nm-system-config-error.c: New files, mostly moved
	here from nm-polkit-helpers.[ch].

	* system-settings/src/Makefile.am: Build new files.

	* system-settings/plugins/keyfile/reader.c 
	(read_array_of_array_of_uint): Make it more general so that it would
	work for routes as well.

	* system-settings/plugins/keyfile/writer.c
	(write_array_of_array_of_uint): Ditto.
	Fix the netmask/prefix writing.

	* system-settings/plugins/keyfile/plugin.c (add_connection): Return
	boolean to notify errors.

	* system-settings/plugins/ifcfg-suse/nm-suse-connection.c (update):
	Return more specific error.
	(delete): Ditto.

2008-07-11  Dan Williams  <dcbw@redhat.com>

	Modify the NMDevice::state-changed signal to include the previous state
	and reason. Enables the applet to provide more information why device
	activation failed.

2008-07-09  Dan Williams  <dcbw@redhat.com>

	* callouts/Makefile.am
	  callouts/nm-avahi-autoipd-action.c
	  callouts/nm-avahi-autoipd.conf
		- avahi-autoipd callout to send options back to NM

	* src/autoip.c
	  src/autoip.h
		- remove

	* src/nm-device.c
	  src/nm-device-private.h
	  src/nm-manager.c
		- Use avahi-autoipd for IPv4LL functionality rather than really crappy
			old custom stuff

2008-07-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (make_ip4_setting): handle DHCP_HOSTNAME; fix up prefix support to
			handle PREFIX too; clean up

2008-07-07  Dan Williams  <dcbw@redhat.com>

	Convert to using IPv4 prefixes instead of netmasks.

2008-07-03  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Add properties for DHCP Client Identifier and DHCP Hostname

	* src/dhcp-manager/nm-dhcp-manager.c
	  src/dhcp-manager/nm-dhcp-manager.h
		- (nm_dhcp_manager_begin_transaction): take the connection's ip4-config
			setting as an argument to pass on to the dhclient config file
			creation function
		- (nm_dhcp_manager_cancel_transaction_real): remove dhclient config when
			DHCP is torn down
		- (dhclient_run): punt config file handling to create_dhclient_config()
		- (create_dhclient_config): create an interface-specific dhclient
			config file since there may need to be interface-specific options
			passed to dhclient
		- (merge_dhclient_config): merge normal distro dhclient config file and
			add options from the connection
		- (nm_dhcp_device_new): generate the interface specific dhclient
			config file path once
		- (nm_dhcp_device_destroy): handle partially initialized objects; free
			dhclient config file path

	* src/nm-device.c
		- (real_act_stage3_ip_config_start): pass ip4-config, if any, to the
			DHCP manager when starting DHCP

2008-07-02  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-8021x.c
		- (verify): allow forcing the PEAP label to 0

2008-07-02  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-active-connection.xml
	  introspection/nm-vpn-connection.xml
	  libnm-glib/nm-active-connection.c
	  src/nm-activation-request.c
	  src/nm-active-connection.h
	  src/vpn-manager/nm-vpn-connection.c
		- Remove "SharedServiceName" and "SharedConnection" bits from the D-Bus
			and libnm-glib API since sharing didn't get implemented that way

2008-07-02  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- (can_scan): don't scan when a shared connection is activated since
			that makes drivers mad (causing disconnects); also NM doesn't need
			to hedge against disconnects by keeping up-to-date network topology
			because the connection originates from the local machine, and thus
			there should be no disconnects

2008-07-01  Dan Williams  <dcbw@redhat.com>

	Fix mobile broadband username/password issues.  NM was never requesting
	mobile broadband secrets, nor was it passing back the username and password
	if it had them.

	* marshallers/nm-marshal.list
		- Add some new types for activation request objects

	* src/nm-activation-request.c
	  src/nm-activation-request.h
		- (get_secrets_cb): pass the caller type in the signal
		- (nm_act_request_request_connection_secrets): take a caller type, so
			that GetSecrets() reply handlers know who asked for the secrets in
			the first place; use secret hints too so the settings service can
			figure out exactly what NM wants (ie, PIN or the PPP password)

	* src/ppp-manager/nm-ppp-manager.c
	  src/ppp-manager/nm-ppp-manager.h
		- (impl_ppp_manager_need_secrets): nm_connection_need_secrets() won't
			detect needed secrets when the secret could be blank, like GSM/CDMA
			passwords.  So always ask for secrets, and send a hint as to what
			secret we really want.
		- (nm_ppp_manager_update_secrets): make function more generic by making
			the device specific class figure out the username and password, and
			accept an error argument to return back over D-Bus

	* src/nm-device-wifi.c
		- (link_timeout_cb, handle_auth_or_fail): update for changes to
			nm_act_request_request_connection_secrets()
		- (real_connection_secrets_updated): update for 'caller' changes

	* src/nm-device.c
	  src/nm-device.h
		- (connection_secrets_updated_cb, connection_secrets_failed_cb): update
			for 'caller' changes

	* src/nm-device-ethernet.c
		- (real_connection_secrets_updated): update for 'caller' changes and
			move logic for getting PPPoE username and password here before
			calling nm_ppp_manager_update_secrets()
		- (link_timeout_cb, handle_auth_or_fail): update for changes to
			nm_act_request_request_connection_secrets()

	* src/nm-cdma-device.c
		- (real_connection_secrets_updated): pass username and password back
			to the PPP manager when required

	* src/nm-gsm-device.c
		- (enter_pin): send the required secret name to the settings service
		- (real_connection_secrets_updated): pass username and password back
			to the PPP manager when required

2008-06-30  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-wifi.c
		- Consistently use NM_DEVICE_WIFI_GET_PRIVATE instead of self->priv

2008-06-30  Dan Williams  <dcbw@redhat.com>

	Attempt to fix various issues causing rh #448889.  Mainly, to qualify for
	the DISCONNECTED state, the device must not be rfkilled _and_ have a valid
	priv->supplicant.iface.  When either condition is false, the device should
	transition back to UNAVAILABLE because it cannot be used.

	* src/nm-device-wifi.c
		- (constructor): cleanup; connect to supplicant manager here since the
			supplicant manager is always around
		- (supplicant_interface_acquire): rename from init_supplicant_interface,
			ensure the supplicant manager is in the IDLE state
		- (supplicant_interface_release): rename from cleanup_supplicant_interface,
			cancel any pending scans too
		- (real_bring_up): don't set up the supplicnat interface here, because
			we need the supplicant interface at times when the device may not
			be "up"
		- (real_take_down): just remove the periodic source
		- (schedule_scan): ensure a state that would peg the CPU doesn't happen
		- (remove_supplicant_interface_connection_error_handler): cleanup; don't
			do anything if there's no supplicant interface
		- (cleanup_association_attempt): cleanup
		- (supplicant_iface_state_cb_handler): request an immediate scan when
			the interface enters the READY state; transition to UNAVAILABLE
			state when the interface goes down because the device can't be used
			without a supplicant interface
		- (supplicant_mgr_state_cb_handler): if the supplicant goes away, clean
			up and transition to UNAVAILABLE; if the supplicant becomes ready,
			acquire the supplicant interface and transition to DISCONNECTED
			if the radio isn't killed
		- (nm_device_wifi_dispose): move most of device_cleanup() here
		- (state_changed_cb): release any existing supplicant interface; if the
			radio is enabled then try to acquire a new supplicant interface;
			if the radio is enabled and a supplicant interface has been acquired,
			we can transition to DISCONNECTED
		- (nm_device_wifi_set_enabled): if bringing the hardware up failed,
			don't enable the radio, because HAL probably lied to us about the
			killswitch being off.  If bringing the hardware up worked, then
			try to grab a supplicant interface, and if that was successful,
			transition to DISCONNECTED

2008-06-30  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-interface.c
		- (request_scan_results, nm_supplicant_interface_dispose,
		   wpas_iface_query_scan_results): cleanup; scan_results_timeout is now
			the id of the timeout, not a GSource

2008-06-30  Tambet Ingo  <tambet@gmail.com>

	* src/backends/NetworkManagerSuSE.c (nm_system_activate_nis): Fix a 
	bunch of typoes introduced by "Patch from David Cantrell 
	<dcantrell@redhat.com> and me".

2008-06-30  Tambet Ingo  <tambet@gmail.com>

	* src/nm-serial-device.c: 
	* src/nm-gsm-device.c: 
	* src/nm-cdma-device.c: Move the pending call handling to a common location
	in serial device. Handle setting device state to failed in one place as well.

2008-06-29  Dan Williams <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- Rework killswitch handling to query killswitch status immediately
			when the first killswitch is added, so that rfkill state is
			known as early as possible
		- Also treat failure of GetPower() as rfkill when the dbus method
			call times out (but not when the HAL callout returns an error)

2008-06-26  Dan Williams <dcbw@redhat.com>

	Patch from David Cantrell <dcantrell@redhat.com> and me

	* include/nm-dbus-glib-types.h
		- Add IP6 address types

	* libnm-util/Makefile.am
	  libnm-util/nm-setting-ip6-config.c
	  libnm-util/nm-setting-ip6-config.h
		- Add IP6 settings object

	* libnm-util/nm-connection.c
		- (register_default_settings): register ip6 settings object

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- (nm_utils_ip6_addresses_from_gvalue, nm_utils_ip6_addresses_to_gvalue,
		   nm_utils_ip6_dns_from_gvalue, nm_utils_ip6_dns_to_gvalue): add
			ip6 address conversion functions
	
2008-06-26  Dan Williams <dcbw@redhat.com>

	Patch from David Cantrell <dcantrell@redhat.com>
	
	* Use inet_ntop() and inet_pton() everwhere and check for errors

2008-06-26  Dan Williams <dcbw@redhat.com>

	* Update FSF address in license headers (Michael Biebl <biebl@debian.org>)

2008-06-26  Dan Williams <dcbw@redhat.com>

	Patch from Adel Gadllah <adel.gadllah@gmail.com>

	* src/nm-device-wifi.c
		- (link_timeout_cb): don't ignore disconnects due to scanning
		- (supplicant_iface_connection_state_cb_handler): instead, schedule
			a longer timeout when scanning; avoids case where supplicant can't
			find the AP and just keeps scanning forever but isn't connected

2008-06-26  Dan Williams <dcbw@redhat.com>

	Patch from Michael Biebl <biebl@debian.org>

	* Clean up build system stuff

2008-06-23  Christian Persch  <chpe@gnome.org>

	* vpn-daemons/openvpn/auth-dialog/gnome-two-password-dialog.c:
	* vpn-daemons/openvpn/auth-dialog/gnome-two-password-dialog.h:
	* vpn-daemons/pptp/auth-dialog-general/anonymous-auth-module.c:
	(impl_get_object):
	* vpn-daemons/pptp/auth-dialog-general/chap-auth-module.c:
	(impl_get_object):
	* vpn-daemons/pptp/auth-dialog-general/gnome-generic-auth-dialog.c:
	* vpn-daemons/pptp/auth-dialog-general/gnome-generic-auth-dialog.h:
	* vpn-daemons/pptp/auth-dialog-general/mschapv2-auth-module.c:
	(impl_get_object):
	* vpn-daemons/pptp/auth-dialog/gnome-two-password-dialog.c:
	* vpn-daemons/pptp/auth-dialog/gnome-two-password-dialog.h:
	* vpn-daemons/pptp/properties/nm-ppp-properties.c: (impl_setup):
	* vpn-daemons/pptp/properties/vpnui_impl.c: (impl_get_object):
	* vpn-daemons/pptp/properties/vpnui_opt.c:
	(vpnui_opt_connect_signals):
	* vpn-daemons/pptp/properties/vpnui_opt.h:
	* vpn-daemons/vpnc/auth-dialog/gnome-two-password-dialog.c:
	* vpn-daemons/vpnc/auth-dialog/gnome-two-password-dialog.h: Don't use
	deprecated gtk type macros. Bug #539325.

2008-06-20  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-vpn-plugin-ui-interface.c
	  libnm-glib/nm-vpn-plugin-ui-interface.h
		- 'validity-changed' -> 'changed' to work better with the connection
			editor.  Plugin UI widgets should emit 'changed' whenever their
			UI values change in a meaningful way.
		- (nm_vpn_plugin_ui_widget_interface_update_connection): the
			update_connection member now returns validity of the UI widget

2008-06-20  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-connection.c (nm_connection_duplicate): Implement.

2008-06-17  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-vpn-plugin-ui-interface.c
	  libnm-glib/nm-vpn-plugin-ui-interface.h
		- Add "desc" property for longer descriptions of the VPN plugin

2008-06-16  Dan Williams  <dcbw@redhat.com>

	* configure.in
	  libnm-glib/libnm_glib_vpn.pc.in
		- add a .pc file for libnm_glib_vpn

	* libnm-glib/nm-vpn-plugin-ui-interface.c
	  libnm-glib/nm-vpn-plugin-ui-interface.h
		- Move the glib/GNOME VPN UI plugin interface into libnm-glib and
			rework it substantially

2008-06-12  Dan Williams  <dcbw@redhat.com>

	Add a GError argument to nm_connection_verify() and nm_setting_verify(),
	and add error enums to each NMSetting subclass.  Each NMSetting subclass now
	returns a descriptive GError when verification fails.

2008-06-11  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* libnm-util/nm-setting-gsm.c
		- (verify): validate APN

	* src/nm-gsm-device.c
		- (manual_registration_done): start setting APN if needed
		- (set_apn, set_apn_done): set the APN
		- (do_dial): use the APN when dialing

2008-06-11  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_ip4_route,
		   nm_system_device_replace_default_ip4_route): check for the right
			return value from rtnl_route_add() to know when to add a gateway
			route (from Tambet)

2008-06-11  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- do_ipt_cmd -> do_cmd
		- (sharing_init): use do_cmd() instead of system()

2008-06-10  Dan Williams  <dcbw@redhat.com>

	The grand 802-11-wireless rename.  Get rid of the 802-11/80211/802_11 bits
	and use "wifi" everwhere instead.

2008-06-10  Dan Williams  <dcbw@redhat.com>

	The grand 802-3-ethernet rename.  Get rid of the 802-3/8023/802_3 bits.

2008-06-10  Dan Williams  <dcbw@redhat.com>

	Patch from Tambet Ingo <tambet@gmail.com>

	* src/ppp-manager/nm-ppp-manager.c: Add ppp stats monitoring, signal the
		changes.

	* src/nm-serial-device.c: Monitor "ppp-stats" signals from NMPPPManager. Add
		a signal to emit these changes over dbus.

	* src/Makefile.am: Genereate nm-serial-device-glue.

	* libnm-glib/nm-serial-device.[ch]: Implement.

	* libnm-glib/nm-cdma-device.[ch]
	  libnm-glib/nm-gsm-device.[ch]: Inherit from NMSerialDevice.

	* libnm-glib/Makefile.am: Add nm-serial-device.[ch].

	* introspection/nm-device-serial.xml: Implement.

	* introspection/all.xml: Fix a couple of typos, add nm-device-serial.xml.

	* introspection/Makefile.am: Add nm-device-serial.xml.

	* include/NetworkManager.h: Add a DBus interface for serial device.

2008-06-10  Dan Williams  <dcbw@redhat.com>

	* configure.in
		- Add TARGET_* define to config.h to distinguish distros

	* src/dhcp-manager/nm-dhcp-manager.c
		- (dhclient_run): use distro-specific path for dhclient config file

2008-06-09  Dan Williams  <dcbw@redhat.com>

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
	  src/dnsmasq-manager/nm-dnsmasq-manager.h
		- (create_dm_cmd_line): use the IP4 address of the ip4-config to
			calculate the addresses passed to dnsmasq instead of hard-coding
			them

	* src/nm-device.c
		- (nm_device_new_ip4_shared_config): be somewhat dynamic when choosing
			IP addresses for shared connections to guard against shared
			connection address collisions
		- (real_act_stage4_get_ip4_config): handle possible NULL ip4-configs on
			error conditions
		- (nm_device_activate_stage5_ip_config_commit): pass ip4-config to
			the dnsmasq manager

2008-06-09  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): set the default connection _after_ unsetting
			default on all non-default connections so that two connections can
			never be default at the same time
		- (device_state_changed): start and stop connection sharing when
			needed
		- (active_connection_default_changed): restart or stop sharing when
			the default connection changes to keep shared connections always
			NAT-ed through the default connection
		- (check_sharing): handle activation/deactivation of shared connections
		- (sharing_restart): atom-bomb approach to connection sharing until we
			can use libnl; reinit all sharing when the default connection or
			shared connections change
		- (sharing_init, sharing_stop): evil functions that init and deinit
			iptables

2008-06-09  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.c
	  src/nm-activation-request.h
		- (nm_act_request_set_shared, nm_act_request_get_shared,
		   nm_act_request_get_device): new functions to facilitate connection
			sharing

2008-06-09  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (clear_act_request): unset the 'default' property of the activation
			request when clearing it to ensure the property changed signal gets
			delivered and handled

2008-06-09  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.c
		- (access_point_removed_proxy): actually unref the AP after removing
			it from the device's AP list.  Fixes refcounting bug for APs that
			caused them to get mixed up in the applet's menu.

2008-06-09  Tambet Ingo  <tambet@gmail.com>

	* src/dhcp-manager/nm-dhcp-manager.c (finalize): Free private members.
	(nm_dhcp_device_destroy): Destroy the device options hash table.

2008-06-06  Dan Williams <dcbw@redhat.com>

	* system-settings/src/nm-polkit-helpers.c
		- (create_polkit_context): in PolicyKit 0.6, polkit_context_init() will
			unref the context if the initialization fails; also avoid spew when
			the error isn't set

2008-06-06  Dan Williams <dcbw@redhat.com>

	Patch from Tambet Ingo  <tambet@gmail.com>

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_add_ip4_route_via_device_with_iface): remove
		- (nm_system_device_set_from_ip4_config): remove unused route_to_iface
		- (nm_system_device_set_ip4_route): clean up
		- (nm_system_vpn_device_set_from_ip4_config): clean up, add VPN routes

	* src/nm-device.c
		- (nm_device_set_ip4_config): remove unused route_to_iface bits

	* src/vpn-manager/nm-vpn-connection.c
		- (ip_address_to_string): new function
		- (print_vpn_config): use ip_address_to_string
		- (merge_vpn_routes): add user-defined routes to the ip4 config
		- (nm_vpn_connection_ip4_config_get): add routes the VPN server sent

	* include/NetworkManagerVPN.h
		- Add 'routes' key

2008-06-05  Dan Williams <dcbw@redhat.com>

	Patch from Markus Becker <mab@comnets.uni-bremen.de>

	* test/nm-tool.c
		- Show which device is the default device

2008-06-05  Tambet Ingo  <tambet@gmail.com>

	Fix memory leaks.

	* system-settings/src/nm-system-config-hal-manager.c (get_type_for_udi):
	Free data returned from dbus method call.

	* system-settings/src/nm-polkit-helpers.c (check_polkit_privileges):
	dbus_g_method_get_sender() returns a duplicated string, free it 
	when done.
	(check_polkit_privileges): Looks like policykit sometimes returns
	error and non-null return value, don't leak errors in that case.

	* system-settings/src/main.c (find_plugin): Don't leak existing 
	plugin names.
	(load_stuff): Don't leak device list and list items.
	(have_connection_for_device): Don't leak connection list.

	* system-settings/plugins/keyfile/reader.c (read_one_setting_value):
	Free the data received from g_keyfile_get_*.

	* system-settings/plugins/ifcfg-suse/parser.c (READ_WEP_KEY): Free
	the key when the security object is updated.

	* src/supplicant-manager/nm-supplicant-interface.c (scan_results_cb):
	Free data returned from dbus method call.
	(iface_state_cb): Ditto.
	(add_network_cb): Ditto.
	(nm_supplicant_interface_add_cb): Don't make another copy of already
	duplicated object path.
	(nm_supplicant_interface_add_to_supplicant): Free the driver GValue
	when done.

	* src/supplicant-manager/nm-supplicant-config.c 
	(ADD_STRING_LIST_VAL): Fix a memory leak.

	* src/nm-manager.c (free_get_settings_info): Free the allocated
	memory slice.
	(list_connections_cb): Free data returned from dbus method call.
	(system_settings_get_unmanaged_devices_cb): Ditto.

	* src/nm-device-802-11-wireless.c (device_cleanup): Free ssid.

	* system-settings/plugins/ifcfg-suse/shvar.c (svCloseFile): 
	* system-settings/plugins/ifcfg-fedora/shvar.c (svCloseFile): 
	* src/backends/shvar.c (svCloseFile): Free the duplicated content
	of the GList.

	* libnm-util/nm-setting.c (nm_setting_from_hash): Free the constructor
	arguments after the object is created.

2008-06-04  Dan Williams <dcbw@redhat.com>

	* libnm-util/Makefile.am
		- Don't distribute nm-param-spec-specialized.h

2008-06-02  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-setting-ip4-config.[ch]: Add static routes property.

	* src/nm-ip4-config.[ch]: Store the static routes as a list of
	NMIP4Address, update the getters and setters.

	* src/dhcp-manager/nm-dhcp-manager.c (nm_dhcp_manager_get_ip4_config):
	Use the updated NMIP4Config routes api.

	* src/NetworkManagerUtils.c (nm_utils_merge_ip4_config): Merge
	static routes as well.

	* src/NetworkManagerSystem.c (netmask_to_prefix): Implement.
	(nm_system_device_set_from_ip4_config): Use the updated NMIP4Config
	routes api.

2008-05-30  Dan Williams <dcbw@redhat.com>

	* src/named-manager/nm-named-manager.c
	  src/named-manager/nm-named-manager.h
		- Remove stale/obsolete bits for controlling bind over DBus

2008-05-29  Dan Williams <dcbw@redhat.com>

	* src/dnsmasq-manager/nm-dnsmasq-manager.c
	  src/dnsmasq-manager/nm-dnsmasq-manager.h
		- (nm_dnsmasq_manager_new): move iface argument here
		- (constructor): remove, not needed
		- (get_pidfile_for_iface, create_dm_cmd_line, kill_existing_for_iface,
		   nm_dnsmasq_manager_start, nm_dnsmasq_manager_stop): use priv->pidfile

	* src/nm-device.c
		- (real_act_stage4_get_ip4_config,
		   nm_device_activate_stage5_ip_config_commit): fix for dnsmasq manager
			changes

2008-05-29  Dan Williams <dcbw@redhat.com>

	* src/nm-device.c
		- (dnsmasq_state_changed_cb): new function; fail the connection if
			something happens to dnsmasq
		- (nm_device_new_ip4_shared_config): new function; create a new
			ip4-config for shared connections.  Shared connections always use a
			fixed static IP address.
		- (real_act_stage4_get_ip4_config): handle shared connections; fix
			autoip connections by actually using the returned ip4-config and
			not leaking it
		- (nm_device_activate_stage5_ip_config_commit): start dnsmasq for shared
			connections
		- (nm_device_deactivate_quickly, nm_device_dispose): terminate dnsmasq
			if its active

2008-05-29  Dan Williams <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_get_best_auto_connection): auto-activate 'shared' method
			connections too

2008-05-29  Dan Williams <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Add a 'shared' method to indicate that this connection should be
			brought up with a DHCP and proxy DNS server to facilitate
			connection sharing.
		- (verify): 'shared' method doesn't allow DNS or searches either

2008-05-29  Dan Williams <dcbw@redhat.com>

	* configure.in
	  src/Makefile.am
	  src/dnsmasq-manager/Makefile.am
	  src/dnsmasq-manager/nm-dnsmasq-manager.c
	  src/dnsmasq-manager/nm-dnsmasq-manager.h
		- Add a dnsmasq daemon manager to facilitate connection sharing

2008-05-29  Dan Williams <dcbw@redhat.com>

	* src/nm-device-private.h
		- Remove unused prototypes and clean up

	* src/nm-device.c
		- Remove anything related to system_config_data, which is no longer used
		- (nm_device_new_ip4_autoip_config): make static

2008-05-29  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/nm-suse-connection.c
	(file_changed): Fix a bug where suse system settings plugin didn't
	update the connections automatically when the files changed.

2008-05-28  Dan Williams  <dcbw@redhat.com>

	Revert r3697 (adhoc-create property patch); it's the wrong way to do this.

2008-05-28  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_flush_ip4_routes_with_iface): implement with libnl
		- (nm_system_vpn_device_set_from_ip4_config): don't flush routes here,
			was causing -EINVAL errors since the libnl code actually does flush
			the routes on VPN interfaces now

	* src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_device_flush_ip4_routes,
		   nm_system_device_flush_ip4_routes_with_iface): remove

2008-05-28  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless.c
	  libnm-util/nm-setting-wireless.h
		- (set_property, get_property, nm_setting_wireless_class_init): add the
			'adhoc-create' property, which when TRUE indicates that NM should
			create this connection as an adhoc wifi network if it's not found
			as an adhoc network during scanning.  Can be used to auto-create
			adhoc networks when used in combination with autoconnect.

2008-05-28  Tambet Ingo  <tambet@gmail.com>

	Patch from Dennis Noordsij <dennis.noordsij@helsinki.fi>.

	* src/nm-gsm-device.c: Don't try to reset the modem before PIN is
	checked, it doesn't work on some devices.

2008-05-28  Tambet Ingo  <tambet@gmail.com>

	* src/ppp-manager/nm-ppp-manager.c (nm_ppp_manager_stop): Make sure 
	pppd gets killed, if SIGTERM doesn't do it's job, SIGKILL it.

	* src/dhcp-manager/nm-dhcp-manager.c (nm_dhcp_manager_get_ip4_config):
	Use inet_aton() everywhere to improve error detection.
	Don't fall back to 'dhcp_server_identifier' if the gateway is not
	provided.

2008-05-26  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/plugin.c (get_unamanged_devices_cb):
	Fix a typo.

2008-05-26  Tambet Ingo  <tambet@gmail.com>

	* src/vpn-manager/nm-vpn-manager.c (nm_vpn_manager_get_service): Fix a
	reference counting issue.

2008-05-23  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/backends/NetworkManagerGeneric.c
		- (nm_generic_enable_loopback): use libnl

2008-05-23  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_device_has_active_routes, nm_system_flush_loopback_routes,
		   nm_system_flush_arp_cache): remove, unused

	* src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
		- (nm_generic_device_has_active_routes, nm_generic_flush_loopback_routes,
		   nm_generic_flush_arp_cache): remove, unused

2008-05-23  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (make_ip4_setting): honor PEERDNS setting

2008-05-23  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_flush_ip4_addresses_with_iface): implement with
			libnl

	* src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_device_flush_ip4_addresses,
		   nm_system_device_flush_ip4_addresses_with_iface): remove

	* src/backends/NetworkManagerGeneric.c
		- (nm_generic_device_flush_ip4_addresses,
		   nm_generic_device_flush_ip4_addresses_with_iface): remove

2008-05-23  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Switch 'bssid' from bytes to keyword type
		- (validate_type_keyword): allow NULL keyword lists

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless): convert the bssid from
			a byte array to string form, which is what the supplicant expects

2008-05-23  Tambet Ingo  <tambet@gmail.com>

	Add a flag to NMSettingIP4Config to make it possible to ignore the DNS
	information received from DHCP.

	* libnm-util/nm-setting-ip4-config.c: Add a new membet "ignore_dhcp_dns"
	to make it possible to ignore the DNS information (both servers and 
	searches) returned by DHCP server.

	* src/NetworkManagerUtils.c (nm_utils_merge_ip4_config): Reset the
	name servers and searches if "ignore_dhcp_dns" is set.

	* src/nm-ip4-config.c (nm_ip4_config_reset_nameservers)
	(nm_ip4_config_reset_searches): Implement.

2008-05-22  Dan Williams  <dcbw@redhat.com>

	Remove anything mDNS related.  This is better done from a distro-specific
	dispatcher script.  Plus, any distro using avahi doesn't need to restart
	avahi, since avahi can handle interface changes just fine using netlink.

	* configure.in
		- Remove --with-mdns-provider

	* src/NetworkManagerPolicy.c
		- (global_state_changed): don't restart the mdns provider

	* src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_restart_mdns_responder): remove

	* src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
		- (nm_generic_restart_mdns_responder): remove

2008-05-22  Dan Williams  <dcbw@redhat.com>

	* configure.in
		- clean up crypto options; just use --with-crypto=nss or
			--with-crypto=gnutls

2008-05-22  Tambet Ingo  <tambet@gmail.com>

	* src/nm-manager.c (impl_manager_sleep): No need to schedule the sync
	anymore, do it right away.

2008-05-22  Tambet Ingo  <tambet@gmail.com>

	* src/nm-gsm-device.c (device_state_changed): Make sure we don't leave the
	serial device open when we're not connecting or connected.

	* src/nm-cdma-device.c (device_state_changed): Ditto.

2008-05-22  Tambet Ingo  <tambet@gmail.com>

	Don't remove all devices on waking up, sync with HAL.

	* src/nm-manager.c (nm_manager_udi_is_managed): Implement.
	(sync_devices): Implement, based on hal_manager_hal_reappeared_cb.
	(hal_manager_hal_reappeared_cb): Just call sync_devices.

2008-05-21  Tambet Ingo  <tambet@gmail.com>

	* src/NetworkManagerSystem.c (nm_system_device_replace_default_ip4_route):
	If the default gateway is unreachable, add a route to gateway and try
	again.

2008-05-20  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (add_one_wep_key): handle ASCII WEP keys too (rh #293111)

2008-05-19  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/reader.c
		- (make_ip4_setting): get a fallback gateway from /etc/sysconfig/network
			if the ifcfg doesn't specify one (rh #446527)

2008-05-19  Dan Williams  <dcbw@redhat.com>

	Make the system settings service exit when the bus goes away.  Since it's
	a bus-activated service, it's lifetime is limited to the bus that activated
	it (rh #444976).

	* system-settings/src/Makefile.am
	  system-settings/src/nm-system-config-hal-manager-private.h
		- Remove nm-system-config-hal-manager-private.h

	* system-settings/src/nm-system-config-hal-manager.c
		- (nm_system_config_hal_manager_reinit_dbus,
		   nm_system_config_hal_manager_deinit_dbus): remove

	* system-settings/src/main.c
		- (dbus_reconnect): remove
		- (dbus_cleanup): don't tell the HAL manager to deinit dbus
		- (destroy_cb): just quit when the bus goes away
		- (start_dbus_service, dbus_init): simplify
		- (main): destroy the wired devices hash table after destroying
			the HAL manager so we don't have to disconnect signals from the
			HAL manager

2008-05-15  Tambet Ingo  <tambet@gmail.com>

	Move crypto functions from nm-applet to libnm-util.

	* libnm-util/nm-setting-8021x.c (nm_setting_802_1x_set_ca_cert)
	(nm_setting_802_1x_set_client_cert)
	(nm_setting_802_1x_set_phase2_ca_cert)
	(nm_setting_802_1x_set_phase2_client_cert)
	(nm_setting_802_1x_set_private_key)
	(nm_setting_802_1x_set_phase2_private_key): Implement. Given a certificate
	file (or private key and it's password), read the certificate data.

	* libnm-util/crypto_nss.c: 
	* libnm-util/crypto_gnutls.c: 
	* libnm-util/crypto.[ch]: Move here from nm-applet.

	* configure.in: Check for NSS and gnutls here (moved here from nm-applet).

	* system-settings/plugins/ifcfg-suse/parser.c (read_wpa_eap_settings):
	Imlement WPA-EAP configuration reading from sysconfig.

2008-05-16  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_set_enabled): request a scan after enabling
			wireless

2008-05-14  Dan Williams  <dcbw@redhat.com>

	Fix Linus' bug in rh #134886

	* src/nm-device-802-3-ethernet.c
		- (constructor): request initial carrier state

	* src/nm-netlink-monitor.c
		- (nm_netlink_monitor_request_status): schedule emission of carrier
			signals after refilling the link cache.  Because the refill is a 
			synchronous operation, the normal message hander won't get called
			since libnl has already consumed the messages.
		- (deferred_emit_carrier_state): emit carrier states from an idle handler

2008-05-14  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_is_up_with_iface): clean up

2008-05-13  Dan Williams  <dcbw@redhat.com>

	Fix refcounting issues over sleep/wake when a VPN connection was active that
	caused NM to try registering an object path for a device upon wake that was
	the same as an already registered object path.

	* src/nm-device.c
		- (nm_device_take_down): properly handle cases where the device is
			no longer active but was just active, and therefore must be
			deactivated.  When a device moves to unmanaged mode, this function
			previously would not deactivate the device, because the state was
			already unmanaged by the time this function was called.

	* src/vpn-manager/nm-vpn-connection.c
		- (device_state_changed): properly handle multiple devices states in
			which the device is now deactivated.  Code previously didn't handle
			transitions to the UNAVAILABLE (like rfkill or carrier off) and
			UNMANAGED states.

2008-05-13  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-private.h
	  src/nm-device.c
		- (nm_device_hw_bring_up, nm_device_hw_take_down): export

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_set_enabled): take devices up
			and down as appropriate for the rfkill state

2008-05-13  Dan Williams  <dcbw@redhat.com>

	* marshallers/nm-marshal.list
		- Add VOID:POINTER,STRING marshaller for ifcfg-fedora plugin

	* system-settings/plugins/ifcfg-fedora/Makefile.am
	  system-settings/plugins/ifcfg-fedora/nm-inotify-helper.c
	  system-settings/plugins/ifcfg-fedora/nm-inotify-helper.h
		- Implement a minimal inotify helper for watch paths for IN_CLOSE_WRITE
			events.  Solely for use watching ifcfg files to pick up changes
			to their hardlinks, since GIO doesn't support this yet (bgo #532815)

	* system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
		- (nm_ifcfg_connection_class_init): new 'ifcfg-changed' signal when the
			file contents change
		- (finalize): clean up inotify watches
		- (nm_ifcfg_connection_new): store keyfile; inotify watch the keyfile
			and the connection ifcfg for changes on their hardlinks
		- (files_changed_cb): proxy the changed signal back out to listeners

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (dir_changed): 
		- (connection_ifcfg_changed): re-read the connection when the ifcfg
			changes
		- (read_one_connection): connect to change signals on the new connection
		- (dir_changed, connection_changed_handler,
		   handle_connection_remove_or_new): break out connection change
			handling and connection new/remove handling so it can be used from
			both the GFileMonitor callback and the NMIfcfgConnection changed
			signals

	* system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-fedora/reader.h
		- (connection_from_file): return the keyfile path the connection would use

2008-05-13  Tambet Ingo  <tambet@gmail.com>

	* system-settings/src/nm-polkit-helpers.c (create_polkit_context): Use a 
	single PolKitContext which is shared by all. PolKitContext::unref leaks
	just about everything, including all open file descriptiors and results
	in 99% cpu usage when data arrives to any of the fds that don't belong
	to any context anymore.

2008-05-12  Dan Williams  <dcbw@redhat.com>

	* gfilemonitor/glocaldirectorymonitor.c
	  gfilemonitor/glocaldirectorymonitor.h
		- (g_local_directory_monitor_constructor): actually subscribe to the
			watch
		- (_g_local_directory_monitor_new): ensure that inotify is started up

	* gfilemonitor/glocalfilemonitor.c
	  gfilemonitor/glocalfilemonitor.h
		- (g_local_file_monitor_constructor): actually subscribe to the watch
		- (_g_local_file_monitor_new): ensure that inotify is started up

2008-05-11  Dan Williams  <dcbw@redhat.com>

	* configure.in
		- record PolicyKit version

	* system-settings/src/nm-polkit-helpers.c
		- (check_polkit_privileges): use polkit_context_can_caller_do_action()
			with PolicyKit <= 0.6

2008-05-11  Dan Williams  <dcbw@redhat.com>

	Update Fedora system-settings plugin to support latest API and use
	GFileMonitor rather than home-rolled inotify code.

	* system-settings/plugins/ifcfg-fedora/Makefile.am
	  system-settings/plugins/ifcfg-fedora/common.h
	  system-settings/plugins/ifcfg-fedora/plugin.c
		- Update to latest system settings plugin API; use GIO instead of
			custom inotify code; use NMIfcfgConnection objects instead of
			ConnectionData structures tacked onto NMConnection objects

	* system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.c
	  system-settings/plugins/ifcfg-fedora/nm-ifcfg-connection.h
		- Implement an NMExportedConnection subclass mapping ifcfg files to
			connections

	* system-settings/plugins/ifcfg-fedora/reader.c
	  system-settings/plugins/ifcfg-fedora/reader.h
		- Move ifcfg parsing bits here from parser.c

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
		- Remove; most code moved to reader.c

2008-05-11  Dan Williams  <dcbw@redhat.com>

	* configure.in
	  Makefile.am
	  gfilemonitor/*
		- Add a private copy of the GIO GFileMonitor code, with a custom GFile
			implementation, so that the same change monitoring code can be used
			on systems without glib-2.14 (like Fedora 8)

	* system-settings/plugins/keyfile/Makefile.am
	  system-settings/plugins/keyfile/plugin.c
	  system-settings/plugins/ifcfg-suse/Makefile.am
	  system-settings/plugins/ifcfg-suse/plugin.c
		- Use private gfilemonitor code if GIO is not present

2008-05-09  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/nm-suse-connection.c: Implement
	NMExportedConnection's 'update' and 'delete' and return error with
	descriptive message.

2008-05-08  Dan Williams  <dcbw@redhat.com>

	Patch from Markus Becker <mab@comnets.uni-bremen.de>

	* src/nm-gsm-device.c
	  src/nm-cdma-device.c
		- (real_get_best_auto_connection): implement; allow autoconnection
			to GSM & CDMA devices

2008-05-08  Tambet Ingo  <tambet@gmail.com>

	Use PolicyKit to authorize the system settings' AddConnection method
	and the system settings connections' Update and Delete methods.
	
	* libnm-glib/nm-settings.c (impl_exported_connection_update)
	(impl_exported_connection_delete, nm_exported_connection_update)
	(nm_exported_connection_delete): Return boolean and fill GError
	to notify the callers of the reasons why it might have failed.

	* libnm-glib/nm-dbus-settings-system.c
	(nm_dbus_settings_system_add_connection): Return the error from dbus
	call so that the callers can see why it failed.

	* libnm-glib/nm-dbus-connection.c (update, delete): Update the 
	signatures.

	* system-settings/src/nm-polkit-helpers.[ch]: Implement.

	* system-settings/src/nm-sysconfig-connection.[ch]: Implement. New
	abstract base class that checks PolicyKit permissions.

	* system-settings/src/dbus-settings.c:
	(impl_settings_add_connection): Check the policy before carring out
	the request.

	* system-settings/plugins/keyfile/nm-keyfile-connection.c:
	Inherit from NMSysconfigConnection, check the policies before
	allowing updating or removing.

	* system-settings/plugins/ifcfg-suse/nm-suse-connection.c:
	Inherit from NMSysconfigConnection.

	* introspection/nm-exported-connection.xml: Annotate "Update" and 
	"Delete" methods with async flag so that the implementations can get
	access to DBusGMethodInvocation.

	* system-settings/src/dbus-settings.c 
	(settings_add_connection_check_privileges): Implement.
	(impl_settings_add_connection): Check the privileges before adding a new
	connection. Improve error reporting.

	* introspection/nm-settings-system.xml: Make the 'AddConnection' method
	async so that the implementation can access DBusGMethodInvocation.

	* configure.in: Check for PolicyKit.

	* policy/org.freedesktop.network-manager-settings.system.policy: 
	New file.

	* policy/Makefile.am: Install the policy file.

	* configure.in: Add 'policy' subdir.

2008-05-08  Tambet Ingo  <tambet@gmail.com>

	Rewrite the suse system settings plugin.

	* system-settings/plugins/ifcfg-suse/plugin.c: Rewrite.

	* system-settings/plugins/ifcfg-suse/parser.c: Rewrite.

	* system-settings/plugins/ifcfg-suse/nm-suse-connection.[ch]: Implement.

	* system-settings/plugins/ifcfg-suse/Makefile.am: Add new files to build.

	* system-settings/src/dbus-settings.c: Fix connection reference counting.

	* system-settings/src/main.c (load_plugins): Improve error reporting.

	* system-settings/src/sha1.[ch] Add.

	* system-settings/src/Makefile.am: Add sha1[ch] to build.

2008-05-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/keyfile/reader.c
		- (read_one_setting_value): handle IP address items separately
		- (read_array_of_uint): read IPv4 DNS option as a string array
		- (read_array_of_array_of_uint): read IPv4 address tuples as a string
			array

	* system-settings/plugins/keyfile/writer.c
		- (write_setting_value): handle IP address items separately
		- (write_array_of_uint): handle IPv4 DNS option as a string array,
			not an array of uint, so that it's user-editable
		- (write_array_of_array_of_uint): handle IPv4 address tuples as string
			arrays, so they are user-editable

2008-05-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/keyfile/Makefile.am
		- Change location of the keyfile plugin settings to
			/etc/NetworkManager/system-connections

2008-05-05  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/keyfile/nm-keyfile-connection.[ch]: Implement.

	* system-settings/plugins/keyfile/plugin.c: Work with
	NMKeyfileConnections.

	* system-settings/src/dbus-settings.c: Remove NMSysconfigExportedConnection.
	Plugins are supposed to return NMExportedConnections now and handle the
	updated(), removed(), and GetSecrets().
	Store the internal list of connections in hash table to make it easier
	to find duplicates.

2008-05-07  Tambet Ingo  <tambet@gmail.com>

	* src/backends/NetworkManagerSuSE.c (nm_system_set_hostname): Update
	for multiple IP addresses.

2008-05-07  Tambet Ingo  <tambet@gmail.com>

	Patch from André Lemos.

	* libnm-glib/nm-dbus-settings.c (fetch_connections_done): Fix a memory
	corruption.

2008-05-06  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): clean up; update for changes to
			NMIP4Config to support multiple IP addresses

	* src/NetworkManagerUtils.c
		- (nm_utils_merge_ip4_config): update for multiple IP addresses

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- Store a list of IPv4 address/netmask/gateway tuples
		- (nm_ip4_config_get_gateway, nm_ip4_config_set_gateway,
		   nm_ip4_config_get_netmask, nm_ip4_config_set_netmask,
		   nm_ip4_config_get_broadcast, nm_ip4_config_set_broadcast,
		   nm_ip4_config_set_address): remove
		- (nm_ip4_config_take_address, nm_ip4_config_add_address,
		   nm_ip4_config_replace_address, nm_ip4_config_get_num_addresses):
			new functions; handle multiple IPv4 addresses

	* src/nm-device.c
	  src/ppp-manager/nm-ppp-manager.c
	  src/vpn-manager/nm-vpn-connection.c
	  src/NetworkManagerPolicy.c
	  test/nm-tool.c
	  libnm-glib/libnm-glib-test.c
		- update for changes to NMIP4Config for multiple IPv4 addresses

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_ip4_route): don't add the route if any address
			is on the same subnet as the destination
		- (check_one_address): ignore the exact match, just match family and
			interface index
		- (add_ip4_addresses): add all IPv4 addresses in an NMIP4Config to
			an interface
		- (nm_system_device_set_from_ip4_config): use add_ip4_addresses()
		- (nm_system_vpn_device_set_from_ip4_config): use add_ip4_addresses()

	* introspection/nm-ip4-config.xml
		- Remove 'address', 'gateway', 'netmask', and 'broadcast' properties
		- Add 'addresses' property which is an array of (uuu) tuples of
			address/netmask/gateway

	* libnm-util/nm-setting-ip4-config.c
		- (set_property): use ip-address <-> GValue converters from nm-utils.c

	* libnm-glib/nm-ip4-config.c
	  libnm-glib/nm-ip4-config.h
		- Handle D-Bus interface changes to support multiple IP addresses

2008-05-06  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- (nm_utils_ip4_addresses_from_gvalue,
		   nm_utils_ip4_addresses_to_gvalue): new functions

2008-05-06  Tambet Ingo  <tambet@gmail.com>

	* libnm-glib/nm-dbus-settings.c (fetch_connections_done): Don't leak
	the returned connection paths.

2008-05-05  Tambet Ingo  <tambet@gmail.com>

	* libnm-glib/nm-dbus-settings.c (constructor): Fix the 
	"PropertiesChanged" signal signature.

	* libnm-glib/nm-dbus-connection.c (constructor): Use the common GType
	defined in nm-dbus-glib-types.h.
	Don't register the connection on dbus, we're a proxy class to 
	communicate with an already registered connection over dbus.

2008-04-30  Tambet Ingo  <tambet@gmail.com>

	Implement new subclasses of NMSettings and NMExportedConnection to make
	it easier for the applet to access and modify system settings.

	* libnm-glib/nm-dbus-connection.[ch]:
	* libnm-glib/nm-dbus-settings.[ch]:
	* libnm-glib/nm-dbus-settings-system.[ch]: Implement.

	* libnm-glib/Makefile.am: Add the new files to build, generate some more
	bindings and glue.

	* include/NetworkManager.h: Define the system settings DBus interface.

2008-04-30  Tambet Ingo  <tambet@gmail.com>

	Implement additional C API for exported connections to make them identical
	with the DBus API. Change the (list_connections) virtual function to be
	more usable from C - instead of requiring implementers to return a GPtrArray
	of dbus paths, return a list of connections.

	* libnm-glib/nm-settings.c (nm_exported_connection_class_init): Fix a typo.
	(nm_settings_list_connections):
	(nm_exported_connection_new):
	(nm_exported_connection_update):
	(nm_exported_connection_delete): Implement.

	(impl_settings_list_connections):
	(impl_exported_connection_update):
	(impl_exported_connection_delete): Use the new public functions to make 
	sure the C and dbus interfaces stay in sync.

	* system-settings/src/dbus-settings.c (list_connections): Return a list of
	connections.

2008-05-02  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (dispose): use right unref call on the DBusGConnection

2008-05-02  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (find_terminator): don't compare the whole line, just the size of the
			terminator, since some modems put stuff after the terminator, like
			"CONNECT 9600"

2008-05-01  Dan Williams  <dcbw@redhat.com>

	Patch from Michael Biebl <biebl@debian.org>

	* callouts/Makefile.am
	  callouts/org.freedesktop.nm_dispatcher.service.in
	  system-settings/src/Makefile.am
	  system-settings/src/org.freedesktop.NetworkManagerSystemSettings.service.in
		- use the right install location for dbus-activated stuff

2008-04-30  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (enter_pin): fix setting name passed to applets when asking for a GSM
			PIN or PUK

2008-04-30  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (nm_manager_error_get_type): remove erroneous NULL enum from table

2008-04-30  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-3-ethernet.c
	  src/nm-device-802-11-wireless.c
		- (real_is_up): return true instead of chaining up to unimplemented
			parent method

2008-04-30  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_is_up, nm_system_device_is_up_with_iface): new
			functions to check device flags for IFF_UP

	* src/nm-serial-device.c
		- (real_is_up): remove; NMDevice now returns TRUE if the subclass doesn't
			implement is_up

	* src/nm-device-802-3-ethernet.c
	  src/nm-device-802-11-wireless.c
		- (real_hw_is_up): call nm_system_device_is_up()

	* src/nm-device.c
		- (real_hw_is_up): move to nm_system_device_is_up_with_iface()
		- (real_is_up): remove; nm_device_is_up() returns TRUE if subclass
			does not implement

2008-04-29  Dan Williams  <dcbw@redhat.com>

	Handle HAL dropouts better; allow NM to start up even if HAL isn't up yet.

	* marshallers/nm-marshal.list
		- Add marshaller

	* src/NetworkManager.c
		- (main): let the NMManager handle the NMHalManager

	* src/nm-hal-manager.c
	  src/nm-hal-manager.h
		- convert to a GObject, and emit singals when stuff changes.  Let the
			NMManager handle the signals, instead of the NMHalManager calling
			into the NMManager.  

	* src/nm-manager.c
	  src/nm-manager.h
		- (remove_one_device): consolidate device removals here
		- (dispose): use remove_one_device()
		- (nm_manager_get_device_by_udi): make static
		- (deferred_hal_manager_query_devices): idle handler to query the HAL
			manager for devices at startup or wakeup time
		- (nm_manager_new): create and monitor the HAL manager
		- (hal_manager_udi_added_cb): new function; do what
			nm_manager_add_device() used to do when signalled by the hal manager
		- (hal_manager_udi_removed_cb): new function; do what
			nm_manager_remove_device() used to do when signalled by the hal
			manager
		- (hal_manager_rfkill_changed_cb): handle rfkill changes from the
			hal manager
		- (hal_manager_hal_reappeared_cb): when HAL comes back, remove devices
			in our device list that aren't known to HAL
		- (impl_manager_sleep): on wakeup, re-add devices from an idle handler;
			see comments on nm-hal-manager.c::nm_manager_state_changed() a few
			commits ago
		- (nm_manager_get_device_by_path, nm_manager_is_udi_managed,
		   nm_manager_activation_pending, nm_manager_wireless_enabled,
		   nm_manager_wireless_hardware_enabled,
		   nm_manager_set_wireless_hardware_enabled): remove, unused

2008-04-28  Dan Williams  <dcbw@redhat.com>

	Fix the device up/down ambiguities.  Up/down state used to be a
	conglomeration of hardware state (IFF_UP) and any device-specific things
	(supplicant, periodic timers, etc) that the device used to indicate
	readiness.  Unfortunately, if the hardware was already IFF_UP for some
	reason, then the device specific stuff wouldn't get run, and the device
	would be stuck.

	* src/nm-device.c
	  src/nm-device.h
		- Create hw_is_up, hw_bring_up, and hw_take_down
		- Rename bring_down -> take_down
		- (real_hw_is_up): check interface flags for IFF_UP
		- (nm_device_hw_is_up): let subclasses figure out their own HW state
		- (nm_device_is_up): make static; only used locally
		- (nm_device_hw_bring_up): update the hardware and IPv4 addresses even
			if the device is already up; if the device isn't up, bring it up
		- (nm_device_hw_take_down): just take down hardware
		- (nm_device_bring_up): bring up HW first, then device specific stuff
		- (nm_device_take_down): always deactivate device when called; always
			try to take hardware down too
		- (nm_device_state_changed): take device down when entering unmanaged
			state from a higher state

	* src/nm-device-802-11-wireless.c
		- (real_hw_is_up, real_hw_bring_up, real_hw_take_down): implement; just
			check IFF_UP really
		- (real_take_down, supplicant_iface_state_cb_handler, 
		   supplicant_iface_connection_state_cb_handler,
		   supplicant_mgr_state_cb_handler): fix some messages

	* src/nm-device-802-3-ethernet.c
		- (real_hw_is_up, real_hw_bring_up, real_hw_take_down): implement; just
			check IFF_UP really

2008-04-28  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
	  src/nm-manager.h
		- (nm_manager_error_get_type): add new error
		- (nm_manager_remove_device): don't bother taking down the device here,
			the state change from unmanaging the device will do it
		- (impl_manager_sleep): move nm_manager_sleep() here since nothing else
			uses it; when going to sleep, just unmanage the device instead of
			taking it down, because stuff will cleaned up correctly when the
			device gets unmanaged

2008-04-28  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- (add_initial_devices): convert to a GSourceFunc prototype
		- (nm_manager_state_changed): when coming out of sleep, punt the
			device re-addition to an idle handler to let D-Bus events go out
			first, fixing a potential dbus-glib assert if the old device was
			not yet disposed (due to references held while emitting the D-Bus
			signals) but the new device was found, because the mainloop didn't
			run between signal emission and add_initial_devices()

2008-04-27  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* initscript/paldo/NetworkManager.in
	  initscript/SUSE/networkmanager.in
		- Remove last bits of dhcdbd

2008-04-27  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (link_timeout_cb): don't ask for secrets when disconnected during
			association/authentication phase, drivers are still just too crappy

2008-04-27  Dan Williams  <dcbw@redhat.com>

	* Makefile.am
	  configure.in
	  dispatcher-daemon/Makefile.am
	  dispatcher-daemon/NetworkManagerDispatcher.c
	  initscript/Arch/Makefile.am
	  initscript/Arch/networkmanager-dispatcher.in
	  initscript/Gentoo/Makefile.am
	  initscript/Gentoo/NetworkManagerDispatcher.in
	  initscript/Mandriva/Makefile.am
	  initscript/Mandriva/networkmanagerdispatcher.in
	  initscript/RedHat/Makefile.am
	  initscript/RedHat/NetworkManagerDispatcher.in
	  initscript/SUSE/Makefile.am
	  initscript/SUSE/networkmanager-dispatcher.in
	  initscript/Slackware/Makefile.am
	  initscript/Slackware/rc.networkmanager-dispatcher.in
	  initscript/paldo/Makefile.am
	  initscript/paldo/NetworkManagerDispatcher.in
	  man/Makefile.am
	  man/NetworkManagerDispatcher.8.in
		- Remove the dispatcher daemon

2008-04-27  Dan Williams  <dcbw@redhat.com>

	* callouts/Makefile.am
	  callouts/nm-dispatcher-action.c
	  callouts/nm-dispatcher-action.h
	  callouts/nm-dispatcher.conf
	  callouts/nm-dispatcher.xml
	  callouts/org.freedesktop.nm_dispatcher.service
		- Re-implement the dispatcher as a system-bus activated service that
			NM calls on-demand, rather than an always running daemon

	* src/Makefile.am
		- Add callouts dir to includes to pick up dispatcher defines

	* src/nm-device.c
		- (nm_device_state_changed): call dispatcher on device activated/
			deactivated

	* src/vpn-manager/nm-vpn-connection.c
		- (nm_vpn_connection_set_vpn_state): call dispatcher when VPN connections
			go up and down

	* src/NetworkManagerUtils.c
	  src/NetworkManagerUtils.h
		- (nm_utils_call_dispatcher): helper to call dispatcher

2008-04-27  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerUtils.c
	  src/NetworkManagerUtils.h
		- remove unneeded includes
		- (nm_null_safe_strcmp, nm_ethernet_addresses_are_equal,
		   nm_utils_inet_ip4_address_as_string, nm_timeval_has_passed,
		   nm_timeval_cmp, nm_timeval_add): remove, unused
		- clean up formatting
		- (nm_spawn_process): de-uglify

	* src/nm-device-802-11-wireless.c
		- (get_active_ap): use memcmp() not nm_ethernet_addresses_are_equal()

2008-04-26  Saleem Abdulrasool  <compnerd@compnerd.org>

	* initscript/Gentoo/NetworkManager.in:
		Fix for starting the daemon.

2008-04-25  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_ip4_route): reimplement using libnl, not ioctls

2008-04-25  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.c
		- (nm_system_device_replace_default_ip4_route): new function; a libnl
			implementation of nm_system_device_replace_default_route()

	* src/NetworkManagerPolicy.c
		- (update_default_route): use nm_system_device_replace_default_ip4_route()

	* src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_device_replace_default_route): remove

2008-04-25  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.c
		- (validate_ip4_route): remove; use nl_addr_parse() instead
		- (nm_system_device_add_ip4_route_via_device_with_iface): new function,
			replace nm_system_device_add_route_via_device_with_iface() in the
			backends

	* src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- Remove nm_system_device_add_route_via_device_with_iface()

2008-04-25  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (GET_ONE_DNS): fix parsing of DNS2 & DNS3

2008-04-24  Dan Williams  <dcbw@redhat.com>

	* dispatcher-daemon/NetworkManagerDispatcher.c
		- (nmd_execute_scripts): execute scripts in order as sorted by strcmp()

2008-04-24  Dan Williams  <dcbw@redhat.com>

	* initscript/RedHat/NetworkManager.in
	  initscript/RedHat/NetworkManagerDispatcher.in
		- Be active at runlevel 2
		- Adjust priorities earlier

2008-04-22  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): when checking for a gateway, look at the
			composite IP4 config, not the connection's ip4-config setting, which
			doesn't include DHCP-returned information

2008-04-22  Tambet Ingo  <tambet@gmail.com>

	Implement GKeyFile system settings plugin.
	Implement writing system settings (currently supported only by GKeyFile plugin).

	* system-settings/src/main.c: 
	* system-settings/src/dbus-settings.c: Move the communication with plugins
	from main.c to dbus-settings.c. Makes it possible to talk to all registered
	plugins for adding/updating/removing connections.

	* system-settings/src/nm-system-config-interface.c
	(nm_system_config_interface_add_connection): Implement
	(nm_system_config_interface_update_connection): Implement.
	(nm_system_config_interface_remove_connection): Implement.

	* system-settings/plugins/keyfile/Makefile.am:
	* system-settings/plugins/keyfile/plugin.[ch]:
	* system-settings/plugins/keyfile/writer.[ch]:
	* system-settings/plugins/keyfile/reader.[ch]: Implement.

	* system-settings/plugins/Makefile.am: Add GKeyFile plugin.

	* configure.in: Generate GKeyFile Makefile.

	* libnm-glib/nm-settings.c (impl_exported_connection_get_id): Fix a memory
	corruption, need to duplicate the returned string.
	(impl_exported_connection_update): Implement.
	(impl_exported_connection_delete): Implement.

	* introspection/nm-settings-system.xml: Add "AddConnection" method.

	* introspection/nm-exported-connection.xml: Add "Update" and "Delete" methods.

2008-04-22  Dan Williams  <dcbw@redhat.com>

	Patch from Charles R. Anderson (cra@wpi.edu)

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): don't select devices without a gateway
			as having the default route (rh #437338)

2008-04-21  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.c
	  src/nm-activation-request.h
		- (dispose): ensure to disconnect from the device's state-changed signal
			when appropriate so the signal doesn't get handled by an already
			disposed NMActRequest
		- (device_state_changed): update is_default here too just to make sure
			default is only True when the child device is activated
		- (nm_act_request_set_default): new function

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): set 'default' on the active connection which
			has the default route and DNS

2008-04-21  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (device_state_changed): update routing and DNS when a device goes
			into unmanaged or unavailable states too (like rfkill or carrier loss)

2008-04-21  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
		- Add NMActiveConnectionState enum

	* introspection/nm-active-connection.xml
	  introspection/nm-vpn-connection.xml
		- Add 'State' property for overall active connection state
		- Add 'Default' property, when True means this active connection
			has the default route
		- Add PropertyChanged signals so changes actually go out over the bus

	* src/nm-active-connection.h
		- Add defines for State & Default properties

	* src/nm-activation-request.c
		- Add 'state' and 'default' properties, hook up to device 'state-changed'
			signal to determine active connection state

	* src/vpn-manager/nm-vpn-connection.c
	  src/vpn-manager/nm-vpn-connection.h
	  src/vpn-manager/nm-vpn-manager.c
	  src/vpn-manager/nm-vpn-service.c
		- Rename old 'state' to 'vpn-state'
		- Rename nm_vpn_connection_get_state() -> nm_vpn_connection_get_vpn_state()
		- Add 'state' and 'default' properties, hook up to the vpn connection's
			'vpn-state-changed' signal

	* libnm-glib/nm-active-connection.c
	  libnm-glib/nm-active-connection.h
		- Add new 'state' and 'default' properties and accessors

	* libnm-glib/nm-vpn-connection.c
	  libnm-glib/nm-vpn-connection.h
		- Rename old 'state' property to 'vpn-state'
		- Add new 'state' and 'default' properties and accessors

2008-04-21  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
		- (nm_ip4_config_to_rtnl_addr): fill in the broadcast address if it's
			not specified (rh #443474)

2008-04-20  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerUtils.c
	  src/NetworkManagerUtils.h
		- (nm_utils_merge_ip4_config): new function; merge settings from an
			NMSettingIP4Config to an NMIP4Config object

	* src/nm-device.c
		- (merge_ip4_config): move to NetworkManagerUtils.c

	* src/vpn-manager/nm-vpn-connection.c
		- (nm_vpn_connection_ip4_config_get): merge in user-specified settings
			too

2008-04-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-ppp.h
		- Add 'no-vj-comp' option for TCP header compression
		- baud, mru, mtu, lcp_echo_failure, and lcp_echo_interval are really
			uint32

2008-04-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-ppp.h
	  src/ppp-manager/nm-ppp-manager.c
		- Add 'refuse-pap' and 'refuse-mschapv2' options

2008-04-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-ppp.h
	  src/ppp-manager/nm-ppp-manager.c
		- Remove the 'usepeerdns' option and always request DNS servers from
			the PPP server; the connection chooses to use/override/ignore the
			DNS servers returned from the PPP server

2008-04-18  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-ppp.h
	  src/ppp-manager/nm-ppp-manager.c
		- Remove the 'require-mppc' option, because pppd doesn't support it and
			it seems to have been an erroneous addition to the PPTP plugin in
			the first place (from which the ppp-manager is derived)

2008-04-17  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-pppoe.c
		- (verify): require a PPP setting too

	* src/ppp-manager/nm-ppp-manager.c
		- (nm_ppp_manager_start): fail if no PPP setting is present instead of
			segfaulting

2008-04-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_state_changed): do deactivation and and promotion to
			unavailable here, so that the device gets cleaned up before the
			manager runs and starts emitting signals; do the
			FAILED->DISCONNECTED transition from an idle handler rather than
			immediately to guard against recursion
		- (nm_device_deactivate_quickly, nm_device_dispose): stop the
			FAILED->DISCONNECTED handler if it's scheduled

2008-04-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (state_changed_cb): clear AP list when device transitions to
			unavailable or unmanaged
		- (nm_device_802_11_wireless_dispose): remove redundant set_current_ap()
			since this is already done in device_cleanup()
		- (supplicant_iface_scanned_ap_cb): don't leak new APs when the device
			isn't available or managed
		- (device_cleanup): use remove_all_aps()
		- (remove_all_aps): consolidate code removing all APs

2008-04-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
	  src/nm-serial-device.h
		- (wait_for_reply_got_data): break input into lines, and search each
			line for responses _and_ terminator strings; also make sure that
			the read loop doesn't continue after the timeout is supposed to fire
		- (nm_serial_device_wait_for_reply): take an array of terminators too

	* src/nm-gsm-device.c
	  src/nm-cdma-device.c
		- Send terminators to nm_serial_device_wait_for_reply()

2008-04-16  Dan Williams  <dcbw@redhat.com>

	Patch from 陈鑫 <znscnchen@gmail.com>

	* src/ppp-manager/nm-pppd-plugin.c
		- (get_credentials): return correct value for success; handle case where
			pppd just does some checking but doesn't want a password
		- (plugin_init): make CHAP work too

2008-04-16  Dan Williams  <dcbw@redhat.com>

	Patch from 陈鑫 <znscnchen@gmail.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (create_pppd_cmd_line): fix argument generation when spawning pppd

2008-04-16  Dan Williams  <dcbw@redhat.com>

	Patch from 陈鑫 <znscnchen@gmail.com>

	* src/nm-device-802-3-ethernet.c
		- (real_deactivate_quickly): clear the IP interface name on
			deactivation, otherwise the wrong interface might get used later
			for routing and IP management

2008-04-15  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.c
		- (get_product_and_vendor): handle serial devices correctly
		- (nm_device_update_description): pass device to get_product_and_vendor()

2008-04-15  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
	  src/nm-device.c
		- (nm_generic_device_add_ip6_link_address,
		   nm_system_device_add_ip6_link_address): remove

2008-04-15  Dan Williams  <dcbw@redhat.com>

	Patch from Benoit Boissinot <bboissin+networkmanager@gmail.com>

	* src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
	  src/NetworkManagerSystem.h
		- flush_routes -> flush_ip4_routes
		- flush_addresses -> flush_ip4_addresses

	* src/NetworkManagerSystem.c
	  src/nm-device.c
	  src/vpn-manager/nm-vpn-connection.c
		- flush only IPv4 addresses; don't touch IPv6 routes and addresses

2008-04-15  Dan Williams  <dcbw@redhat.com>

	Remove exposure of wireless-tools mode types in the API.

	* include/NetworkManager.h
		- Define NM80211Mode enum

	* introspection/generic-types.xml
		- Describe NM_802_11_MODE enum
		- Remove IW_MODE_* enum

	* introspection/nm-access-point.xml
	  libnm-glib/nm-access-point.c
	  libnm-glib/nm-access-point.h
		- 'mode' is now of type NM80211Mode, a DBUS_TYPE_UINT

	* introspection/nm-device-802-11-wireless.xml
	  libnm-glib/nm-device-802-11-wireless.c
	  libnm-glib/nm-device-802-11-wireless.h
		- 'mode' is now of type NM80211Mode, a DBUS_TYPE_UINT

	* libnm-util/nm-setting-wireless.c
	  src/NetworkManagerAP.c
	  src/NetworkManagerAP.h
	  src/nm-device-802-11-wireless.c
	  src/nm-device-802-11-wireless.h
	  test/nm-tool.c
		- Use NM80211Mode not IW_MODE_*

2008-04-15  Dan Williams  <dcbw@redhat.com>

	Enhance nm-online based on a patch from Bill Nottingham.

	* test/nm-online.c
		- Add a '-q' option
		- Add help messages and option summary
		- Add long-format options
		- Add a '-x' option to exit if NM isn't running or isn't connecting

2008-04-15  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-setting.c (nm_setting_duplicate): Implement.

	* libnm-util/nm-connection.c (nm_connection_remove_setting): Implement.

2008-04-15  Dan Williams  <dcbw@redhat.com>

	* nm-setting-ip4-config.c
		- (ip4_addresses_from_gvalue): handle NULL address array

	* nm-setting-8021x.c
		- (verify_tls, verify_ttls): warn on failed verification

2008-04-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
		- (automatic_registration): accept "+CREG: 0,0"
		- (automatic_registration_response): fail on "+CREG: 0,0"

2008-04-10  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-setting-wired.c (get_property): Fix a typo.

2008-04-10  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/parser.c (make_wireless_security_setting): 
	Make it compile again by commenting out broken code that at first didn't work and
	now didn't compile either.

2008-04-08  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-object-cache.c
	  libnm-glib/nm-settings.c
	  src/dhcp-manager/nm-dhcp-manager.c
	  system-settings/plugins/ifcfg-fedora/plugin.c
	  system-settings/plugins/ifcfg-suse/plugin.c
	  system-settings/src/nm-system-config-hal-manager.c
	  libnm-util/nm-utils.c
		- Remove usage of GStaticMutex since gcc-4.3 hates it and because we're
			not threadsafe anyway

2008-04-08  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/main.c
		- (load_stuff, device_added_cb, device_removed_cb): device added/removed
			callbacks take a device type too

2008-04-08  Dan Williams  <dcbw@redhat.com>

	The system settings service will now create a new default DHCP connection
	for wired devices that have no existing applicable connection.

	* system-settings/src/nm-system-config-hal-manager.c
	  system-settings/src/nm-system-config-hal-manager.h
		- (nm_system_config_hal_manager_get_type_for_udi): new function

	* system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- (nm_sysconfig_settings_get_connections): new function
		- (nm_sysconfig_settings_is_device_managed): new function

	* system-settings/src/main.c
		- (load_stuff): check for wired devices that need a default connection
		- (get_details_for_udi): get interface and MAC address from HAL
		- (add_default_dhcp_connection): add a default connection for a wired
			device if needed
		- (device_added_cb, device_removed_cb): do the right thing with
			wired devices and their default connections on HAL device events

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.c
	  libnm-glib/nm-device.h
		- Proxy the 'managed' property

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-gsm-device.c
	  src/nm-cdma-device.c
		- (state_changed_cb): when entering UNAVAILABLE state, schedule an idle
			handler to transition to DISCONNECTED

2008-04-07  Dan Williams  <dcbw@redhat.com>

	Patch from Bill Nottingham

	* dispatcher-daemon/NetworkManagerDispatcher.c
		- ignore backup/packaging crufy (rh #440143)

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
		- Remove the DOWN and CANCELLED device states
		- Add UNMANAGED and UNAVAILABLE device states
		- Document the device states

	* introspection/nm-device.xml
	  src/nm-device-interface.c
	  src/nm-device-interface.h
		- Add the 'managed' property

	* test/nm-tool.c
		- (detail_device): print out device state

	* src/NetworkManagerSystem.h
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerMandriva.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerSuSE.c
		- (nm_system_device_get_system_config, nm_system_device_get_disabled
		   nm_system_device_free_system_config): remove; they were unused and
			their functionality should be re-implemented in each distro's
			system settings service plugin 

	* src/nm-gsm-device.c
	  src/nm-gsm-device.h
	  src/nm-cdma-device.c
	  src/nm-cdma-device.h
		- (*_new): take the 'managed' argument

	* src/nm-device.c
		- (nm_device_set_address): remove, fold into nm_device_bring_up()
		- (nm_device_init): start in unmanaged state, not disconnected
		- (constructor): don't start device until the system settings service
			has had a chance to figure out if the device is managed or not
		- (nm_device_deactivate, nm_device_bring_up, nm_device_bring_down):
			don't set device state here, let callers handle that as appropriate
		- (nm_device_dispose): don't touch the device if it's not managed
		- (set_property, get_property, nm_device_class_init): implement the
			'managed' property
		- (nm_device_state_changed): bring the device up if its now managed,
			and deactivate it if it used to be active
		- (nm_device_get_managed, nm_device_set_managed): do the right thing
			with the managed state

	* src/nm-hal-manager.c
		- (wired_device_creator, wireless_device_creator, modem_device_creator):
			take initial managed state and pass it along to device constructors
		- (create_device_and_add_to_list): get managed state and pass to
			type creators

	* src/nm-device-802-11-wireless.c
		- (real_can_activate): fold in most of
			nm_device_802_11_wireless_can_activate()
		- (can_scan): can't scan in UNAVAILABLE or UNMANAGED
		- (link_timeout_cb): instead of deactivating, change device state and
			let the device state handler to it
		- (real_update_hw_address): clean up
		- (state_changed_cb): when entering UNAVAILABLE state, schedule an idle
			handler to transition to DISCONNECTED if the device isn't rfkilled

	* src/nm-device-802-3-ethernet.c
		- (set_carrier): move above callers and get rid of prototype
		- (device_state_changed): when entering UNAVAILABLE state, schedule an
			idle handler to transition to DISCONNECTED if the device has a
			carrier
		- (real_update_hw_address): clean up
		- (link_timeout_cb, ppp_state_changed): change state instead of calling
			deactivation directly as deactivation doesn't change state anymore

	* src/NetworkManagerPolicy.c
		- (schedule_activate_check): yay, remove wireless_enabled hack since
			the NMManager and wireless devices work that out themselves now
		- (device_state_changed): change to a switch and update for new device
			states
		- (device_carrier_changed): remove; device handles this now through
			state changes
		- (device_added): don't care about carrier any more; the initial
			activation check will happen when the device transitions to
			DISCONNECTED

	* src/nm-manager.c
		- (dispose): clear unmanaged devices
		- (handle_unmanaged_devices): update unmanaged device list and toggle
			the managed property on each device when needed
		- (system_settings_properties_changed_cb): handle signals from the
			system settings service
		- (system_settings_get_unmanaged_devices_cb): handle callback from
			getting the unmanaged device list method call
		- (query_unmanaged_devices): ask the system settings service for its
			list of unmanaged devices
		- (nm_manager_name_owner_changed, initial_get_connections): get unmanaged
			devices
		- (manager_set_wireless_enabled): push rfkill state down to wireless
			devices directly and let them handle the necessary state transitions
		- (manager_device_state_changed): update for new device states
		- (nm_manager_add_device): set initial rfkill state on wireless devices
		- (nm_manager_remove_device): don't touch the device if it's unmanaged
		- (nm_manager_activate_connection): return error if the device is
			unmanaged
		- (nm_manager_sleep): handle new device states correctly; don't change
			the state of unavailable/unmanaged devices

	* libnm-glib/nm-device-802-11-wireless.c
		- (state_changed_cb): update for new device states

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* marshallers/nm-marshal.list
		- Add VOID:STRING,UINT marshaller for system settings HAL manager

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/main.c
		- (unmanaged_devices_changed_cb, register_plugin): proxy changes from
			plugins to the dbus settings object
		- (load_stuff): start the dbus service after grabbing unmanaged devices
		- (dbus_reconnect, dbus_cleanup): make HAL manager aware of dbus events
		- (log_handler, logging_setup, logging_shutdown): log output to syslog
		- (main): switch default logging to syslog with a 'debug' option to
			output to console; start up the HAL manager

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-settings-system.xml
	  introspection/Makefile.am
		- Define the unmanaged devices interface for the system settings service

	* system-settings/src/nm-system-config-hal-manager.c
	  system-settings/src/nm-system-config-hal-manager.h
	  system-settings/src/nm-system-config-hal-manager-private.h
	  system-settings/src/Makefile.am
		- Add a lightweight HAL manager object for tracking network devices for
			the purpose of determining unmanaged devices and which devices need
			the default DHCP connections

	* system-settings/src/nm-system-config-interface.c
	  system-settings/src/nm-system-config-interface.h
		- (nm_system_config_interface_init): add the HAL manager as an argument
		- (nm_system_config_interface_get_unmanaged_devices): implement
		- Define 'unmanaged-devices-changed' signal

	* system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- Implement the unmanaged devices interface; some cleanups

	* system-settings/plugins/ifcfg-suse/plugin.c
		- Fixup for plugin interface changes

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (get_ether_device_udi): new function; find the device that has
			a specified MAC address and return its UDI
		- (get_udi_for_connection): new function; try to find the specific
			device a connection is locked to, if any
		- (device_added_cb, device_removed_cb): update unmanaged device list in
			response to HAL events
		- (get_unmanaged_devices): new function; return unmanaged device list
		- (build_one_connection): set the connection's locked device, if any
		- (write_auto_wired_connection): remove
		- (kill_old_auto_wired_file): remove the ifcfg-Auto Wired file if found
		- (handle_connection_changed): alert listeners that the unmanaged device
			list has changed
		- (init): fixup for plugin interface changes, implement unmanaged devices

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
		- (connection_data_free): clean up connection UDI

2008-04-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (make_ip4_setting): fix parsing of DNS servers

2008-04-05  Dan Williams  <dcbw@redhat.com>

	* Makefile.am
	  configure.in
	  marshallers/Makefile.am
	  marshallers/nm-marshal-main.c
	  marshallers/nm-marshal.list
		- Consolidate marshallers

	* libnm-glib/nm-marshal-main.c
	  libnm-glib/nm-marshal.list
	  src/marshallers/Makefile.am
	  src/marshallers/nm-marshal-main.c
	  src/marshallers/nm-marshal.list
		- Remove

	* libnm-glib/Makefile.am
	  src/Makefile.am
	  src/dhcp-manager/Makefile.am
	  src/ppp-manager/Makefile.am
	  src/supplicant-manager/Makefile.am
	  src/vpn-manager/Makefile.am
		- Use consolidated marshallers

2008-04-04  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
	  src/nm-hal-manager.h
		- (hal_init): don't look for hardware here
		- (nm_hal_manager_start): new function; look for hardware here instead,
			which can be done at a later time than hal_init()

	* src/NetworkManager.c
		- (main): start HAL manager after entering the main loop

2008-04-03  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
	    - (nm_exported_connection_get_id): new function
		- (impl_exported_connection_get_id): use nm_exported_connection_get_id()

2008-04-02  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.c
	  src/nm-device-interface.h
	  src/nm-device.c
	  src/nm-device.h
		- Rename check_connection_conflicts() to check_connection_compatible()

	* src/nm-device-802-11-wireless.c
		- (real_check_connection_conflicts): remove
		- (real_check_connection_compatible): implement; match MAC address

	* src/nm-device-802-3-ethernet.c
		- (real_check_connection_conflicts): remove
		- (real_check_connection_compatible): implement; match MAC address
		- (real_get_best_auto_connection): correctly handle PPPoE cases

	* src/nm-manager.c
		- (check_connection_allowed): remove; unused until PolicyKit integration
		- (internal_activate_device): check whether the connection is compatible
			with the device before trying to activate it

2008-04-02  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (read_mac_address): new function; read in MAC address and stuff it
			into the connection
		- (add_one_wep_key): remove debug spew
		- (make_wireless_security_setting): validate the default TX key; don't
			add the wireless-security setting if the connection doesn't need
			security; don't leak the keys shvarFile on error cases
		- (make_wireless_setting, make_wired_setting): populate device's MAC
			address

2008-04-02  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-connection.h
		- (set_property, get_property, nm_setting_connection_class_init): remove
			the 'lockdown' property; it's functionality will be replaced by
			PolicyKit instead

2008-04-01  Dan Williams  <dcbw@redhat.com>

	Patch from Per Øyvind Karlsen <peroyvind@mandriva.org>

	* configure.in
	  initscript/Makefile.am
	  initscript/Mandriva/Makefile.am
	  initscript/Mandriva/networkmanager.in
	  initscript/Mandriva/networkmanagerdispatcher.in
	  src/backends/Makefile.am
	  src/backends/NetworkManagerMandriva.c
	  system-settings/plugins/Makefile.am
		- Add Mandriva support

2008-03-31  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-service.c
		- (nm_vpn_service_daemon_exec): add an error argument so that spawn
			errors can be passed back to the caller; also no longer scheduled
			as an idle handler, but called directly; and bump up VPN service
			spawn timeout, 2s is really short
		- (nm_vpn_service_activate): don't schedule the VPN service activation,
			but call it directly so that errors are reported on return from
			ActivateConnection() and don't get lost.  If scheduled as an idle
			handler, clients don't have the time to query NM for the new VPN
			connection's properties before the VPN connection is torn down again
			if the service couldn't be launched, and therefore launch errors
			get lost.

2008-03-31  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-connection.c
		- (device_state_changed): send correct state on device failure too
		- (plugin_state_changed): failed state means unexpected disconnection,
			thus if the service goes away while the VPN connection is activated
			that's a failure too

2008-03-31  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-manager.c
	  src/vpn-manager/nm-vpn-manager.h
		- Make VPNManager errors more available; add a service-start-failed error

2008-03-31  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
	  libnm-glib/nm-client.h
		- (activate_cb): pass the new active connection to callback; fix
			message when no callback is specified

2008-03-30  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless-security.c
		- (need_secrets): only require key0 if the transmit key index is also
			0
		- (verify): reject non-NULL but zero-length WEP keys; these are invalid

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-8021x.c
	  libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-vpn-properties.c
	  libnm-util/nm-setting-vpn.c
	  libnm-util/nm-setting-wireless-security.c
	  libnm-util/nm-setting-wireless.c
	  libnm-util/nm-utils.c
	  src/dhcp-manager/nm-dhcp-manager.c
	  src/nm-activation-request.c
	  src/nm-ip4-config.c
	  src/nm-manager.c
	  src/nm-properties-changed-signal.c
	  src/ppp-manager/nm-pppd-plugin.c
	  src/supplicant-manager/nm-supplicant-interface.c
	  src/vpn-manager/nm-vpn-connection.c
		- consistently use nm-dbus-glib-types.h

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-connection.c
		- (nm_vpn_connection_class_init): PROP_SPECIFIC_OBJECT should be boxed,
			not string

	* src/nm-activation-request.c
		- (nm_act_request_class_init): PROP_SPECIFIC_OBJECT should be boxed,
			not string

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.c
		- (access_point_added_proxy): create new APs if not found

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
		- (proxy_name_owner_changed): tell wireless devices about rfkill state
			before freeing them

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- Fix parsing of WEP keys; ifcfg files use indexes [1...4] rather than
			[0...3]; also handle KEY correctly in combination with DEFAULTKEY

2008-03-29  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (get_one_wep_key, make_wireless_security_setting): handle "KEY" too

2008-03-27  Dan Williams  <dcbw@redhat.com>

	* nm-object.c
		- (nm_object_queue_notify): don't notify multiple times for the same
			property

	* nm-object-private.h
		- (handle_ptr_array_return): return NULL if the given array is NULL or
			if it has zero elements

	* nm-ip4-config.c
		- (finalize): use g_ptr_array_foreach() when freeing domains
		- (nm_ip4_config_get_domains): use handle_ptr_array_return()

	* nm-active-connection.c
		- (nm_active_connection_get_devices): use handle_ptr_array_return()

	* nm-device-802-11-wireless.c
	  nm-device-802-11-wireless.h
		- (nm_device_802_11_wireless_get_access_points): return const; use
			handle_ptr_array_return()

	* nm-types.c
		- (nm_object_array_demarshal): always create an array, even of length
			zero, to distinguish between "NM returned no items" and "haven't
			asked NM yet"

	* nm-client.c
		- (dispose): free active connections too
		- (proxy_name_owner_changed): free active connections too when NM goes
			away
		- (nm_client_get_devices): return const; use handle_ptr_array_return()
		- (nm_client_get_active_connections): use handle_ptr_array_return()

2008-03-26  Dan Williams  <dcbw@redhat.com>

	Rework VPN connection handling for a more consistent D-Bus API.  The
	VPNManager object has been removed, and active VPN connections are now the
	same as any other active connection.  The Manager object's ActivateConnection
	and DeactivateConnection methods are used to start and stop a VPN connection,
	and the VPNConnection objects are subclasses of the ActiveConnection objects.
	When activating a VPN connection, pass the path of the active connection
	to which the VPN connection is tied in the 'specific_object' argument.

	Consequently, the libnm-glib API has been reworked to match this arrangement,
	with the VPNManager object removed, and the NMVPNConnection objects now
	being subclasses of NMActiveConnection.

2008-03-25  Dan Williams  <dcbw@redhat.com>

	Patch from Björn Martensen <bjoern.martensen@gmail.com>

	* initscript/Arch/networkmanager.in
	  initscript/Arch/networkmanager-dispatcher.in
		- Updates for Arch Linux (gnome.org #523701)

2008-03-25  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-ip4-config.c
	  libnm-glib/nm-active-connection.c
	  libnm-glib/nm-access-point.c
		- Use nm_object_queue_notify() instead of g_object_notify()

	* libnm-glib/nm-device.c
		- (demarshal_ip4_config): distinguish between successful but missing
			ip4-config request, and unsuccessful and missing ip4-config request
		- (nm_device_get_ip4_config): don't try to demarshal a NULL ip4-config
			path
		- Use nm_object_queue_notify() instead of g_object_notify()

	* libnm-glib/nm-device-802-11-wireless.c
		- (demarshal_active_ap): distinguish between successfull but missing
			active-ap request, and unsuccessful and missing active-ap request
		- (dispose, clean_up_aps): consolidate AP list and active AP clearing
			code
		- (nm_device_802_11_wireless_set_wireless_enabled): add a private hook
			for the NMClient to notify the device that wireless is disabled,
			and therefore to clear the AP list and active AP
		- Use nm_object_queue_notify() instead of g_object_notify()

	* libnm-glib/nm-client.c
		- (poke_wireless_devices_with_rf_status): new function
		- (update_wireless_status): notify wireless devices of the rfkill status
			so they can clean up if needed
		- Use nm_object_queue_notify() instead of g_object_notify()

2008-03-25  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-object.c
	  libnm-glib/nm-object-private.h
		- (nm_object_queue_notify): add helper to batch & postpone GObject notify
			signals to an idle handler
		- (nm_object_get_property): add a timeout to the D-Bus method call

2008-03-25  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-device-cdma.xml
	  introspection/nm-device-gsm.xml
	  introspection/Makefile.am
	  introspection/all.xml
		- Add introspection for CDMA and GSM devices for PropertiesChanged signal

	* src/nm-gsm-device.h
	  src/nm-gsm-device.c
	  src/nm-cdma-device.h
	  src/nm-cdma-device.c
	  src/Makefile.am
		- Implement PropertiesChanged signals

	* libnm-glib/nm-cdma-device.c
	  libnm-glib/nm-cdma-device.c
		- Attach to PropertiesChanged signals

2008-03-24  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
		- (client_device_added_proxy): add new devices to the internal device
			list so they appear to clients

2008-03-24  Dan Williams  <dcbw@redhat.com>

	Massive fixup of libnm-glib to:
	a) have all objects (with the exception of VPN) cache their properties and
		update them asynchronously on PropertiesChanged signals from NM
	b) return internal const data for most attributes/properties instead of
		allocated values that the caller must free
	c) cache wrapped objects such that a given D-Bus path will always map to the
		same GObject returned by libnm-glib
	d) remove a few signals and move them to GObject property notifications
	e) match recent NM D-Bus API changes for activation/deactivation
	f) remove some private functions from libnm-glib headers

2008-03-20  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (nm_manager_update_state, manager_device_state_changed,
		   nm_manager_activate_device, connection_added_default_handler,
		   impl_manager_activate_connection, impl_manager_deactivate_connection):
			queue PropertyChanged singals when the active connections change

2008-03-20  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-manager.xml
	  introspection/nm-manager-client.xml
		- (ActivateConnection): return the object path of the active connection
			on success
		- (GetActiveConnections): remove
		- (DeactivateConnection): new function; deactivate a currently active
			connection
		- Add an ActiveConnections property which returns an array of
			active connection object paths

	* introspection/nm-device.xml
		- (Deactivate): remove

	* introspection/all.xml
		- Add ActiveConnection introspection

	* introspection/nm-active-connection.xml
		- Add the ActiveConnection object

	* include/NetworkManager.h
		- Add the Connection.Active D-Bus interface

	* src/nm-device-interface.c
		- (impl_device_deactivate): remove

	* src/nm-activation-request.c
	  src/nm-activation-request.c
	  src/Makefile.am
		- Implement the Connection.Active D-Bus interface

	* src/nm-manager.c
		- (get_property, nm_manager_class_init): add ACTIVE_CONNECTIONS property
		- (nm_manager_activate_device): return the active connection path
		- (connection_added_default_handler, impl_manager_activate_connection):
			return the active connection to the caller
		- (add_one_connection_element, impl_manager_get_active_connections):
			remove
		- (impl_manager_deactivate_connection): new function; deactivate an
			active connection

	* libnm-glib/nm-device.c
	  libnm-glib/nm-device.h
		- Remove Deactivate() function

2008-03-19  Dan Williams  <dcbw@redhat.com>

	* introspection/nm-manager.xml
	  introspection/nm-manager-client.xml
		- Rename the ActivateDevice method to ActivateConnection to better
			reflect it's usage; it's arguments get reordered a bit too
		- Convert GetActiveConnections method return from a struct to a dict

	* include/NetworkManager.h
		- Define the dict keys for return value of GetActiveConnections

	* src/nm-manager.c
		- impl_manager_activate_device -> impl_manager_activate_connection
		- (add_one_connection_element): return a populated hash table, not
			a structure

	* libnm-glib/nm-client.c
	  libnm-glib/nm-client.h
		- nm_client_activate_device -> nm_client_activate_connection
		- nm_client_free_active_connection_element -> nm_client_free_active_connections_element
		- (nm_client_get_active_connections): return a GSList of GHashTables,
			instead of the custom structures.  Each element of the returned list
			must be freed with nm_client_free_active_connections_element()

2008-03-18  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
	  system-settings/plugins/ifcfg-fedora/plugin.c
		- Read settings from /etc/sysconfig/network-scripts/ instead of using
			profiles.  DNS servers and searches must now be stored in the ifcfg
			files themselves

2008-03-18  Tambet Ingo  <tambet@gmail.com>

	* src/ppp-manager/nm-ppp-manager.c (nm_ppp_manager_update_secrets): Don't
	print out username and password, it's supposed to be a secret.

	* src/nm-device-802-3-ethernet.c (ppp_state_changed): Handle authentication 
	request and set the device state accordingly.

2008-03-18  Tambet Ingo  <tambet@gmail.com>

	* src/nm-device-802-3-ethernet.c: Implement wired 802.1x authentication.

	* libnm-util/nm-setting-wireless-security.h: Fix a typo.

2008-03-18  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-connection.c
		- (get_secrets_cb): handle new GetSecrets return format

2008-03-18  Dan Williams  <dcbw@redhat.com>

	Adapt system settings service for split 802.1x.

	* system-settings/src/nm-system-config-interface.h
		- clarify return value of get_secrets()

	* system-settings/src/dbus-settings.c
		- (string_to_gvalue, destroy_gvalue, add_one_secret_to_hash): remove
		- (check_for_secrets): check if there actually secrets returned by a
			plugin
		- (exported_connection_get_secrets): just return the plugin-returned
			hash of settings' secrets if it looks valid

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (get_secrets): add split secrets with correct format to reply hash

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
		- (copy_one_cdata_secret, connection_data_copy_secrets,
		   connection_data_free, connection_data_add): keep secrets for
			different settings in different hashes

2008-03-17  Tambet Ingo  <tambet@gmail.com>

	Clean up activating device deactivation.

	* src/nm-device.c (real_activation_cancel_handler): Remove. The same thing
	should be done whether the device activation gets cancelled or the device
	is just getting deactivated.
	(nm_device_activation_cancel): Remove.
	(nm_device_deactivate_quickly): Handle the case where device is activating.

	* src/nm-device-802-11-wireless.c (real_activation_cancel_handler): Remove.
	It does the exact same thing as real_deactivate_quickly().

2008-03-17  Dan Williams  <dcbw@redhat.com>

	Split the 802.1x bits out of the wireless-security setting so they are
	generalized enough for wired 802.1x to use too.

	* introspection/nm-exported-connection.xml
		- GetSecrets now returns 'a{sa{sv}}' (a hash of settings hashes) instead
			of just a hash of the secrets for one setting

	* libnm-util/nm-setting-wireless-security.c
	  libnm-util/nm-setting-wireless-security.h
		- Remove 802.1x-specific stuff
		- Added leap-username and leap-password properties for old-school LEAP

	* src/nm-device.c
	  src/nm-device.h
		- (connection_secrets_updated_cb): take a list of updated settings names,
			not just one

	* src/supplicant-manager/nm-supplicant-config.c
	  src/supplicant-manager/nm-supplicant-config.h
		- (nm_supplicant_config_add_setting_wireless_security): remove 802.1x
			specific stuff; fix for updated LEAP bits; punt 802.1x stuff
			to nm_supplicant_config_add_setting_8021x()
		- (nm_supplicant_config_add_setting_8021x): add an 802-1x setting to
			the supplicant config

	* src/nm-device-802-11-wireless.c
		- (build_supplicant_config): pass in the 802.1x setting too, if any
		- (real_connection_secrets_updated): take a list of updated settings
			names, not just one

	* src/nm-device-802-3-ethernet.c
	  src/nm-cdma-device.c
	  src/nm-gsm-device.c
		- (real_connection_secrets_updated_cb): take a list of updated settings
			names, not just one

	* src/nm-activation-request.c
	  src/nm-activation-request.h
		- (nm_act_request_class_init): the 'connection-secrets-updated' signal
			now passes a list of updated settings names, not just one
		- (update_one_setting): new function; handle one updated setting
		- (get_secrets_cb): handle multiple settings returned from the
			settings service; have to be careful of ordering here as there are
			some dependencies between settings (ex. wireless-security and 802.1x
			in some cases)

	* src/marshallers/nm-marshal.list
		- new marshaller for connection-secrets-updated signal

	* libnm-util/nm-setting-8021x.c
		- Add back the 'pin' and 'psk' settings, for EAP-SIM and EAP-PSK auth
			methods
		- (verify): a valid 'eap' property is now required

	* libnm-util/nm-connection.c
		- (register_default_settings): add priorities to settings; there are
			some dependencies between settings, and during the need_secrets
			calls this priority needs to be respected.  For example, only the
			wireless-security setting knows whether or not the connection is
			going to use 802.1x or now, so it must be asked for secrets before
			any existing 802.1x setting is
		- (nm_connection_lookup_setting_type): expose

	* libnm-util/nm-setting-wireless.c
		- (verify): should verify even if all_settings is NULL; otherwise won't
			catch the case where there is missing security

	* libnm-util/nm-setting-wireless-security.c
		- Remove everything to do with 802.1x
		- Add old-school LEAP specific properties for username and password
		- (need_secrets): rework LEAP secrets checking
		- (verify): rework for LEAP and 802.1x verification

2008-03-17  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (auto_activate_device): always remove the current activation check
			from the pending activation list, otherwise when the policy gets
			destroyed on NM exit it will attempt to free the already freed
			activation check

2008-03-14  Tambet Ingo  <tambet@gmail.com>

	* src/backends/NetworkManagerSlackware.c 
	(nm_system_device_setup_static_ip4_config): Remove, it's unused.

	* src/backends/NetworkManagerSuSE.c: Add missing includes.

2008-03-14  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (nm_device_interface_get_iface): g_object_get() will return an
			allocated value, so this function must not return const
		- (nm_device_interface_activate): free returned iface

2008-03-14  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/Makefile.am: Add new files to build.

	* libnm-util/nm-connection.c: Register NMSetting8021x.

	* libnm-util/nm-setting-8021x.c
	* libnm-util/nm-setting-8021x.h: Implement.

2008-03-14  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/Makefile.am: Add new files to build.

	* libnm-util/nm-connection.c: Register NMSetting8021x.

	* libnm-util/nm-setting-8021x.c
	* libnm-util/nm-setting-8021x.h: Implement.

2008-03-14  Tambet Ingo  <tambet@gmail.com>

	* src/NetworkManagerPolicy.c (auto_activate_device): Don't leak device and
	data.

2008-03-14  Dan Williams  <dcbw@redhat.com>

	* include/wireless-helper.h
	  include/Makefile.am
		- One place for all the junk needed for #including wireless.h

	* test/nm-tool.c
	  src/NetworkManagerAP.c
	  src/wpa.c
	  src/Makefile.am
	  libnm-util/nm-utils.c
	  libnm-util/nm-setting-wireless.c
	  libnm-glib/nm-device-802-11-wireless.c
	  libnm-glib/nm-access-point.c
	  libnm-glib/libnm-glib-test.c
		- include wireless-helper.h, not iwlib.h

	* configure.in
		- Don't need libiw really, just need to check for wireless.h

	* src/kernel-types.h
		- Remove; used types moved into wpa.c

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_update_signal_strength,
		   real_get_generic_capabilities, nm_device_802_11_wireless_get_mode,
		   nm_device_802_11_wireless_set_mode,
		   nm_device_802_11_wireless_get_frequency,
		   nm_device_802_11_wireless_get_ssid,
		   nm_device_802_11_wireless_set_ssid,
		   nm_device_802_11_wireless_get_bitrate,
		   nm_device_802_11_wireless_get_bssid,
		   nm_device_802_11_wireless_disable_encryption): use ioctl() directly
			instead of iwlib functions

2008-03-14  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (impl_ppp_manager_need_secrets): since it's asynchronous now, it
			should only take the DBusGMethodInvocation argument, not user/pass
			too.  With dbus-glib, async functions only take 2 C arguments since
			the real dbus method arguments get passed back with
			dbus_g_method_return()

2008-03-13  Tambet Ingo  <tambet@gmail.com>

	* system-settings/plugins/ifcfg-suse/plugin.c (update_default_routes): 
	Adapt the changes of NMSettingIP4Config.

2008-03-13  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerUtils.c
	  src/NetworkManagerUtils.h
		- (nm_ether_ntop): replacement for iw_ether_ntop()

	* src/NetworkManagerAP.c
	  src/nm-device-802-11-wireless.c
	  src/nm-device-802-3-ethernet.c
		- s/iw_ether_ntop/nm_ether_ntop/g

2008-03-13  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): never set the default route through an
			IPv4LL addressed device

2008-03-13  Dan Williams  <dcbw@redhat.com>

	* NetworkManagerUtils.c
	  NetworkManagerUtils.h
		- Remove NMSock stuff
		- Remove the completion stuff

	* nm-device.c
	  nm-device.h
	  NetworkManager.c
	  NetworkManagerSystem.c
	  autoip.c
	  nm-device-802-11-wireless.c
	  nm-device-802-3-ethernet.c
		- Remove NMSock and completion stuff
		- Remove nm_ioctl_info()

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (merge_ip4_config): avoid duplicates

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- Remove 'manual' and 'autoip' properties
		- Add 'method' property
		- (verify): fix verification with 'method'
		- (finalize): free 'method'
		- (set_property, get_property, nm_setting_ip4_config_class_init): fix
			up for 'method'

	* src/nm-device.c
		- (real_act_stage3_ip_config_start): check IP4Config method
		- (nm_device_new_ip4_autoip_config): add a note about not sucking in
			the future
		- (merge_ip4_config): IP settings are valid with DHCP too
		- (real_act_stage4_get_ip4_config): handle all IP4Config methods
		- (real_act_stage4_ip_config_timeout): don't do autoip on DHCP timeout

	* src/nm-device-802-11-wireless.c
		- (real_act_stage3_ip_config_start): remove; autoip only on demand
		- (real_act_stage4_get_ip4_config): just chain up to parent; autoip
			only on demand

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-suse/parser.c
		- (make_ip4_setting): fix up for 'method'

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
		- (get_ifcfg_name): ignore more file suffixes
		- (is_wireless_device): fix check for ifcfgs that have no TYPE

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* configure.in
		- Bring in the bits of gnome-common we actually use (all 15 lines)

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (write_auto_wired_connection): new function; write out an auto
			wired connection file since the applet isn't doing it any more
		- (reload_all_connections): write out the auto wired connection file
			if there aren't any wired connections already
		- (init): don't leak a GError

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.c
		- (nm_device_interface_activate): print the ID of the connection
			that's about to be activated

2008-03-12  Dan Williams  <dcbw@redhat.com>

	Harmonize the 802.11 bitrate API

	* introspection/nm-access-point.xml
		- 'Rate' -> 'MaxBitrate'; clarify units

	* introspection/nm-device-802-11-wireless.xml
		- Clarify units of 'Bitrate'

	* src/NetworkManagerAP.c
	  src/NetworkManagerAP.h
		- (set_property, get_property, nm_ap_class_init): rename 'rate'
			property to 'max-bitrate'
		- (foreach_property_cb): convert rate to Kb/s

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_get_bitrate): return rate in Kb/s

	* libnm-glib/nm-access-point.c
	  libnm-glib/nm-access-point.h
		- 'rate' -> 'max-bitrate'

	* test/nm-tool.c
	  libnm-glib/libnm-glib-test.c
		- Fix up for these changes

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_set_ip4_config): don't send property notifications when
			the ip4 config is set to NULL; it causes a PropertyChanged signal
			which dbus-glib can't parse because the value is NULL, which isn't
			a legal object path.  Setting the IP4 config to NULL is only
			valid when deactivating a device anyway, so the device state change
			will alert listeners that the ip4 config is invalid.

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-properties-changed-signal.c
		- (add_to_string): better handling of NULL objects

2008-03-12  Dan Williams  <dcbw@redhat.com>

	Move the 'carrier' property from NMDevice to NMDevice8023Ethernet;
	convert the libnm-glib NMDevice8023Ethernet to cached properties

	* introspection/nm-device-802-3-ethernet.xml
		- New 'Carrier' property
		- New 'PropertiesChanged' signal

	* introspection/nm-device.xml
		- Remove 'Carrier' property
		- Remove 'CarrierChanged' signal

	* src/nm-device-interface.c
	  src/nm-device-interface.h
		- (nm_device_interface_init): remove 'carrier' property and
			'carrier-changed' signal

	* src/nm-device.c
	  src/nm-device.h
		- (nm_device_get_carrier, nm_device_set_carrier): remove
		- (nm_device_activate_stage5_ip_config_commit): don't bother updating
			the link here; wired device will handle that
		- (handle_dhcp_lease_change): don't bother updating link here
		- (get_property, nm_device_class_init): remove carrier property

	* src/nm-device-802-11-wireless.c
		- (real_update_link, nm_device_802_11_wireless_class_init): remove
			real_update_link(); wireless devices don't use carrier at all
		- (link_timeout_cb, supplicant_iface_state_cb_handler,
		   supplicant_iface_connection_state_cb_handler,
		   supplicant_mgr_state_cb_handler): remove anything to do with carrier

	* src/nm-device-802-3-ethernet.c
	  src/nm-device-802-3-ethernet.h
		- (nm_device_802_3_ethernet_carrier_on,
		   nm_device_802_3_ethernet_carrier_off, constructor): use set_carrier()
			instead of nm_device_set_carrier()
		- (device_state_changed): update link from sysfs on activation;
			replaces real_update_link()
		- (real_update_link): remove, replaced by device_state_changed()
		- (nm_device_802_3_ethernet_get_carrier, set_carrier): new functions
		- (nm_device_802_3_ethernet_get_speed): move up with other getters/setters
		- (real_get_generic_capabilities, real_can_interrupt_activation): use
			new get_carrier function
		- (get_property): add 'carrier' property
		- (nm_device_802_3_ethernet_class_init): add 'carrier' property and
			hook into property-changed signal helper

	* src/NetworkManagerPolicy.c
		- (device_carrier_changed): will only ever be called with a wired device
		- (device_added): only hook up to carrier-changed for wired devices

	* libnm-glib/nm-device.c
	  libnm-glib/nm-device.h
		- (constructor, nm_device_class_init): remove carrier-changed signal
		- (device_carrier_changed_proxy): remove; unused
		- (nm_device_get_carrier): remove; carrier a property of wired devices

	* libnm-glib/nm-device-802-3-ethernet.c
	  libnm-glib/nm-device-802-3-ethernet.h
		- Convert to cached properties like AP and Wireless objects
		- (nm_device_802_3_ethernet_get_hw_address): now returns a 'const char *'
			instead of a 'char *', return value should not be freed
		- (nm_device_802_3_ethernet_get_carrier): return current carrier status
		- (constructor): hook into properties-changed helper
		- (set_property, get_property): new functions
		- (nm_device_802_3_ethernet_class_init): export GObject properties

	* test/nm-tool.c
		- (detail_device): strdup the wired hardware address too since it's
			cached now

	* libnm-glib/libnm-glib-test.c
		- (dump_wired): strdup the wired hardware address too since it's
			cached now

2008-03-12  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
	  libnm-util/nm-setting-ip4-config.h
		- (set_property, get_property, nm_setting_ip4_config_class_init): add
			the 'autoip' property from the spec

2008-03-11  Dan Williams  <dcbw@redhat.com>

	* src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
		- (nm_generic_device_get_use_dhcp): remove

2008-03-11  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_deactivate): don't need to munge DNS here; that gets done
			already in nm_device_set_ip4_config()
		- (handle_dhcp_lease_change): fail the device if setting the IP4Config
			due to a DHCP rebind fails
		- (nm_device_set_ip4_config): send property notifications when the
			ip4 config changes
		- (get_property): only report IP4Config property during valid states

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): ignore devices that don't have an ip4
			config; add parameter 'force_update' to allow callers to specify
			that changes should be made even if the default device doesn't change
		- (device_ip4_config_changed): update DNS and routing when the device's
			IP4Config changes, like for DHCP updates
		- (device_added): listen for ip4-config property changes

2008-03-11  Dan Williams  <dcbw@redhat.com>

	Fix address handling as a result of DHCP rebind/renew/reboot.

	* src/NetworkManagerSystem.c
		- (check_one_address): delete an address if it doesn't match a given
			one for the same interface
		- (nm_system_device_set_from_ip4_config): don't flush the default route,
			be smarter about flushing addresses (only flush ones that don't
			match the one we're about to apply)

	* src/backends/NetworkManagerDebian.c
	  src/backends/NetworkManagerSuSE.c
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerGentoo.c
		- (nm_system_delete_default_route): remove

	* src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
		- (nm_generic_enable_loopback): fix the loopback device label
		- (nm_generic_delete_default_route): remove; no longer used

2008-03-11  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.h
		- Delimit property name words with '-', otherwise g_object_notify()
			doesn't work the way we expect

2008-03-11  Tambet Ingo  <tambet@gmail.com>

	* src/nm-hal-manager.c (create_device_and_add_to_list): Don't ignore USB devices.

2008-03-11  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (update_routing_and_dns): don't change anything if the default device
			hasn't changed; print something out when switching the default route
			and DNS

2008-03-10  Tambet Ingo  <tambet@gmail.com>

	Implement PPPoE.

	* src/ppp-manager/nm-ppp-manager.c (create_pppd_cmd_line): Use PPPoE service
	setting. Use "nic-$eth".

	* src/NetworkManagerPolicy.c (auto_activate_device): Move the check of whether
	the device is activating here to fix a race condition.

	* src/ppp-manager/nm-pppd-plugin.c (get_credentials): Implement.

	* src/ppp-manager/nm-ppp-manager.c (impl_ppp_manager_need_secrets): Implement.
	(ppp_watch_cb): Emit a signal to notify pppd is not running anymore.
	(nm_ppp_manager_start): Take activation request instead of connection, we might
	need it for asking secrets.
	(nm_ppp_manager_update_secrets): Implement.

	* src/nm-serial-device.c (real_act_stage2_config): Send activation request to
	ppp manager start. It might be needed for asking secrets.

	* src/nm-device-802-3-ethernet.c (real_connection_secrets_updated): Implement.
	(ppp_state_changed): Handle pppd daemon disappearing.
	(pppoe_stage2_config): Send activation request to ppp manager start.

	* libnm-util/nm-setting-pppoe.c (nm_setting_pppoe_class_init): Fix a typo.

	* introspection/nm-ppp-manager.xml: Make NeedSecrets method async, return only
	username and password.
	
2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (handle_dhcp_lease_change): apply an IP4 config to a device in
			response to a DHCP lease change
		- (dhcp_state_changed): handle DHCP lease changes while activated
		- (nm_device_set_ip4_config): remove a previously set named config
			when setting an ip4 config

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (nm_serial_device_send_command): report errno on error
		- (get_reply_got_data): limit the size of the overall buffer
		- (wait_for_reply_info_destroy): destroy result string
		- (wait_for_reply_got_data): append received data to an overall buffer
			until timeout, filled buffer, or error instead of keeping a per-call
			buffer.  Some devices send data slowly enough that this function
			gets called multiple times for the same command stream.
		- (nm_serial_device_wait_for_reply): initialize overall buffer for
			wait_for_reply_got_data() here

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-cdma-device.c
		- (do_dial, init_modem): handle errors from
			nm_serial_device_send_command_string()

	* src/nm-gsm-device.c
		- (do_dial, manual_registration, automatic_registration_get_network,
		   automatic_registration, enter_pin, check_pin, init_modem): handle
			errors from nm_serial_device_send_command_string()

2008-03-10  Dan Williams  <dcbw@redhat.com>

	Patch based on ideas suggested by Bas Zoetekouw <bas@debian.org>

	* src/named-manager/nm-named-manager.c
		- (compute_searches): prefer searches before domains
		- (compute_domain): new function
		- (rewrite_resolv_conf): write out the 'domain' and 'searches' options
		- (merge_one_ip4_config): if there are no searches in the source config,
			merge domains of the source config into the target config
		- (compute_nameservers): make formatting of resolv.conf a bit nicer

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (get_reply_got_data): clean up indentation, shrink serial buffer
		- (wait_for_reply_got_data): try to handle slower serial devices where
			the reply is broken up into multiple reads by concatenating replies
			together until either an error is received or the search string is
			found

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (nm_device_bring_down): deactivate the device if it's activating too,
			not just if it's already activated.  This makes sure that everything
			from an association attempt is cleaned up (like DHCP for example)

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (config_fd): report error from TCSETA
		- (nm_serial_device_open): fail when config_fd() fails

2008-03-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-ip4-config.c
		- (nm_ip4_config_init): allocate searches list
		- (finalize): free searches list

2008-03-09  Dan Williams  <dcbw@redhat.com>

	Patch from Bas Zoetekouw <bas@debian.org>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): handle domain-search option too

2008-03-09  Dan Williams  <dcbw@redhat.com>

	Patch from Bas Zoetekouw <bas@debian.org>

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- (nm_ip4_config_add_search, nm_ip4_config_get_search,
		   nm_ip4_config_get_num_searches): add 'searches' as distinct from
			domains.  'searches' is the correct way to store multiple search
			domains, whereas 'domains' is really just supposed to store one
			domain.  Some sites abuse the DHCP 'domain-name' option to push
			search domains to the client.
		- (nm_ip4_config_add_domain): group with related functions (my patch)

2008-03-09  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (dhclient_run): send interface-specific config files to dhclient

2008-03-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (is_wireless_device): new function; test a device for wireless
			extensions
		- (parser_parse_file): if the ifcfg file doesn't have a TYPE tag,
			test the device for wireless extensions to determine the type

2008-03-07  Dan Williams  <dcbw@redhat.com>

	Change manager's StateChange signal to StateChanged for consistency.

	* introspection/nm-manager.xml
		- Add 'StateChanged' signal
		- Move 'StateChange' down to the deprecated section

	* src/nm-hal-manager.c
		- (nm_hal_manager_new): connect to 'state-changed' instead

	* src/NetworkManagerPolicy.c
		- (nm_policy_new): connect to 'state-changed' instead

	* src/nm-manager.c
	  src/nm-manager.h
		- (nm_manager_update_state): emit both 'state-changed' and 'state-change'
		- (nm_manager_class_init): add 'state-changed' and not the deprecation
			of 'state-change'

	* libnm-glib/nm-client.c
	  libnm-glib/nm-client.h
		- (constructor, nm_client_class_init, client_state_changed_proxy):
			track and proxy 'state-changed' instead of 'state-change'

2008-03-07  Dan Williams  <dcbw@redhat.com>

	First pass of multiple active device support.  Expect bugs.

	* src/nm-ip4-config.c
	  src/nm-ip4-config.h
		- (nm_ip4_config_get_secondary, nm_ip4_config_set_secondary): remove;
			there are better ways to do this in the named manager

	* src/nm-device.c
	  src/nm-device.h
		- (nm_device_can_activate): return whether the device can activate a
			connection right now; taking into account things like carrier state
			and rfkill state
		- (nm_device_get_best_auto_connection): renamed from
			nm_device_get_best_connection
		- (real_act_stage4_get_ip4_config): MTU stuff is now handled in the
			device subclasses themselves, so that each device can override the
			MTU from it's NMSetting subclass if needed
		- (nm_device_set_ip4_config): set MTU when setting up routes and stuff
			in NetworkManagerSystem.c, not here

	* src/named-manager/nm-named-manager.c
	  src/named-manager/nm-named-manager.h
		- (nm_named_manager_name_owner_changed,
		   nm_named_manager_dbus_connection_changed): fix for changes to
			rewrite_resolv_conf()
		- (compute_nameservers): don't need the NMNamedManager at all, remove
			from parameter list
		- (merge_one_ip4_config): new function; merge ip4 configs together
		- (rewrite_resolv_conf): write out resolv.conf from all the stored
			ip4 configs; the VPN config takes precedence, then the best
			device config, then the rest of the configs
		- (get_domain_for_config): take the NMNamedManager as an argument
			to check whether the config is the VPN config
		- (add_ip4_config_to_named): fixups for removal of the 'secondary'
			attribute from ip4 configs
		- (add_all_ip4_configs_to_named): add all the configs in priority order
		- (remove_ip4_config_from_named): fix for changes to
			get_domain_for_config()
		- (nm_named_manager_add_ip4_config): assign the config to the right slot
			based on its type; callers must pass in the type now
		- (get_last_default_domain): remove, unused
		- (nm_named_manager_remove_ip4_config): handle config slots correctly

	* src/nm-device-802-11-wireless.c
		- (real_can_activate): new function
		- (real_get_best_auto_connection): renamed from real_get_best_connection
		- (real_act_stage4_get_ip4_config): handle MTU override

	* src/nm-device-802-3-ethernet.c
		- (real_can_activate): new function
		- (real_get_best_auto_connection): renamed from real_get_best_connection
		- (real_act_stage4_get_ip4_config): new function; handle MTU override

	* src/vpn-manager/nm-vpn-connection.c
		- (nm_vpn_connection_ip4_config_get): don't need to set the 'secondary'
			attribute on the ip4 config

	* src/NetworkManagerPolicy.c
		- (nm_policy_auto_get_best_device): remove
		- (nm_policy_device_change_check): remove
		- (update_default_route): new function; set the default route via
			the specified device
		- (get_device_priority): new function; return the priority number of
			a device type WRT which one should have the default route.  Order is
			(highest to lowest)  wired, wireless, GSM, CDMA.
		- (update_routing_and_dns): new function; determine which device should
			have the default route, then update the routing table and DNS
		- (maybe_auto_activate_device): new function; if a device is now
			available for activation, find out what connection it would like to
			activate and do it
		- (schedule_activate_check): new function; if a device can be activated
			now, schedule the activation.  Each device may have only one
			pending activation at a given time.
		- (device_state_changed): if activation was canceled, try again,
			possibly with another connection; if the device was activated,
			update routing and DNS; if the device was deactivated, try again
			with another connection
		- (device_carrier_changed): if there is no carrier, deactivate the
			device; otherwise schedule an activation check for the device
		- (wireless_networks_changed): schedule an activation check for the
			device
		- (device_added): keep track of the signal handler IDs so they can
			be removed when the device goes away
		- (device_removed): remove any signal handlers that might be attached
			to the device; update routing and DNS
		- (schedule_activate_all): new function
		- (connections_added, connection_added, connection_updated): when
			connections change, schedule all devices for an activation check
		- (connection_removed): when a device is deactivated because its
			connection was removed, schedule another activation check for it
		- (nm_policy_destroy): destroy pending activations and disconnect
			all device signal handlers

	* src/nm-manager.c
		- (nm_manager_activate_device): if the device was already actived,
			deactivate it
		- (deactivate_old_device): remove
		- (connection_added_default_handler, impl_manager_activate_device):
			don't deactivate other devices when activating this one

	* src/backends/NetworkManagerGentoo.c
	  src/backends/NetworkManagerFrugalware.c
	  src/backends/NetworkManagerPaldo.c
	  src/backends/NetworkManagerRedHat.c
	  src/backends/NetworkManagerSlackware.c
	  src/backends/NetworkManagerArch.c
	  src/backends/NetworkManagerSuSE.c
	  src/backends/NetworkManagerDebian.c
		- (nm_system_get_mtu): remove; MTU should be provided through the
			distro's system settings service plugin instead
		- (nm_system_device_add_default_route_via_device): remove
		- (nm_system_device_add_default_route_via_device_with_iface): remove
		- (nm_system_device_replace_default_route): new function; call
			generic implementation

	* src/backends/NetworkManagerGeneric.c
	  src/backends/NetworkManagerGeneric.h
		- (nm_generic_device_add_default_route_via_device,
		   nm_generic_device_add_default_route_via_device_with_iface): remove
		- (nm_generic_device_replace_default_route): replace the default route
			with the given route via some gateway

	* src/NetworkManagerSystem.c
	  src/NetworkManagerSystem.h
		- (nm_system_device_set_from_ip4_config): let the policy handle updates
			to routing and DNS; but set the MTU here
		- (nm_system_vpn_device_set_from_ip4_config): set the route with the
			ip_iface of the active device; use the standard MTU setting function
		- (nm_system_set_mtu): remove
		- (nm_system_device_set_mtu): consolidate MTU setting code in one place

2008-03-07  Tambet Ingo  <tambet@gmail.com>

	Rework the interaction between ppp manager and pppd plugin. Register a well
	known DBUS service in manager and let the plugin call it's methods instead
	of listening plugin's signals.

	* src/ppp-manager/nm-pppd-plugin.c: Call ppp-manager dbus methods instead
	of emitting signals.

	* src/ppp-manager/nm-ppp-manager.c: Implement dbus service here.

	* src/ppp-manager/Makefile.am: Build nm-ppp-manager-glue.h.

	* src/nm-serial-device.c (real_act_stage2_config): Pass NMConnection to
	nm_ppp_manager_start().

	* introspection/nm-ppp-manager.xml: New file.

	* src/nm-device-802-3-ethernet.c (nm_device_802_3_ethernet_get_speed): Handle
	the case correctly where driver is trying to send -1 for the speed, which gets
	casted to u16 and thus is always > 0.

2008-03-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- (nm_get_device_driver_name): use net.originating_device first, fall
			back to physical device.  HAL has deprecated physical_device.

	* libnm-glib/nm-device.c
		- (get_product_and_vendor): use net.originating_device first, fall
			back to physical device.  HAL has deprecated physical_device.
		- (nm_device_update_description): s/physical_device_udi/orig_dev_udi

2008-03-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-netlink.c
		- (nm_netlink_get_default_handle): mistakenly removed too much code in
			last commit; fix that
		- (get_link_cache): print error string

2008-03-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-netlink.c
		- (nm_netlink_get_default_handle): NMNetlinkMonitor now uses libnl,
			don't need this hack any more (Benoit Boissinot)

2008-03-06  Dan Williams  <dcbw@redhat.com>

	* autogen.sh
		- Die gnome-common, die

2008-03-04  Dan Williams  <dcbw@redhat.com>

	Patch from Michael Biebl <biebl@debian.org>

	* NetworkManager.pc.in
		- doesn't actually depend on dbus-1

	* libnm-util/nm-utils.h
		- remove unused #include <dbus/dbus.h>

	* libnm-glib/libnm_glib.pc.in
		- depends on glib and dbus-glib

2008-03-02  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- s/device_state_changed_idle_id/update_state_id/

2008-03-02  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
	  src/nm-device.h
	  src/nm-device-802-11-wireless.c
	  src/nm-device-802-3-ethernet.c
	  src/NetworkManagerPolicy.c
		- s/link_active/carrier
		- nm_device_set_active_link() -> nm_device_set_carrier()
		- nm_device_has_active_link() -> nm_device_get_carrier()

2008-03-02  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (make_wireless_setting): fail connection creation on missing SSID

2008-02-29  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (nm_policy_device_change_check): ensure that a previously active
			device with a system connection has a link before denying a switch
			to a user connection

2008-02-29  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (link_timeout_cb): try again if scanning; deactivate the device when
			activated if the link dies
		- (supplicant_iface_connection_state_cb_handler): bump link timeout to
			15 seconds

2008-02-29  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
	  src/nm-device-802-11-wireless.h
		- (nm_device_802_11_wireless_reset_scan_interval): remove, unused
			elsewhere; fold into the sole user in nm-device-802-11-wireless.c
		- (device_cleanup): reset the scan interval lower when the device
			deactivates
		- (can_scan): base decision mostly off device state, not supplicant
			interface state since the supplicant interface state isn't a
			great indicator of whether the device is active or not
		- (request_wireless_scan): clean up; schedule the next scan here
		- (schedule_scan): only back the scan interval off if a new scan
			actually gets scheduled; and make scan intervals tighter when the
			device is disconnected
		- (supplicant_iface_state_cb_handler): fold in the bits of
			nm_device_802_11_wireless_reset_scan_interval() by resetting scan
			interval to minimum
		- (activation_success_handler): reset scan interval to something
			reasonable 

2008-02-28  Saleem Abdulrasool  <compnerd@compnerd.org>

	reviewed by: Steev <steev@steev.net>

	* configure.in:
	* src/backends/NetworkManagerGentoo.c:
	(nm_system_restart_mdns_responder):
		Howl is no longer a supported mDNS provider

2008-02-28  Tambet Ingo  <tambet@gmail.com>

	Get rid of a bunch of unused distro specific functions.

2008-02-28  Tambet Ingo  <tambet@gmail.com>

	Implement suse plugin for system settings daemon.

	* system-settings/plugins/ifcfg-suse/*: Implement.

	* system-settings/plugins/Makefile.am: Add ifcfg-suse to subdirs when targeting
	suse.

	* configure.in: Check (without failing) for gio.
	Create ifcfg-suse plugin's Makefile.

2008-02-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.c
	  libnm-util/nm-connection.h
		- (nm_connection_compare): accept compare flags and pass them to the
			setting compare function

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
		- (nm_setting_compare): accept compare flags; ignore properties that are
			marked fuzzy

	* libnm-util/nm-setting-connection.c
	  libnm-util/nm-setting-wireless.c
	  libnm-util/nm-setting-ppp.c
	  libnm-util/nm-setting-wired.c
		- Mark some setting properties as ignorable when doing a fuzzy compare

	* src/nm-device.c
		- (device_activation_precheck): use exact compare

2008-02-20  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (nm_policy_device_change_check): get scope off the connection, not
			using the manager helper

	* src/nm-manager.c
	  src/nm-manager.h
		- (get_scope_for_proxy): rename from get_type_for_proxy()
		- (connection_get_settings_cb): set scope and path on connection, not
			using GObject data items
		- (get_connection_for_proxy): don't need to return path, since that
			can be gotten from the connection
		- (get_connection_for_proxy): get path off the connection, not from
			parameters
		- (connection_removed_cb, connection_updated_cb): don't need to get
			path from get_connection_for_proxy(); get scope off the connection
			instead of using GObject data items
		- (connection_added_default_handler, add_one_connection_element): use
			nm_connection_get_path() not nm_manager_get_connection_dbus_path()
		- (nm_manager_get_connection_dbus_path): remove
		- (nm_manager_get_connection_scope): remove

2008-02-20  Dan Williams  <dcbw@redhat.com>

	* Global rename of NMConnectionSettings -> NMExportedConnection to cut down
		on confusing names

	* Add 'path' and 'scope' properties to NMConnection since both NM and the
		applet were having to hack this in anyway.  Remove the 'path' stuff from
		NMExportedConnection

	* Internally rename NMConnectionType -> NMConnectionScope

	* Provide default implementations of the 'get_id' and 'get_settings' methods
		of NMExportedConnection

2008-02-15  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (device_cleanup): release the AP list here too so that the AP list
			doesn't survive across suspend/resume and up/down.  There is some
			room for optimization, for example blow the list away when the card
			brought back up, but only if the device has only been down for a
			minute or more.

2008-02-15  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- (modem_device_creator): recognize new HAL modem capabilities

2008-02-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (watch_path): handle IN_DELETE_SELF too
		- (handle_connection_changed): notify when removing a connection
		- (stuff_changed): don't warn on unknown inotify watches; handle the
			case of a file moving out of the profile directory

2008-02-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (make_ip4_setting): bring IPv4 setting handling more up to spec

2008-02-12  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
		- (nm_utils_convert_uint_array_to_string): don't die on NULL array, it's
			just any empty array

2008-02-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/nm-system-config-interface.c
	  system-settings/src/nm-system-config-interface.h
		- (load_connections): get_connections() should now return an allocated
			GSList that the system settings service will free

	* system-settings/plugins/ifcfg-fedora/plugin.c
	  system-settings/plugins/ifcfg-fedora/parser.h
	  system-settings/plugins/ifcfg-fedora/parser.c
		- Fix up inotify issues; handle keys-* files, handle new files appearing
			in the profile directory, handle resolv.conf file changes

2008-02-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-3-ethernet.c
		- (real_bring_up): save the supplicant interface state signal id
		- (real_bring_down): disconnect from the supplicant interface state
			signal

2008-02-07  Dan Williams  <dcbw@redhat.com>

	* initscript/RedHat/NetworkManager.in
	  initscript/RedHat/NetworkManagerDispatcher.in
		- Add new-style LSB init headers

2008-02-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
		- (add_one_secret_to_hash): copy secrets out of the plugin-returned hash
			table of secrets
		- (connection_settings_get_secrets): consolidate error returns into
			one place; use the new get_secrets() plugin interface function to
			get secrets from the plugin itself rather than using GObject data
			magic

	* system-settings/src/main.c
		- (connection_added_cb, connection_removed_cb, free_plugin_connections,
		   load_connections): keep a private list of the plugin-returned
			connections, don't use the plugin's GSList

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- (watch_path): watch the path, not the filename (duh)
		- (reload_all_connections): use the direct hash/equal functions; the
			ones for int aren't appropriate here
		- (get_secrets, system_config_interface_init): implement the
			get_secrets() function
		- (build_one_connection, find_connection_by_path): ifcfg file path is
			now in the connection's ConnectionData instead of being a GObject
			data property
		- (handle_profile_item_changed): ifcfg file path is now in the
			connection's ConnectionData instead of being a GObject data property;
			be sure to copy secrets over from the new connection to the existing
			connection when updating the connection's settings
		- (init): sc_plugin_inotify_init() returns success/fail, not the inotify
			file descriptor

	* system-settings/plugins/ifcfg-fedora/parser.c
	  system-settings/plugins/ifcfg-fedora/parser.h
		- (connection_data_get, copy_one_cdata_secret, clear_one_cdata_secret,
		   connection_data_copy_secrets, connection_data_free,
		   connection_data_add): new functions; connection data manipulation
		- (make_wireless_security_setting): stuff secrets into the
			connection data, not as GObject data items; make sure to close
			the keys ifcfg file
		- (wireless_connection_from_ifcfg, wired_connection_from_ifcfg): add
			connection data to the connection

2008-02-07  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/nm-system-config-interface.c
	  system-settings/src/nm-system-config-interface.h
		- Add a get_secrets() interface function to retrieve secrets for a
			specific setting of a specific connection.  Document the interface
			a bit more too.

2008-02-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (handle_auth_or_fail): new function; consolidate device activation
			failure check after a certain number of failures getting secrets
		- (supplicant_connection_timeout_cb, real_act_stage2_config,
		   real_act_stage4_ip_config_timeout): use handle_auth_or_fail() to fail
			the connection if secrets were requested more than a few times
		- (real_act_stage3_ip_config_start): don't clear the wireless secrets
			tries here; otherwise they are cleared before the IP configure
			timeout, which happens with open system WEP when key is wrong
		- (activation_success_handler): clear wireless secrets tries here too

2008-02-07  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (connection_updated): clear invalid tag when connection gets updated
			to allow that connection to be tried again
		- (nm_policy_new): save signal ids so they can be disconnected when
			the policy is destroyed
		- (nm_policy_destroy): stop any in-progress state change idle handler,
			and disconnect all signals from the manager object so that none
			of the policy functions gets called after the policy is destroyed

2008-02-06  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (finalize): remove devices a bit earlier; clean up system settings
			poke
		- (nm_manager_name_owner_changed): clean up system settings poke when
			the service appears, and try to restart it if it fails
		- (poke_system_settings_daemon_cb): try to get the system settings
			service started through D-Bus service activation
		- (initial_get_connections): start the system settings daemon if it's
			not already running

2008-02-05  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless): send scan_ssid=1 for
			broadcast networks too

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (make_wireless_security_setting): fix spelling; unencrypted networks
			need key_mgmt set too
		- (parser_parse_file): validate ifcfg file name and don't try to parse
			.bak files; ensure that an error is set whenever NULL gets returned

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/Makefile.am
		- Install D-Bus service activation file for the system settings
			service

	* system-settings/src/org.freedesktop.NetworkManagerSystemSettings.service
		- D-Bus service activation file for system settings service

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/main.c
		- (parse_config_file): parse a config file
		- (main): accept --config option and read plugins from config file

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- Change reported name to 'ifcfg-fedora'
		- Use IFCFG_PLUGIN_NAME

	* system-settings/plugins/ifcfg-fedora/plugin.c
		- Remove PLUGIN_NAME, use IFCFG_PLUGIN_NAME instead

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg-fedora/parser.c
		- (get_ifcfg_name): new function; factor out ifcfg name finding code
		- (make_connection_setting): use get_ifcfg_name()
		- (make_wireless_security_setting): handle shadow key files
		- (get_one_wep_key): treat empty string as NULL

2008-02-04  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-manager.c
		- (poke_supplicant_cb): reschedule the poke as a timeout, don't let
			glib automatically reschedule
		- (nm_supplicant_manager_init): immediately try to start the supplicant
		- (nm_supplicant_manager_name_owner_changed): immediately try to restart
			the supplicant

2008-02-01  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (device_state_changed): schedule a change check when a device gets
			deactivated so something happens if you disconnect GSM/CDMA

2008-01-31  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.h
	  src/nm-device-802-11-wireless.c
		- (ap_list_get_ap_by_ssid, is_associated,
		   nm_device_802_11_wireless_ap_list_get_ap_by_ssid,
		   nm_device_802_11_wireless_ap_list_get_ap_by_obj_path): remove
		- (nm_device_802_11_wireless_get_activation_ap): collapse
			nm_device_802_11_wireless_ap_list_get_ap_by_obj_path() into this
			function

2008-01-30  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg
	* system-settings/plugins/ifcfg-fedora
		- Move the ifcfg plugin to ifcfg-fedora

2008-01-24  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.c
		- (get_access_point): move the "/" check here; check for invalid path
			too
		- (nm_device_802_11_wireless_set_active_ap): leave the "/" check up
			to get_access_point()
		- (access_point_added_proxy, access_point_removed_proxy): don't try
			to send signals for non-existent access points

2008-01-24  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_set_active_ap): path of "/" means no AP

2008-01-23  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/libnm_glib.c
		- (libnm_glib_init): make thread joinable
		- (libnm_glib_ctx_free): join thread on exit to clean up memory

2008-01-23  Dan Williams  <dcbw@redhat.com>

	* test/libnm_glib_test.c
		- (signal_handler, setup_signals): trap SIGINT and SIGTERM
		- (main): set up signal handlers; call libnm_glib_shutdown

2008-01-21  Dan Williams  <dcbw@redhat.com>

	* include/NetworkManager.h
		- Add CDMA mobile broadband card device type

	* src/nm-hal-manager.c
		- (modem_device_creator): handle both CDMA and GSM modems; the device
			must now be tagged with 'cdma' or 'gsm' capability

	* src/nm-cdma-device.c
	  src/nm-cdma-device.h
	  src/Makefile.am
		- Add the CDMA mobile broadband card device class

	* libnm-util/nm-connection.c
		- (register_default_settings): add NMSettingCdma

	* libnm-util/nm-setting-cdma.c
	  libnm-util/nm-setting-cdma.h
	  libnm-util/Makefile.am
		- Add the CDMA mobile broadband card setting class

	* libnm-glib/nm-cdma-device.c
	  libnm-glib/nm-cdma-device.h
	  libnm-glib/Makefile.am
		- Add the CDMA mobile broadband card GLib proxy class

	* libnm-glib/nm-client.c
		- (get_device): handle CDMA devices too

2008-01-21  Dan Williams  <dcbw@redhat.com>

	* src/ppp-manager/nm-ppp-manager.c
		- (ip4_config_get): set peer address too

	* src/ppp-manager/nm-pppd-plugin.c
		- (nm_ip_up): try harder to get the peer's address

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_from_ip4_config): if the IP4Config has a peer
			address, use that too.  Otherwise, some PPP connections won't work.

2008-01-19  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (nm_policy_device_change_check): system connections override user
			connections; don't activate a user connection if there's a currently
			active system connection, and new, better system connections always
			interrupt user connections

2008-01-19  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.h
		- (nm_manager_get_connection_type): new function

2008-01-19  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_get_best_connection): collapse find_best_connection() into this
			function

2008-01-19  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-3-ethernet.c
		- (real_get_best_connection): collapse find_best_connection() into this
			function

2008-01-18  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-3-ethernet.c
		- (find_best_connection): check MAC address too
		- (real_get_best_connection): let autoconnect=True connections activate
			for devices that don't have carrier detection

	* src/nm-device-802-11-wireless.c
		- (find_best_connection): check MAC address too

2008-01-18  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg/parser.c
		- (make_connection_setting): interpret ON_BOOT=y as 'autoconnect=True'

2008-01-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-3-ethernet.c
		- (nm_device_802_3_ethernet_carrier_on,
		   nm_device_802_3_ethernet_carrier_off): ignore any spurious netlink
			carrier events that might come in for devices that don't support
			carrier detect

2008-01-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.c
		- (nm_device_interface_check_connection_conflicts): need to actually
			get the interface, not cast to the object

	* src/nm-device.c
		- (nm_device_check_connection_conflicts): need to get the device class,
			not cast the device to the device class

2008-01-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_check_connection_conflicts): ignore connections that aren't
			wireless connections

2008-01-17  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerPolicy.c
		- (nm_policy_device_change_check): clear change check idle here
		- (device_change_check_done): remove
		- (schedule_change_check): simplify

2008-01-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (check_connection_allowed): take an NMDeviceInterface instead of
			an NMDevice object as an argument
		- (nm_manager_activate_device): pass an NMDeviceInterface to
			check_connection_allowed()

2008-01-13  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_get_access_points): fix memory leak

2008-01-12  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (activation_success_handler): if a match was found in the scan list
			and that match is a hidden AP, update that AP's SSID

2008-01-11  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
		- (nm_ap_new_fake_from_connection): mark fake APs as fake

	* src/nm-device-802-11-wireless.c
		- (get_active_ap): do two passes over the scan list if the caller
			requests that hidden APs get matched too; during the second pass
			when matching hidden APs, ignore the SSID since hidden APs in the
			scan list don't have an SSID yet
		- (periodic_update): move some checks to
			nm_device_802_11_periodic_update() because not all callers need them
		- (nm_device_802_11_periodic_update): move some checks here from
			perodic_update()
		- (merge_scanned_ap): if the current AP is fake, then don't do strict
			matching on incoming scan results, because the fake AP's flags
			might be slightly different (yet still compatible) with the incoming
			scan result's flags and they might actually be the same AP; update
			the rate on merged APs too
		- (activation_success_handler): update the frequency of the fake AP
			on successful connection; match hidden APs too since if the
			current AP is fake, there might already be a scan result in the
			scan list for the desired AP, just without it's SSID filled in yet

2008-01-10  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
		- (foreach_property_cb): catch more hidden SSID formats

2008-01-10  Dan Williams  <dcbw@redhat.com>

	Fix gnome.org #464215.  Requires the kernel patch titled
	"Introduce WEXT scan capabilities" but will handle the patch not being
	present, you'll just continue to have problems with hidden SSIDs when
	using mac80211-based drivers.

	* src/supplicant-manager/nm-supplicant-config.h
	  src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless): new parameter to indicate
			whether the driver supports SSID scans or not.  If it does, and if
			the AP is hidden, use ap_scan=1 instead of ap_scan=2

	* src/nm-device-802-11-wireless.c
		- (constructor): check whether or not the driver supports SSID scans
		- (build_supplicant_config): pass driver SSID scan capability when
			building the wireless bits of the supplicant config

2008-01-09  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
	  src/nm-device.h
		- (device_activation_precheck, check_connection_complete): remove this
			virtual function; incomplete connections should be invalid by
			definition, complete-ness should be checked in the setting's
			verify function

	* src/nm-serial-device.c
	  src/nm-gsm-device.c
		- (real_check_connection_complete): remove

	* libnm-util/nm-setting-serial.c
		- (verify): new function; ensure there is a PPP setting too

	* libnm-util/nm-setting-gsm.c
		- (verify): ensure there is a serial setting too

2008-01-06  Dan Williams  <dcbw@redhat.com>

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): handle DHCP-provided MTU
			(gnome.org #332953)

2008-01-04  Dan Williams  <dcbw@redhat.com>

	* src/named-manager/nm-named-manager.c
		- (rewrite_resolv_conf, add_ip4_config_to_named): use primary IP4Config's
			nameservers if the secondary config doesn't have any
			(gnome.org #346833)

2008-01-02  Tambet Ingo  <tambet@gmail.com>

	* libnm-util/nm-setting-serial.c (nm_setting_serial_class_init): Mark the properties
	with G_PARAM_CONSTRUCT so that they get the default values.

	* src/nm-gsm-device.c: Add preliminary support for monitoring device. It only monitors
	the monitoring device and prints out the output for now. Or more precicely, doesn't
	do absolutely anything right now since the montoring device argument is never set.

	* src/nm-serial-device.c (serial_debug): Implement. It's very verbose and thus
	requires it's own knob to turn it on.
	(config_fd): Add NMSettingSerial to the arguments list.
	(nm_serial_device_open): Ditto.
	(get_reply_got_data): Ignore the terminators at the beginning of the output.
	(nm_serial_device_get_io_channel): Implement.

	* src/nm-manager.c: Add NMDBusManager to the private data of the NMManager. Asking
	a new reference every time (and forgetting to release it sometimes) is a pain and
	it's not like NMManager could work without dbus.
	(nm_manager_add_device): Register the added device on dbus here.

	* src/nm-hal-manager.c (modem_device_creator): Pass NULL for now for the monitoring
	device.

	* src/nm-device.c (constructor): Don't export the device here, instead export
	it when it's added to the NMManager's device list.

2007-12-31  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.c
	  src/nm-device-interface.h
		- (nm_device_interface_check_connection_conflicts): new function

	* src/nm-device.c
	  src/nm-device.h
		- (nm_device_check_connection_conflicts): new function
		- (device_activation_precheck): don't require subclasses to implement
			check_connection_complete()
		- check_connection() -> check_connection_complete()

	* src/nm-device-802-11-wireless.c
		- (real_check_connection): remove; unused
		- (real_check_connection_conflicts): implement, handle lockdown for
			system connections

	* src/nm-device-802-3-ethernet.c
		- (real_check_connection): remove; unused

	* src/nm-manager.c
		- (check_connection_allowed): new function
		- (nm_manager_activate_device): ensure the connection being requested
			is allowed to be activated

	* src/nm-serial-device.c
	  src/nm-gsm-device.c
		- real_check_connection() -> real_check_connection_complete()

2007-12-27  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-interface.c
	  src/nm-device-interface.h
		- (nm_device_interface_error_quark, nm_device_interface_error_get_type):
			normalize and expand errors
		- (nm_device_interface_init): register errors so they can be marshalled
			through dbus-glib
		- (nm_device_interface_activate): ensure that failure of activation
			returns an error

	* src/nm-device.c
	  src/nm-device.h
		- (device_activation_precheck): implementations of check_connection()
			now take a GError and must fill it in if the check fails.  Return
			more descriptive error if the requested connection is already
			activating
		- (nm_device_activate): actually try to return descriptive errors on
			failures

	* src/nm-device-802-11-wireless.c
	  src/nm-device-802-3-ethernet.c
	  src/nm-serial-device.c
	  src/nm-gsm-device.c
		- (real_check_connection): return more descriptive errors on failure

	* src/NetworkManagerPolicy.c
		- (nm_policy_device_change_check): print activation errors in the logs

	* src/nm-manager.c
		- (nm_manager_error_quark, nm_manager_error_get_type,
		   nm_manager_class_init): new errors
		- (nm_manager_activate_device): handle errors
		- (nm_manager_error_new): removed
		- (wait_for_connection_expired, connection_added_default_handler,
		   impl_manager_activate_device): better error handling

2007-12-27  Dan Williams  <dcbw@redhat.com>

	Fixes gnome.org #466954

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Allow 'frequency' network property

	* src/supplicant-manager/nm-supplicant-config.c
	  src/supplicant-manager/nm-supplicant-config.h
		- (nm_supplicant_config_add_setting_wireless): add 'adhoc_freq' argument
			for callers to specify the frequency an Ad-Hoc network should operate
			on.  Some drivers require this to successfully create an Ad-Hoc
			network.

	* src/nm-device-802-11-wireless.c
		- (iw_freq_to_uint32): new function; convert a struct iw_freq into a
			guint32 value in MHz
		- (constructor, nm_device_802_11_wireless_get_frequency): use
			iw_freq_to_uint32()
		- (find_supported_frequency): new function; find a free supported
			frequency for a user-created Ad-Hoc network
		- (build_supplicant_config): if no frequency was specified for a user-
			created Ad-Hoc network, find a free one to use
		- (real_act_stage1_prepare): mark Ad-Hoc connections that don't have
			a specific object as user-created

2007-12-27  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- (nm_utils_security_valid): add 'adhoc' argument and handle security
			for adhoc networks

2007-12-24  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless.c
		- (verify): add 802.11a channels 7, 8, 9, 11, 12, 16, 34, 165, 183, 184,
			185, 187, 188, 192, and 196

2007-12-24  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_get_frequency): handle drivers that return
			a channel # instead of a frequency

2007-12-24  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
	  src/NetworkManagerAP.h
		- (nm_ap_new_fake_from_connection): pass band to channel_to_freq()
		- (freq_to_channel): handle split band tables
		- (channel_to_freq): handle split band tables, take a band argument

2007-12-24  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-connection.h
	  libnm-util/nm-setting-connection.c
		- Add 'lockdown' member

2007-12-22  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless.c
		- (nm_setting_wireless_class_init): add missing 'rate' property
			specification

2007-12-18  Dan Williams  <dcbw@redhat.com>

	Base the NMNetlinkMonitor class on libnl instead of hand-rolled netlink.

	* src/nm-netlink-monitor.c
	  src/nm-netlink-monitor.h
		- Remove handrolled netlink, use libnl instead

	* src/nm-device-802-3-ethernet.c
		- (constructor, nm_device_802_3_ethernet_carrier_off,
		   nm_device_802_3_ethernet_carrier_on): use new names

2007-12-17  Dan Williams  <dcbw@redhat.com>

	* configure.in
		- Bump requirement for libnl to 1.0-pre8 (which works with newer kernels
			and fixes memory leaks)

	* src/nm-netlink.c
		- (nm_netlink_get_default_handle): handle new versions of libnl that
			automatically handle the netlink PID

2007-12-17  Dan Williams  <dcbw@redhat.com>

	Patch from Michael Biebl <biebl@debian.org>

	* configure.in
	  src/ppp-manager/Makefile.am
		- fix up install dir of pppd plugin
		- clean up configure.in a bit

2007-12-12  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/nm-system-settings.conf
		- Allow non-root clients (like the applet) to read settings

2007-12-10  Tambet Ingo  <tambet@gmail.com>

	* Replace all occurences of 'UMTS' with 'GSM'.

2007-12-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-serial-device.c
		- (real_is_up): serial devices are always "up"

2007-12-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-netlink.c
	  src/NetworkManagerSystem.c
		- (new_nl_handle): ensure that the same netlink pid is never chosen
			twice (gnome.org #491047)
		- Make more robust against allocation-related failures should they occur

2007-12-07  Dan Williams  <dcbw@redhat.com>

	Noticed by Christian Persch <chpe@gnome.org>

	Always chain up to parent object in dispose and finalize handlers.
		(gnome.org #433112)

2007-12-07  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- Wrap #include of linux/mii.h to fix redefined structures due to
			incorrect kernel headers (gnome.org #350061)

2007-12-06  Tambet Ingo  <tambet@gmail.com>

	* src/nm-umts-device.c (real_act_stage1_prepare): Flash the modem (drop DTR)
	before doing anything else.
	(init_modem): Move modem initialization here.

	* src/nm-serial-device.c (ppp_state_changed): React on pppd state changes.
	(nm_serial_device_flash): Implement.

	* src/ppp-manager/nm-ppp-manager.c (name_owner_changed): Fix the typoes: the state
	changes signal is "StateChanged" and not "Status".
	(ppp_exit_code, ppp_status_changed): Remove the debug output, it's working fine now.

2007-12-06  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): reorganize a bit
			to only send some options when they make sense; also send phase2
			option to the supplicant (possible fix for rh #399631)

2007-12-06  Tambet Ingo  <tambet@gmail.com>

	* src/NetworkManagerSystem.c (nm_system_device_set_from_ip4_config): Change the
	arguments: This whole file shouldn't really know anything about NMDevices, it
	should deal only with device interfaces. Devices might have different ifaces for
	different stuff and this place shouldn't know anything about it.

	* src/NetworkManagerPolicy.c: Get rid of leftover global variable global_policy.
	(global_state_changed): Implement. In the current NM it's not really important,
	but will be required in the case of multiple active devices. (Or even better,
	if stuff like that gets moved out from NM).

	* src/vpn-manager/nm-vpn-connection.c (connection_state_changed): Don't call
	nm_system_device_set_from_ip4_config() directly, use nm_device_set_ip4_config() 
	instead.

	* src/nm-device.c: Add a ip_face protected member. It's used for 'multi-interface'
	devices like serial devices (ttyS0 and ppp0 for example).
	(nm_device_get_ip_iface): Implement. Default to the device iface if ip_iface is not
	set.
	(nm_device_set_ip_iface): Implement.
	(nm_device_activate_stage5_ip_config_commit): Move all the extra actions that happen
	after setting ip4_config from here ...
	(nm_device_set_ip4_config): ... to here. The reason behind it is that no other code
	than this function should call nm_system_device_set_from_ip4_config() because no
	other code has enough information on which arguments to use. So instead, other code
	could just set the new ip4 config using this function and everyone is happy.

	* src/nm-umts-device.c: Store the pending ids so that we can remove pending actions
	if we happen to get deactivated while something is pending.
	(automatic_registration): Handle the response that indicates pending network
	registration and wait until the pending registration is done.
	(real_deactivate_quickly): If there's a pending operation, cancel it.

	* src/nm-serial-device.c (ppp_ip4_config): Set the ip_iface when the iface is up ...
	(real_deactivate_quickly): ... and remove it when it's down.
	(nm_serial_device_get_reply): Return the timeout id so that the callers can remove
	it if needed.
	(nm_serial_device_wait_for_reply): Ditto.

2007-12-05  Tambet Ingo  <tambet@gmail.com>

	* src/nm-umts-device.c (dial_done): Fix the typoes in warnings.
	(get_network_done): Remove newline, nm_info() does it already.
	(real_act_stage1_prepare): Turn the modem echo off.

	* src/NetworkManagerSystem.c (nm_system_device_set_from_ip4_config): In case of serial
	device, set the route to the device interface. This is a hack.

	* src/nm-serial-device.c (nm_serial_device_send_command_string): Only append carriage 
	return, no need for a new-line.
	(ppp_ip4_config): Store the ip4 config to be set in the next stage.
	Change the device iface here (ugh).
	(real_act_stage4_get_ip4_config): Implement.
	(real_deactivate_quickly): Free the pending ip4 config if it's still pending.
	Restore the device iface.

	* src/NetworkManagerPolicy.c (nm_policy_device_change_check): Do nothing if the active
	device is not wired or wireless (eg, automatically upped) device.

	* src/ppp-manager/nm-ppp-manager.c (ip4_config_get): Don't make the config secondary,
	it isn't.
	(nm_ppp_manager_start): Don't let pppd to set the default route, we want to do it.

	* src/nm-hal-manager.c (get_creator): Make sure the device has required capability
	before calling it's is_device_fn().

2007-12-05  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
		- (nm_utils_register_value_transformations,
		   nm_utils_convert_gvalue_hash_to_string): better debug output of
			GHashTables of GValues too

2007-12-04  Dan Williams  <dcbw@redhat.com>

	* initscript/RedHat/NetworkManager.in
		- No longer start named; it's D-Bus interface is going away

2007-12-04  Dan Williams  <dcbw@redhat.com>

	Patch from Michael Biebl <biebl@debian.org>

	* system-settings/plugins/ifcfg/Makefile.am
	  system-settings/src/main.c
	  system-settings/src/Makefile.am
		- Put system settings plugins in NM plugins dir

	* src/ppp-manager/Makefile.am
	  src/ppp-manager/nm-ppp-manager.c
		- Move pppd plugin to NM plugins dir

2007-12-04  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-vpn-properties.h
		- Clarify usage of the 'data' member of the setting

	* libnm-util/nm-setting-vpn-properties.c
		- (nm_setting_vpn_properties_init): initialize the 'data' hash table
		- (set_property): just remove all the settings; don't recreate the has
		- (update_one_secret): don't need to create the hash table here since
			it should always be present

2007-12-03  Tambet Ingo  <tambet@gmail.com>

	Implement PIN and PUK requesting.

	* src/nm-umts-device.c (enter_pin_done): Request the secret again if it failed.
	(enter_pin): Handle PIN and PUK requests.
	(real_act_stage1_prepare): Clear the secret type.
	(real_connection_secrets_updated): Implement this class method to get
	notified when new secrets arrive.
	(nm_umts_device_class_init): Add private data back to the umts device class
	to store the required secret type.

2007-12-01  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg/parser.c
		- (parser_parse_file): don't try to verify NULL connections

2007-12-01  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/main.c
		- (load_connections, add_connection_to_settings): actually export
			plugin-provided connections over D-Bus so NM can get them

2007-12-01  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg/parser.c
	  system-settings/plugins/ifcfg/parser.h
	  system-settings/plugins/ifcfg/plugin.c
		- Hook up more inotify bits (untested)

2007-11-29  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/nm-system-config-interface.h
	  system-settings/src/nm-system-config-interface.c
		- (nm_system_config_interface_init,
		   nm_system_config_interface_get_connections): add

	* system-settings/src/main.c
		- (load_plugins, load_connections, main): use a GSList for plugins
			to ensure priority ordering

	* system-settings/plugins/ifcfg/parser.c
		- (ifcfg_error_quark): move to plugin.c, and rename

	* system-settings/plugins/ifcfg/plugin.h
	  system-settings/plugins/ifcfg/plugin.c
		- (ifcfg_plugin_error_quark): move here from parser.c
		- rework connection loading and initialization
		- Add preliminary inotify support for network profile config file

2007-11-28  Tambet Ingo  <tambet@gmail.com>

	Merge the beginnings of the new GSM card support.

	* src/ppp-manager/nm-ppp-manager.c (nm_ppp_manager_stop): Remove the
	ppp watch source before killing pppd - If this happens from g_object_unref()
	then the ppp manager is already destroyed by the time the watch callback runs.

	* src/nm-hal-manager.c: Add a device_type_name string to the device
	creators, so that we can print a nice human readable string when a
	device is added.

	* src/nm-umts-device.c (automatic_registration_get_network): Query
	for the activated network, not much is done with the result thought.

	* src/nm-serial-device.c (nm_serial_device_get_reply): Implement.
	(ppp_ip4_config): Change the device state to activated here for now.
	(real_check_connection): Make sure the connection includes ppp setting.

	* libnm-glib/nm-client.c (get_device): Handle umts devices.

	* libnm-glib/Makefile.am: Add the new files to build.

	* libnm-glib/nm-umts-device.c: 
	* libnm-glib/nm-umts-device.h: Implement.

2007-11-26  Tambet Ingo  <tambet@gmail.com>

	* src/nm-umts-device.c (automatic_registration_get_network): For now, dial
	immediately, nm_serial_device_get_reply() isn't implemented correctly yet.

	* src/nm-serial-device.c (wait_for_reply_info_destroy): Don't try to remove
	the timeout source - this function is only called when the timeout source has
	been removed.
	(nm_serial_device_wait_for_reply): Allocate the duplicate responses array
	to be big enough to contain the terminating zero element as well.
	The timeout argument is meant to be in seconds now.
	(real_deactivate_quickly): Implement.

	* src/NetworkManager.conf: Allow root to own 
	"org.freedesktop.NetworkManager.PPP", deny it for everybody else.

	* libnm-util/nm-setting-umts.c: Network type and band properties are ints,
	(not unsigned ints).

	* libnm-util/nm-setting-serial.c (nm_setting_serial_class_init): Fix a 
	small issue with parity bounds - capital letters have lower ascii codes
	than lower case letters.

	* libnm-util/nm-connection.c (register_default_settings): Register serial
	and umts settings.

2007-11-22  Tambet Ingo  <tambet@gmail.com>

	Remove the "index" property from devices as not all device types have this.

	* include/NetworkManager.h (NM_DBUS_PATH_DEVICE): Remove.

	* src/nm-hal-manager.c (nm_get_device_index_from_hal): Remove.
	(wired_device_creator): Get the device interface from hal to create the device.
	(wireless_device_creator): Ditto.

	* src/nm-device.c (nm_device_init): Remove the index member.
	(constructor): Remove the checks for index property, make interface property
	a require constructor property.
	Use the HAL udi for DBus path for devices.
	(nm_device_get_index): Remove.
	(set_property): Remove index handling.
	(get_property): Ditto.
	(nm_device_get_dbus_path): Remove.

	* src/nm-device-interface.c (nm_device_interface_init): Remove the index
	property.

	* src/nm-device-802-3-ethernet.c (nm_device_802_3_ethernet_link_activated):
	Access the device index through it's interface.
	(nm_device_802_3_ethernet_link_deactivated): Ditto.
	(nm_device_802_3_ethernet_new): Remove the useless argument test_dev. Remove
	index argument. Add interface argument.

	* src/nm-device-802-11-wireless.c (nm_device_802_11_wireless_new): Remove
	the useless test_dev argument. Remove index argument. Add interface arugment.

	* src/NetworkManagerSystem.c (nm_system_device_set_from_ip4_config): Get the
	device index through interface.
	(nm_system_set_mtu): Ditto.

	* introspection/nm-device.xml: Remove the "Index" property.

2007-11-21  Tambet Ingo  <tambet@gmail.com>

	* src/nm-serial-device.c: 
	* src/nm-serial-device.c: 
	* src/nm-umts-device.c:
	* src/nm-umts-device.h: Implement.

	* src/nm-hal-manager.c (nm_get_device_driver_name): libhal_free_string the string 
	allocated by libhal.
	(modem_device_creator): Implement.
	(register_built_in_creators): Register the modem creator.

	* src/nm-device-802-11-wireless.c (nm_device_802_11_wireless_new): 
	Remove the unused test_dev argument.

	* src/nm-device-802-3-ethernet.c (nm_device_802_3_ethernet_new): Ditto.

	* src/Makefile.am: Add new files to build.
	Link in ppp-manager.

	* libnm-util/nm-setting-umts.c: 
	* libnm-util/nm-setting-umts.h: 
	* libnm-util/nm-setting-serial.c: 
	* libnm-util/nm-setting-serial.h: Implement.

	* libnm-util/Makefile.am: Add new files to build.

2007-11-28  Dan Williams  <dcbw@redhat.com>

	Patch from Zdeněk Jurka <zdenek.jurka@jware.cz>

	Support DHCP-provided static routes.

	* src/nm-ip4-config.h
	  src/nm-ip4-config.c
		- Add get/set functions for static routes

	* src/dhcp-manager/nm-dhcp-manager.c
		- (nm_dhcp_manager_get_ip4_config): extract static routes from the
			DHCP response

	* src/NetworkManagerSystem.c
		- (nm_system_device_set_from_ip4_config): set any static routes on the
			interface when applying the IP4Config

2007-11-28  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_act_stage1_prepare): mark APs created for hidden networks
			as non-broadcasting

2007-11-27  Dan Williams  <dcbw@redhat.com>

	* system-settings/src/nm-system-config-interface.h
		- Note how to store secrets on NMSetting objects

	* system-settings/src/dbus-settings.c
		- (connection_settings_get_secrets): implement

2007-11-27  Dan Williams  <dcbw@redhat.com>

	* system-settings/plugins/ifcfg/Makefile.am
	  system-settings/plugins/ifcfg/parser.c
	  system-settings/plugins/ifcfg/parser.h
	  system-settings/plugins/ifcfg/plugin.c
		- Parse wireless connections too

	* system-settings/src/dbus-settings.c
	  system-settings/src/dbus-settings.h
	  system-settings/src/main.c
		- Handle connection update/removal if the plugin supports it

2007-11-27  Dan Williams  <dcbw@redhat.com>

	* src/nm-dbus-manager.h
	  src/nm-hal-manager.c
		- Include the correct headers now that NetworkManagerDbusUtils.h doesn't
			do it for them

	* src/Makefile.am
	  src/NetworkManagerDbusUtils.c
	  src/NetworkManagerDbusUtils.h
		- Remove these two source files; they are unused

2007-11-27  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-manager.c
		- (impl_vpn_manager_connect): fix system settings check (found by
			James M. Leddy)

2007-11-26  Dan Williams  <dcbw@redhat.com>

	* Fix warnings so everything compiles with --enable-more-warnings

2007-11-25  Dan Williams  <dcbw@redhat.com>

	* system-settings/*
		- Rework structure and code to use GModule-loaded plugins and a plugin
			interface that plugins export to the system settings service

2007-11-21  Dan Williams  <dcbw@redhat.com>

	* system-settings/*
		- Add Soren's system settings service.  Needs work for distros other
			than Fedora; the backends from NM should mostly migrate to here
			and be converted to GObjects

2007-11-21  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-vpn-properties.c
		- (set_property): must deep-copy the given settings hash, otherwise
			double-free errors occur when the setting is disposed of

2007-11-21  Dan Williams  <dcbw@redhat.com>

	* src/vpn-manager/nm-vpn-act-request.h
	  src/vpn-manager/nm-vpn-act-request.c
		- Remove; unused

2007-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
		- (nm_utils_convert_strv_to_string, nm_utils_convert_uint_array_to_string,
		   nm_utils_convert_ip4_addr_struct_array_to_string,
		   nm_utils_register_value_transformations): print out the readable
			values of more types of properties of NMSettings subclasses

2007-11-20  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-ip4-config.c
		- (ip4_addresses_from_gvalue, ip4_addresses_to_gvalue,
		   nm_setting_ip4_config_class_init): apparently dbus-glib can't
			marshal GValueArrays inside collections, so switch to types that it
			can actually marshal/demarshal

2007-11-16  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless-security.c
		- (verify_tls, verify_ttls, verify_identity, verify_nai): do some
			minimal verification of EAP methods too
		- (verify): verify phase1 eap methods too

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.h
	  libnm-glib/nm-device.c
		- (nm_device_get_product, nm_device_get_vendor): should be returning
			const char *

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.c
		- (get_product_and_vendor): don't try to free things that should be
			freed

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerUtils.c
		- (nm_ethernet_address_is_valid): unbreak previous fix

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): handle PEAP
			options

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerUtils.c
		- (nm_ethernet_address_is_valid): fix style, clarify
		- (nm_ethernet_addresses_are_equal): don't try to memcmp NULLs

	* src/nm-device-802-11-wireless.c
		- (get_active_ap): handle failure from nm_device_802_11_wireless_get_bssid()
		- (nm_device_802_11_wireless_get_ssid,
		   nm_device_802_11_wireless_get_bssid,
		   nm_device_802_11_wireless_get_bitrate): zero the wreq structure
		   	before calling the ioctl; fixes valgrind-reported jump depends on
			uninitialized value errors

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (nm_setting_to_hash, one_property_cb): revert previous commit, it's
			unecessary to serialize 'name'

	* src/nm-activation-request.c
		- (get_secrets_cb): fix cases where a full NMSetting is returned from
			the GetSecrets call

2007-11-15  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-connection.h
	  libnm-util/nm-setting-connection.c
		- Rename the 'name' property to 'id', because it conflicted with the
			NMSetting superclass' 'name' property.

	* libnm-util/nm-setting.c
		- (nm_setting_to_hash): serialize the 'name' property
		- (one_property_cb): ignore 'name' on deserialization of a connection

	* src/nm-device-802-11-wireless.c
	  src/vpn-manager/nm-vpn-connection.c
	  src/NetworkManagerPolicy.c
		- Fix up for NMSettingConnection 'name'->'id' changes

2007-11-13  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device-802-11-wireless.h
	  libnm-glib/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_get_hw_address): return should be const

	* test/nm-tool.c
	  libnm-glib/libnm-glib-test.c
		- Fixes for above change

2007-11-12  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Allow fragment_size option

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- (nm_supplicant_config_add_setting_wireless_security): use a lower
			EAP fragment size than the default to help some TLS connections

2007-11-12  Dan Williams  <dcbw@redhat.com>

	Make certs actually work.  The private key is now a secret, and should be
	decrypted when requested by NM.  The private key and phase2 private key
	passwords are no longer interesting to NM because they should be used by
	the settings service to decrypt the private key itself before passing it
	to NM, and hence have been removed as fields.

	* libnm-util/nm-setting-wireless-security.h
	  libnm-util/nm-setting-wireless-security.c
		- Remove private-key-passwd and phase2-private-key-passwd from
			properties
		- (need_secrets_password, need_secrets_eappsk, need_secrets_sim,
		   need_secrets): use property #defines instead strings to keep things
			consistent
		- (need_secrets_tls): if a client certificate is present but no
			private key, request the private key
		- (set_property, get_property, nm_setting_wireless_security_class_init):
			remove private key password stuff, mark private keys as secret

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- Remove private_key_passwd and private_key2_passwd from opt_table

2007-11-09  Dan Williams  <dcbw@redhat.com>

	Fix vpn-properties setting update_secrets call for new NMSetting stuff.
	Since the vpn-properties are managed and known by the VPN daemons themselves,
	libnm-util doesn't know what's secret and what's in the setting's 'data'
	member.

	* libnm-util/nm-setting.h
	  libnm-util/nm-setting.c
		- Add the ability for subclasses to override update_one_secret

	* libnm-util/nm-setting-vpn-properties.c
		- Override update_one_secret and just copy the values into the
			internal table

2007-11-09  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-settings.h
	  libnm-glib/nm-settings.c
		- (nm_settings_new_error): remove
		- (nm_settings_error_quark): add; instead of nm_settings_new_error,
			clients should use g_set_error() with NM_SETTINGS_ERROR

2007-11-09  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): private key
			passwords are never sent to wpa_supplicant, because the supplicant
			should never be reading random files from the disk.  Clients like
			the applet are required to decrypt the private keys and send NM
			the decrypted blobs.

2007-11-08  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting-wireless-security.h
	  libnm-util/nm-setting-wireless-security.c
		- Add 'private-key-decrypted' and 'phase2-private-key-decrypted'
			members to 802-11-wireless-security structure.  This should be used
			to indicate that the values in private-key and phase2-private-key
			are already decrypted by the user agent, and that no
			private-key-passwd or phase2-private-key-passwd should be expected.
			It is not meant to be a stored configuration value, but meant to
			be set when the conneciton is sent to NM over dbus.

2007-11-08  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.h
	  libnm-util/nm-connection.c
		- (nm_connection_need_secrets): add argument to return hints

	* src/nm-device-802-11-wireless.c
		- (link_timeout_cb, supplicant_connection_timeout_cb,
		   real_act_stage2_config, real_act_stage4_ip_config_timeout): handle
			nm_connection_need_secrets() change

2007-11-07  Tambet Ingo  <tambet@gmail.com>

	Rework NMSetting structures: Move each setting to it's own file.
	Convert to GObject. Remove home grown setting types and use GTypes.
	Use GObject property introspection for hash conversion, enumerating
	properties, etc.

	* libnm-util/nm-setting-connection.[ch]
	* libnm-util/nm-setting-ip4-config.[ch]
	* libnm-util/nm-setting-ppp.[ch]
	* libnm-util/nm-setting-vpn.[ch]
	* libnm-util/nm-setting-vpn-properties.[ch]
	* libnm-util/nm-setting-wired.[ch]
	* libnm-util/nm-setting-wireless.[ch]
	* libnm-util/nm-setting-wireless-security.[ch]

	New files, each containing a setting.

	* libnm-util/nm-setting-template.[ch]: A template for creating new
	settings. To use it, just replace 'template' with the new setting
	name, and you're half-way done.

	* libnm-util/nm-setting.c: Convert to GObject and use GObject
	introspection instead of internal types and tables.

	* libnm-util/nm-connection.c: Adapt the new NMSetting work.

	* libnm-util/nm-param-spec-specialized.[ch]: Implement. Handles
	GValue types defined by dbus-glib for composed types like collections,
	structures and maps.

	* src/*: The API of NMSetting and NMConnection changed a bit: Getting
	a setting from connection takes the setting type now. Also, since
	the settings are in multiple files, include relevant settings.

2007-10-31  Saleem Abdulrasool <compnerd@compnerd.org>

	* configure.in:
	* src/backends/NetworkManagerGentoo.c:
	(nm_system_restart_mdns_responder): Implement restarts for other mdns
	providers in Gentoo.

2007-10-31  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-connection.c
		- (gvalue_to_string): handle UINT32 arrays

2007-10-31  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-device.h
	  libnm-glib/nm-device.c
		- (nm_device_get_description): remove
		- (nm_device_get_product, nm_device_get_vendor): add
		- (nm_device_update_description): new function (private); walk HAL
			devices to get product and vendor IDs for a specific device

2007-10-31  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (nm_device_802_11_wireless_get_mode): ignore ENODEV errors

2007-10-29  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- (device_added, device_new_capability): ignore device additions while
			asleep.  Fixes crash caused when NM goes to sleep, a network device
			kernel module is unloaded and reloaded and recognized by NM again.

2007-10-26  Dan Williams  <dcbw@redhat.com>

	Patch from Helmut Schaa <hschaa@suse.de> (and more bits from me)

	* src/NetworkManagerAP.c
	  src/NetworkManagerAP.h
	  libnm-glib/nm-access-point.c
	  libnm-glib/nm-access-point.h
		- Make 'rate' property a guint32 to better match with WEXT and
			wpa_supplicant and to allow representation of higher bitrates

	* src/nm-device-802-11-wireless.c
	  introspection/nm-device-802-11-wireless.xml
	  libnm-glib/nm-device-802-11-wireless.c
	  libnm-glib/nm-device-802-11-wireless.h
		- Make 'bitrate' property a guint32 to match AP 'rate' property type

	* src/nm-device-802-3-ethernet.c
	  src/nm-device-802-3-ethernet.h
	  introspection/nm-device-802-3-ethernet.xml
	  libnm-glib/nm-device-802-3-ethernet.c
	  libnm-glib/nm-device-802-3-ethernet.h
		- Make 'speed' property a guint32 to match other speed/rate types
		- Make nm_device_802_3_ethernet_get_speed() static

	* test/nm-tool.c
		- Update for the changes above

2007-10-26  Dan Williams  <dcbw@redhat.com>

	* src/named-manager/nm-named-manager.c
		- (rewrite_resolv_conf): clean up error handling to avoid double-free by
		    not calling fclose() twice on some error conditions

2007-10-26  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.c
		- (dispose): clean up indentation; get the right DBusGProxy object to
			cancel the GetSecrets pending call on.  Need to use the Secrets
			proxy, not the regular connection proxy.  Otherwise the GetSecrets
			pending call doesn't get canceled, and pressing Cancel in the
			applet's password dialog could cause get_secrets_cb() to be called
			after the activation request has already been destroyed

2007-10-24  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_blob): pass blob data and length for
			verification
		- (get_hash_cb): use GByteArrays rather than GArrays; easier to follow

2007-10-24  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- (opt_table): max length for certificates should be 65536

2007-10-24  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-interface.c
		- (blob_free): correctly free blob data after use
		- (call_set_blobs): use the right D-Bus interfaace for setBlobs

2007-10-24  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_need_secrets): Fix lookup table logic for
			EAP method need secrets

2007-10-24  Dan Williams  <dcbw@redhat.com>

	* src/backends/NetworkManagerRedHat.c
		- (nm_system_update_dns): be a lot smarter about telling nscd to restart

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.c
		- (nm_setting_compare): implement
		- (default_setting_compare_fn, do_one_compare, compare_gvalue_hash,
		   compare_one_hash_gvalue): compare the contents of a setting

	* libnm-util/nm-connection.c
		- (nm_connection_compare): implement

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.c
		- (get_secrets_cb): handle getting a setting back that is more than
			just secrets (ie, user changed auth or EAP method or something)

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
		- (nm_setting_verify): new function; verify one setting
		- (nm_settings_verify_all): rename from nm_settings_verify()
		- (setting_connection_verify, setting_wireless_verify): allow NULL
			all_settings

	* libnm-util/nm-connection.c
		- (nm_connection_replace_settings, nm_connection_verify,
		   nm_connection_new_from_hash): handle nm_settings_verify() rename

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_act_stage2_config): use pre-increment on 'tries' to get the
			desired behavior

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-settings-verify.c
		- eap_allowed, phase2_allowed: harmonize with allowed values from
			nm-settings.c

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (real_act_stage2_config): after the first association failure,
			if the connection still needs secrets ask the user for them
			explicitly.  After the fourth association failure due to bad
			secrets, fail the connection entirely.  Handles the GetSecrets
			loop that NM gets into when the provided secrets don't match up
			with the connection details.

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): only add
			WPA-specific options when WPA is in use

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): 'password'
			secret doesn't need to be unhexified

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_need_secrets): ensure auth_alg is !NULL
			before trying to do something with it

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (merge_scanned_ap): handle NULL ssids returned from nm_ap_get_ssid()

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (merge_scanned_ap): use libnm-util empty SSID check to catch more
			non-SSID-broadcasting APs

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
		- (match_cipher, security_compatible): remove
		- (nm_ap_check_compatible): use nm_utils_ap_security_compatible() from
			libnm-util instead

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.c
	  libnm-util/nm-utils.h
		- (nm_utils_ap_security_compatible): common function for checking
			whether a specific AP is compatible with an NMConnection

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_need_secrets, need_secrets_phase2,
		   need_secrets_tls, need_secrets_sim, need_secrets_eappsk,
		   need_secrets_password, setting_wireless_security_verify): fix
			need_secrets for IEEE 802.1x and WPA-EAP by implementing need
			secrets logic for each supported EAP method

2007-10-23  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_add_setting_wireless_security): fix wpa_supplicant
			config option name, should be "private_key2_passwd"

2007-10-22  Tambet Ingo  <tambet@gmail.com>

	Implement support for static IP addresses, additional/overridden DNS and
	DNS domain search lists.

	* libnm-util/nm-setting.c (uint_array_to_gvalue): Implement.
	(ip4_addresses_to_gvalue): Implement.
	(convert_array_to_byte_array): Implement.
	(nm_setting_populate_from_hash_default): Handle NM_S_TYPE_UINT_ARRAY and
	NM_S_TYPE_IP4_ADDRESSES.
	(nm_setting_hash): Ditto.
	(default_setting_clear_secrets): Add a default case for the switch: IP address
	shouldn't be secret, ever.
	(setting_ip4_config_verify): Update, requires addresses in case of manual
	configurations.
	(setting_ip4_config_destroy): Free stuff.

	* src/nm-device.c (merge_ip4_config): Implement.
	(real_act_stage4_get_ip4_config): Merge IP4 configuration from NMConnection.

2007-10-22  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_verify): allow WEP-40 and WEP-104 as
			pairwise cipher options for Dynamic WEP

2007-10-21  Dan Williams  <dcbw@redhat.com>

	* src/NetworkManagerAP.c
	  src/NetworkManagerAP.h
		- Rename 'articifical' -> 'fake' since that's what they are until
			noticed in scans
		- (nm_ap_new_fake_from_connection): new function to create a 'fake' AP
			from the attributes in an NMConnection object
		- (security_compatible): better handle Dynamic WEP and LEAP; handle
			WPA Enterprise
		- (nm_ap_match_in_list): find a matching AP in a scan list

	* src/nm-device-802-11-wireless.c
		- (get_active_ap): add an 'ignore_ap' argument to ignore a specific
			AP when searching the scan list; match on frequency and mode too
		- (nm_device_802_11_wireless_get_frequency): implement
		- (merge_scanned_ap): replace duplicate matching logic with
			nm_ap_match_in_list()
		- (real_act_stage1_prepare): handle a NULL specific object; ie where
			the user is trying to connect to a hidden network that is not yet
			known from the scan list
		- (activation_success_handler): now that the card knows the AP's BSSID,
			there may already be a scanned AP in the scan list that is what
			we really wanted to connect to, but didn't know at the time.  Use
			that instead of the 'fake' AP created at activation start and get
			rid of the 'fake' AP 
		- (cull_scan_list): don't remove fake APs

2007-10-21  Dan Williams  <dcbw@redhat.com>

	* src/nm-activation-request.h
	  src/nm-activation-request.c
		- (nm_act_request_set_specific_object): new function; allow setting the
			specific object if one isn't set yet

2007-10-20  Dan Williams  <dcbw@redhat.com>

	* src/supplicant-manager/nm-supplicant-config.h
	  src/supplicant-manager/nm-supplicant-config.c
		- (nm_supplicant_config_init, nm_supplicant_config_finalize): add a hash
			table to store blobs
		- (nm_supplicant_config_add_blob): new function; add blob to internal
			blob hash table
		- (nm_supplicant_config_get_blobs): new function; get stored blobs
		- (nm_supplicant_config_add_setting_wireless_security): handle
			options that use certificates (ie, blobs)

	* src/nm-device-802-11-wireless.c
		- (build_supplicant_config): pass a UID (just use the connection path)
			to the supplicant config as now required

	* src/supplicant-manager/nm-supplicant-interface.c
		- (add_network_cb, call_set_blobs, set_blobs_cb, call_set_network): if
			there are any blobs to send to wpa_supplicant, send those first
			before sending the network configuration

2007-10-19  Dan Williams  <dcbw@redhat.com>

	Split the GetSecrets() call off to a separate D-Bus interface so that it
	can be more easily locked down with D-Bus policy.  Only 'root' (ie, NM)
	should be able to call GetSecrets().

	* include/NetworkManager.h
		- Define the connection secrets D-Bus interface

	* src/vpn-manager/nm-vpn-connection.c
		- (clear_need_auth): get the right proxy object for the connection
			secrets interface
		- (get_connection_secrets): use the connection secrets proxy; send
			empty hints in get secrets request

	* src/nm-activation-request.c
		- (nm_act_request_request_connection_secrets): use the connection
			secrets proxy; send empty hints in get secrets request

	* src/nm-manager.c
	  src/nm-manager.h
		- (connection_get_settings_cb): set the connection secrets proxy on
			the connection object too
		- (internal_new_connection_cb): create the connection secrets proxy

	* introspection/nm-settings-connection.xml
		- Define Connection.Secrets interface and move GetSecrets there
		- Add a 'hints' argument to GetSecrets

	* libnm-glib/nm-settings.c
	  libnm-glib/nm-settings.h
		- (impl_connection_settings_get_secrets): add 'hints' argument

2007-10-19  Dan Williams  <dcbw@redhat.com>

	* src/nm-device.c
		- (constructor): add message about what path a device is exported as
			to help in debugging rh #339011

2007-10-17  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-utils.h
	  libnm-util/nm-utils.c
		- (nm_utils_security_valid): common function to help find the intersection
			of capabilities of devices and (optionally) access points

2007-10-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (get_wireless_capabilities): add missing braces so that WPA capabilities
			don't get erroneously cleared

2007-10-17  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.h
	  src/nm-manager.c
	  src/nm-hal-manager.c
		- (device_removed, finalize, nm_manager_remove_device,
		   nm_manager_sleep): add a 'deactivate' argument to 
		   nm_manager_remove_device() to fully deactivate devices when necessary
		   (ie, always except when waking up)

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_verify): fix phase2_auth methods; 'sim'
			also isn't valid phase2 autheap method

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
		- (update_wireless_status): consolidate updates of wireless status
		- (constructor): use update_wireless_status()
		- (manager_running): set wireless status off when NM goes away; requery
			the wireless status when NM comes back

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* libnm-glib/nm-client.c
		- (nm_client_activate_device): actually use the fixed-up specific
			object path

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* src/nm-hal-manager.c
		- (killswitch_getpower_reply, nm_hal_manager_destroy): only print out
			killswitch error messages once

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (manager_set_wireless_enabled): don't allow wireless to be enabled
			if it's disabled in hardware; don't touch network devices while
			NM is asleep

2007-10-16  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-client.c
		- (nm_client_activate_device): convert NULL specific_object to "/",
			which is used in place of NULL

	* src/nm-manager.c
		- (impl_manager_activate_device): convert "/" specific_object back into
			NULL

2007-10-16  Tambet Ingo  <tambet@gmail.com>

	Implement a generic NMSetting creator from setting name.
	While at it, get rid of all nm_setting_foo_new_from_hash() functions and
	add a virtual function 'populate_fn'.

	* libnm-util/nm-connection.c (nm_connection_create_setting): Implement.
	(register_default_creators): Register setting creators instead of functions
	that create and then populate.
	(parse_one_setting): Use the common setting creator and then setting specific
	poplulation function.

	* libnm-util/nm-setting.c: Get rid of nm_setting_foo_new_from_hash() functions,
	they all looked exactly the same.
	Add a 'populate_fn' virtual function to NMSetting.
	Use default virtual functions in case they are not overriden.
	(nm_setting_populate_from_hash): Implement.

	* src/nm-device.c (real_act_stage3_ip_config_start): Don't hard code the setting
	name, use a defined string.
	(real_act_stage4_get_ip4_config): Ditto.

2007-10-16  Tambet Ingo  <tambet@gmail.com>

	* src/nm-hal-manager.c (killswitch_getpower_reply): The type returned from
	HAL is int, not uint.

2007-10-15  Tambet Ingo  <tambet@gmail.com>

	Implement killswitch polling through HAL.

	* src/nm-manager.c: Add wireless hardware status property. Add 
	'properties-changed' signal for changes in wireless and wireless hardware
	state changes.

	* src/nm-hal-manager.c: Poll hal for killswitch statuses in every 6 seconds
	and update NMManager's wireless hardware state when it has changed.
	(nm_hal_manager_new): Don't try to add initial devices here - (hal_init)
	already does that.

	* libnm-glib/nm-client.c: Add wireless hardware status property. Cache the
	values of wireless state and wireless hardware state. Listen for the
	'properties-changed' signals, update the cached values and emit notify.

	* include/NetworkManager.h: Fix a typo in a comment.

2007-10-14  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
		- (setting_wireless_security_need_secrets): handle LEAP secrets

2007-10-13  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.h
	  libnm-util/nm-setting.c
	  src/supplicant-manager/nm-supplicant-config.c
		- Make the 'proto' field of the 802-11-wireless-security field a
			string list

2007-10-12  Tambet Ingo  <tambet@gmail.com>

	Rework the "properties-changed" signal listening implementation.
	Add a generic implementation to NMObject class that listens for
	the signal and calls property setters of the target NMObject.

	* libnm-glib/nm-object.c (nm_object_handle_properties_changed): Implement.

	* libnm-glib/nm-device-802-11-wireless.c: Move the GObject consturction
	code to the end of file so that all the static functions are available
	without extra declarations.
	Remove the "properties-changed" signal handling and use the framework from
	NMObject.
	Implement property setters for properties that change with 
	"properties-changed" signal.

	* libnm-glib/nm-access-point.c: Ditto.

2007-10-12  Tambet Ingo  <tambet@gmail.com>

	Rework the "properties-changed" signal implementation.
	In classes that need to use it, just emit "GObject::notify" and the new
	framework takes care of the rest to make the signal available on dbus.
	The framework queues the notifications and tries to send as many together
	in one signal as possible.

	* src/nm-properties-changed-signal.c:
	* src/nm-properties-changed-signal.h: Implement.

	* src/Makefile.am: Add new files to build.

	* src/NetworkManagerAP.c: Use the general framework for properties-changed
	signal.

	* src/nm-device-802-11-wireless.c: Ditto.

2007-10-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-manager.c
		- (wait_for_connection_expired): ensure info is valid
		- (connection_added_default_handler): Should only remove pending
			connection info when the manager has the connection that it's
			waiting for.  Fixes segfault in wait_for_connection_info().  

2007-10-10  Dan Williams  <dcbw@redhat.com>

	* libnm-util/nm-setting.c
	  libnm-util/nm-setting.h
		- Add a default 'user_name' field to the VPN setting, which VPN plugins
			can use if they choose.  Should be filled in by the settings service
			on-the-fly with the currently logged in user's username

2007-10-10  Dan Williams  <dcbw@redhat.com>

	* src/nm-device-802-11-wireless.c
		- (merge_scanned_ap): make sure non-SSID-broadcasting APs are marked
			as such, because even if the manager fills in the SSID, NM still
